"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var StorageRequestEnsureToken = /*#__PURE__*/function () {
  function StorageRequestEnsureToken() {
    var op = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, StorageRequestEnsureToken);

    _defineProperty(this, "TOKEN_KEY", 'fetch-service-storage-token');

    _defineProperty(this, "TOKEN_KEY_TIMESTAMP", 'fetch-service-storage-token-timestamp');

    _defineProperty(this, "TIME_OVER_TIME", 1 * 60 * 60 * 1000);

    _defineProperty(this, "_initToking", false);

    _defineProperty(this, "_userSessionStorage", false);

    _defineProperty(this, "_initTokenPromise", []);

    _defineProperty(this, "_customGetToken", function () {
      return Promise.resolve();
    });

    if (!op.customGetToken) {
      throw 'need customGetToken function return Promise';
    }

    if (op.tokenKey) {
      this.TOKEN_KEY = op.tokenKey;
    }

    if (op.tokenTimestampKey) {
      this.TOKEN_KEY_TIMESTAMP = op.tokenTimestampKey;
    }

    if (op.timeout) {
      this.TIME_OVER_TIME = op.timeout;
    }

    if (op.session) {
      this._userSessionStorage = true;
    }

    this._customGetToken = op.customGetToken;
  }

  _createClass(StorageRequestEnsureToken, [{
    key: "setStorage",
    value: function setStorage(key, value) {
      if (this._userSessionStorage) {
        sessionStorage.setItem(key, value);
      } else {
        localStorage.setItem(key, value);
      }
    }
  }, {
    key: "getStorage",
    value: function getStorage(key) {
      if (this._userSessionStorage) {
        return sessionStorage.getItem(key);
      } else {
        return localStorage.getItem(key);
      }
    }
  }, {
    key: "removeStorage",
    value: function removeStorage(key) {
      if (this._userSessionStorage) {
        sessionStorage.removeItem(key);
      } else {
        localStorage.removeItem(key);
      }
    }
  }, {
    key: "__setToken",
    value: function __setToken(token) {
      if (token) {
        this.setStorage(this.TOKEN_KEY, token);
        this.setStorage(this.TOKEN_KEY_TIMESTAMP, "".concat(Date.now()));
      }

      return token;
    }
  }, {
    key: "clearToken",
    value: function clearToken() {
      this.removeStorage(this.TOKEN_KEY);
      this.removeStorage(this.TOKEN_KEY_TIMESTAMP);
    }
  }, {
    key: "__invokeTokingPromise",
    value: function __invokeTokingPromise(err, info) {
      var _iterator = _createForOfIteratorHelper(this._initTokenPromise),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var p = _step.value;

          if (err) {
            p.reject(err);
          } else {
            p.resolve(info);
          }
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      this._initTokenPromise = [];
      this._initToking = false;
    }
  }, {
    key: "getStorageToken",
    value: function getStorageToken() {
      var token = this.getStorage(this.TOKEN_KEY);
      var timestamp = this.getStorage(this.TOKEN_KEY_TIMESTAMP);
      if (!token) return null;
      if (!timestamp) return null;
      var time = Date.now() - timestamp;

      if (time >= 0 && time <= this.TIME_OVER_TIME) {
        return token;
      }

      return null;
    }
  }, {
    key: "getToken",
    value: function getToken() {
      var _this = this;

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      var token = this.getStorageToken();
      return new Promise(function (resolve, reject) {
        if (token) {
          resolve(token);
        } else {
          if (_this._initToking) {
            _this._initTokenPromise.push({
              resolve: resolve,
              reject: reject
            });

            return;
          }

          _this._initToking = true;

          _this._customGetToken.apply(_this, args).then(function (newToken) {
            _this.__setToken(newToken);

            resolve(newToken);

            _this.__invokeTokingPromise(null, newToken);
          })["catch"](function (err) {
            reject(err);

            _this.__invokeTokingPromise(err);
          });
        }
      });
    }
  }]);

  return StorageRequestEnsureToken;
}();

exports["default"] = StorageRequestEnsureToken;