(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('crypto')) :
  typeof define === 'function' && define.amd ? define(['exports', 'crypto'], factory) :
  (global = global || self, factory(global.fetchServiceParser = {}, global.crypto));
}(this, (function (exports, crypto) { 'use strict';

  crypto = crypto && Object.prototype.hasOwnProperty.call(crypto, 'default') ? crypto['default'] : crypto;

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);

    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);

      if (enumerableOnly) {
        symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });
      }

      keys.push.apply(keys, symbols);
    }

    return keys;
  }

  function _objectSpread2(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};

      if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }

    return target;
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";

    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function (obj) {
        return typeof obj;
      };
    } else {
      _typeof = function (obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }

    return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }

    return target;
  }

  function _objectWithoutProperties(source, excluded) {
    if (source == null) return {};

    var target = _objectWithoutPropertiesLoose(source, excluded);

    var key, i;

    if (Object.getOwnPropertySymbols) {
      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

      for (i = 0; i < sourceSymbolKeys.length; i++) {
        key = sourceSymbolKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
      }
    }

    return target;
  }

  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
  }

  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;

    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

    return arr2;
  }

  function _createForOfIteratorHelper(o, allowArrayLike) {
    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];

    if (!it) {
      if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
        if (it) o = it;
        var i = 0;

        var F = function () {};

        return {
          s: F,
          n: function () {
            if (i >= o.length) return {
              done: true
            };
            return {
              done: false,
              value: o[i++]
            };
          },
          e: function (e) {
            throw e;
          },
          f: F
        };
      }

      throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }

    var normalCompletion = true,
        didErr = false,
        err;
    return {
      s: function () {
        it = it.call(o);
      },
      n: function () {
        var step = it.next();
        normalCompletion = step.done;
        return step;
      },
      e: function (e) {
        didErr = true;
        err = e;
      },
      f: function () {
        try {
          if (!normalCompletion && it.return != null) it.return();
        } finally {
          if (didErr) throw err;
        }
      }
    };
  }

  var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

  function commonjsRequire () {
  	throw new Error('Dynamic requires are not currently supported by rollup-plugin-commonjs');
  }

  function createCommonjsModule(fn, module) {
  	return module = { exports: {} }, fn(module, module.exports), module.exports;
  }

  var eventemitter3 = createCommonjsModule(function (module) {
  var has = Object.prototype.hasOwnProperty
    , prefix = '~';
  function Events() {}
  if (Object.create) {
    Events.prototype = Object.create(null);
    if (!new Events().__proto__) prefix = false;
  }
  function EE(fn, context, once) {
    this.fn = fn;
    this.context = context;
    this.once = once || false;
  }
  function addListener(emitter, event, fn, context, once) {
    if (typeof fn !== 'function') {
      throw new TypeError('The listener must be a function');
    }
    var listener = new EE(fn, context || emitter, once)
      , evt = prefix ? prefix + event : event;
    if (!emitter._events[evt]) emitter._events[evt] = listener, emitter._eventsCount++;
    else if (!emitter._events[evt].fn) emitter._events[evt].push(listener);
    else emitter._events[evt] = [emitter._events[evt], listener];
    return emitter;
  }
  function clearEvent(emitter, evt) {
    if (--emitter._eventsCount === 0) emitter._events = new Events();
    else delete emitter._events[evt];
  }
  function EventEmitter() {
    this._events = new Events();
    this._eventsCount = 0;
  }
  EventEmitter.prototype.eventNames = function eventNames() {
    var names = []
      , events
      , name;
    if (this._eventsCount === 0) return names;
    for (name in (events = this._events)) {
      if (has.call(events, name)) names.push(prefix ? name.slice(1) : name);
    }
    if (Object.getOwnPropertySymbols) {
      return names.concat(Object.getOwnPropertySymbols(events));
    }
    return names;
  };
  EventEmitter.prototype.listeners = function listeners(event) {
    var evt = prefix ? prefix + event : event
      , handlers = this._events[evt];
    if (!handlers) return [];
    if (handlers.fn) return [handlers.fn];
    for (var i = 0, l = handlers.length, ee = new Array(l); i < l; i++) {
      ee[i] = handlers[i].fn;
    }
    return ee;
  };
  EventEmitter.prototype.listenerCount = function listenerCount(event) {
    var evt = prefix ? prefix + event : event
      , listeners = this._events[evt];
    if (!listeners) return 0;
    if (listeners.fn) return 1;
    return listeners.length;
  };
  EventEmitter.prototype.emit = function emit(event, a1, a2, a3, a4, a5) {
    var evt = prefix ? prefix + event : event;
    if (!this._events[evt]) return false;
    var listeners = this._events[evt]
      , len = arguments.length
      , args
      , i;
    if (listeners.fn) {
      if (listeners.once) this.removeListener(event, listeners.fn, undefined, true);
      switch (len) {
        case 1: return listeners.fn.call(listeners.context), true;
        case 2: return listeners.fn.call(listeners.context, a1), true;
        case 3: return listeners.fn.call(listeners.context, a1, a2), true;
        case 4: return listeners.fn.call(listeners.context, a1, a2, a3), true;
        case 5: return listeners.fn.call(listeners.context, a1, a2, a3, a4), true;
        case 6: return listeners.fn.call(listeners.context, a1, a2, a3, a4, a5), true;
      }
      for (i = 1, args = new Array(len -1); i < len; i++) {
        args[i - 1] = arguments[i];
      }
      listeners.fn.apply(listeners.context, args);
    } else {
      var length = listeners.length
        , j;
      for (i = 0; i < length; i++) {
        if (listeners[i].once) this.removeListener(event, listeners[i].fn, undefined, true);
        switch (len) {
          case 1: listeners[i].fn.call(listeners[i].context); break;
          case 2: listeners[i].fn.call(listeners[i].context, a1); break;
          case 3: listeners[i].fn.call(listeners[i].context, a1, a2); break;
          case 4: listeners[i].fn.call(listeners[i].context, a1, a2, a3); break;
          default:
            if (!args) for (j = 1, args = new Array(len -1); j < len; j++) {
              args[j - 1] = arguments[j];
            }
            listeners[i].fn.apply(listeners[i].context, args);
        }
      }
    }
    return true;
  };
  EventEmitter.prototype.on = function on(event, fn, context) {
    return addListener(this, event, fn, context, false);
  };
  EventEmitter.prototype.once = function once(event, fn, context) {
    return addListener(this, event, fn, context, true);
  };
  EventEmitter.prototype.removeListener = function removeListener(event, fn, context, once) {
    var evt = prefix ? prefix + event : event;
    if (!this._events[evt]) return this;
    if (!fn) {
      clearEvent(this, evt);
      return this;
    }
    var listeners = this._events[evt];
    if (listeners.fn) {
      if (
        listeners.fn === fn &&
        (!once || listeners.once) &&
        (!context || listeners.context === context)
      ) {
        clearEvent(this, evt);
      }
    } else {
      for (var i = 0, events = [], length = listeners.length; i < length; i++) {
        if (
          listeners[i].fn !== fn ||
          (once && !listeners[i].once) ||
          (context && listeners[i].context !== context)
        ) {
          events.push(listeners[i]);
        }
      }
      if (events.length) this._events[evt] = events.length === 1 ? events[0] : events;
      else clearEvent(this, evt);
    }
    return this;
  };
  EventEmitter.prototype.removeAllListeners = function removeAllListeners(event) {
    var evt;
    if (event) {
      evt = prefix ? prefix + event : event;
      if (this._events[evt]) clearEvent(this, evt);
    } else {
      this._events = new Events();
      this._eventsCount = 0;
    }
    return this;
  };
  EventEmitter.prototype.off = EventEmitter.prototype.removeListener;
  EventEmitter.prototype.addListener = EventEmitter.prototype.on;
  EventEmitter.prefixed = prefix;
  EventEmitter.EventEmitter = EventEmitter;
  {
    module.exports = EventEmitter;
  }
  });
  var eventemitter3_1 = eventemitter3.prefixed;
  var eventemitter3_2 = eventemitter3.EventEmitter;

  function dataURItoBlob(dataURI) {
    var byteString = atob(dataURI.split(',')[1]);
    var mimeString = dataURI.split(',')[0].split(':')[1].split(';')[0];
    var ab = new ArrayBuffer(byteString.length);
    var ia = new Uint8Array(ab);
    for (var i = 0; i < byteString.length; i++) {
      ia[i] = byteString.charCodeAt(i);
    }
    return new Blob([ab], {
      type: mimeString
    });
  }
  function canvasDataURL(path) {
    var quality = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0.6;
    var img = new Image();
    return new Promise(function (resolve, reject) {
      img.src = path;
      img.onload = function () {
        var w = img.width,
            h = img.height,
            scale = w / h;
        w = Math.min(2000, w);
        h = w / scale;
        var canvas = document.createElement('canvas');
        var ctx = canvas.getContext('2d');
        var anw = document.createAttribute("width");
        anw.nodeValue = w;
        var anh = document.createAttribute("height");
        anh.nodeValue = h;
        canvas.setAttributeNode(anw);
        canvas.setAttributeNode(anh);
        ctx.drawImage(img, 0, 0, w, h);
        var base64 = canvas.toDataURL('image/jpeg', quality);
        resolve(base64);
      };
      img.onerror = function (err) {
        reject(err);
      };
    });
  }
  function setCookies(obj, cookieExpiresTime) {
    for (var key in obj) {
      var v = obj[key];
      if (obj.hasOwnProperty(key) && v) {
        setCookie(key, v, cookieExpiresTime);
      }
    }
  }
  function setCookie(name, value) {
    var cookieExpiresTime = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 24 * 60 * 60 * 30;
    var exp = new Date();
    exp.setTime(Date.now() + cookieExpiresTime);
    document.cookie = name + "=" + escape(value) + ";expires=" + exp.toGMTString();
  }
  function getCookie(name) {
    var arr;
    var reg = new RegExp("(^| )" + name + "=([^;]*)(;|$)");
    if (arr = document.cookie.match(reg)) {
      return unescape(arr[2]);
    }
    return null;
  }
  function deepClone(obj) {
    return JSON.parse(JSON.stringify(obj));
  }
  function getFileURL(file) {
    var getUrl = null;
    if (window.createObjectURL != undefined) {
      getUrl = window.createObjectURL(file);
    } else if (window.URL != undefined) {
      getUrl = window.URL.createObjectURL(file);
    } else if (window.webkitURL != undefined) {
      getUrl = window.webkitURL.createObjectURL(file);
    }
    return getUrl;
  }
  function propsMapper(props, keyStr) {
    var defaultValue = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var newKeyName = arguments.length > 3 ? arguments[3] : undefined;
    var keys = keyStr.split('.');
    var keyValue = objectKeysValue(props, keys, defaultValue);
    return _defineProperty({}, newKeyName || keys[keys.length - 1], keyValue);
  }
  function objectKeysValue(object, keys) {
    var defaultValue = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    if (isUnValid(object)) {
      return defaultValue;
    }
    if (keys.length > 1) {
      return objectKeysValue(object[keys[0]], keys.slice(1), defaultValue);
    } else if (keys.length === 1) {
      if (!object) {
        return defaultValue;
      }
      var v = object[keys[0]];
      return isUnValid(v) ? defaultValue : v;
    } else {
      return {};
    }
  }
  function isUnValid(value) {
    return !value && value !== false && value !== 0;
  }
  function timeoutPromise(fun) {
    var timeout = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1000;
    if (!isFunction(fun)) {
      return Promise.resolve();
    }
    return new Promise(function (resolve, reject) {
      setTimeout(function () {
        try {
          resolve(fun());
        } catch (err) {
          reject(err);
        }
      }, timeout);
    });
  }
  function parseJson(text) {
    try {
      return JSON.parse(text);
    } catch (_unused) {
      return text;
    }
  }
  function isFunction(fun) {
    return typeof fun === 'function';
  }
  function json2param(o) {
    var p = [];
    for (var key in o) {
      if (o.hasOwnProperty(key)) {
        var value = o[key];
        if (value == null || value === undefined || Number.isNaN(value) || value === Infinity || value === -Infinity) {
          value = '';
        }
        p.push("".concat(key, "=").concat(encodeURIComponent(value)));
      }
    }
    return p.join('&');
  }
  function param2json(str) {
    if (typeof str !== 'string') {
      return {};
    }
    var i1 = str.indexOf('?');
    var i2 = str.indexOf('#');
    if (i2 < 0) {
      i2 = str.length;
    }
    if (i2 > i1) {
      str = str.substring(i1 + 1, i2);
    }
    var reg = /([a-z0-9_]+)=([^&#]+)/ig;
    var m = reg.exec(str);
    var ret = {};
    while (m) {
      ret[m[1]] = decodeURIComponent(m[2]);
      m = reg.exec(str);
    }
    return ret;
  }
  function renderTemplate(template, context) {
    var reg = /\{\{(.*?)\}\}/g;
    var repl = function repl(match, key) {
      return context[key.trim()];
    };
    return template.replace(reg, repl);
  }
  function promiseAll(arr, operate) {
    var resultArr = [];
    function _aysncArr(cb) {
      var a = arr.shift();
      if (a) {
        var promise = a;
        if (isFunction(operate)) {
          promise = operate(a);
        }
        promise.then(function (r) {
          resultArr.push(r);
          _aysncArr(cb);
        })["catch"](function (err) {
          cb(err, resultArr);
        });
      } else {
        cb(null, resultArr);
      }
    }
    return new Promise(function (resolve, reject) {
      _aysncArr(function (err, res) {
        if (err) {
          reject(err);
        } else {
          resolve(res);
        }
      });
    });
  }

  var util = /*#__PURE__*/Object.freeze({
    __proto__: null,
    dataURItoBlob: dataURItoBlob,
    canvasDataURL: canvasDataURL,
    setCookies: setCookies,
    setCookie: setCookie,
    getCookie: getCookie,
    deepClone: deepClone,
    getFileURL: getFileURL,
    propsMapper: propsMapper,
    isUnValid: isUnValid,
    timeoutPromise: timeoutPromise,
    parseJson: parseJson,
    isFunction: isFunction,
    json2param: json2param,
    param2json: param2json,
    renderTemplate: renderTemplate,
    promiseAll: promiseAll
  });

  var support = {
    searchParams: 'URLSearchParams' in self,
    iterable: 'Symbol' in self && 'iterator' in Symbol,
    blob:
      'FileReader' in self &&
      'Blob' in self &&
      (function() {
        try {
          new Blob();
          return true
        } catch (e) {
          return false
        }
      })(),
    formData: 'FormData' in self,
    arrayBuffer: 'ArrayBuffer' in self
  };
  function isDataView(obj) {
    return obj && DataView.prototype.isPrototypeOf(obj)
  }
  if (support.arrayBuffer) {
    var viewClasses = [
      '[object Int8Array]',
      '[object Uint8Array]',
      '[object Uint8ClampedArray]',
      '[object Int16Array]',
      '[object Uint16Array]',
      '[object Int32Array]',
      '[object Uint32Array]',
      '[object Float32Array]',
      '[object Float64Array]'
    ];
    var isArrayBufferView =
      ArrayBuffer.isView ||
      function(obj) {
        return obj && viewClasses.indexOf(Object.prototype.toString.call(obj)) > -1
      };
  }
  function normalizeName(name) {
    if (typeof name !== 'string') {
      name = String(name);
    }
    if (/[^a-z0-9\-#$%&'*+.^_`|~]/i.test(name)) {
      throw new TypeError('Invalid character in header field name')
    }
    return name.toLowerCase()
  }
  function normalizeValue(value) {
    if (typeof value !== 'string') {
      value = String(value);
    }
    return value
  }
  function iteratorFor(items) {
    var iterator = {
      next: function() {
        var value = items.shift();
        return {done: value === undefined, value: value}
      }
    };
    if (support.iterable) {
      iterator[Symbol.iterator] = function() {
        return iterator
      };
    }
    return iterator
  }
  function Headers(headers) {
    this.map = {};
    if (headers instanceof Headers) {
      headers.forEach(function(value, name) {
        this.append(name, value);
      }, this);
    } else if (Array.isArray(headers)) {
      headers.forEach(function(header) {
        this.append(header[0], header[1]);
      }, this);
    } else if (headers) {
      Object.getOwnPropertyNames(headers).forEach(function(name) {
        this.append(name, headers[name]);
      }, this);
    }
  }
  Headers.prototype.append = function(name, value) {
    name = normalizeName(name);
    value = normalizeValue(value);
    var oldValue = this.map[name];
    this.map[name] = oldValue ? oldValue + ', ' + value : value;
  };
  Headers.prototype['delete'] = function(name) {
    delete this.map[normalizeName(name)];
  };
  Headers.prototype.get = function(name) {
    name = normalizeName(name);
    return this.has(name) ? this.map[name] : null
  };
  Headers.prototype.has = function(name) {
    return this.map.hasOwnProperty(normalizeName(name))
  };
  Headers.prototype.set = function(name, value) {
    this.map[normalizeName(name)] = normalizeValue(value);
  };
  Headers.prototype.forEach = function(callback, thisArg) {
    for (var name in this.map) {
      if (this.map.hasOwnProperty(name)) {
        callback.call(thisArg, this.map[name], name, this);
      }
    }
  };
  Headers.prototype.keys = function() {
    var items = [];
    this.forEach(function(value, name) {
      items.push(name);
    });
    return iteratorFor(items)
  };
  Headers.prototype.values = function() {
    var items = [];
    this.forEach(function(value) {
      items.push(value);
    });
    return iteratorFor(items)
  };
  Headers.prototype.entries = function() {
    var items = [];
    this.forEach(function(value, name) {
      items.push([name, value]);
    });
    return iteratorFor(items)
  };
  if (support.iterable) {
    Headers.prototype[Symbol.iterator] = Headers.prototype.entries;
  }
  function consumed(body) {
    if (body.bodyUsed) {
      return Promise.reject(new TypeError('Already read'))
    }
    body.bodyUsed = true;
  }
  function fileReaderReady(reader) {
    return new Promise(function(resolve, reject) {
      reader.onload = function() {
        resolve(reader.result);
      };
      reader.onerror = function() {
        reject(reader.error);
      };
    })
  }
  function readBlobAsArrayBuffer(blob) {
    var reader = new FileReader();
    var promise = fileReaderReady(reader);
    reader.readAsArrayBuffer(blob);
    return promise
  }
  function readBlobAsText(blob) {
    var reader = new FileReader();
    var promise = fileReaderReady(reader);
    reader.readAsText(blob);
    return promise
  }
  function readArrayBufferAsText(buf) {
    var view = new Uint8Array(buf);
    var chars = new Array(view.length);
    for (var i = 0; i < view.length; i++) {
      chars[i] = String.fromCharCode(view[i]);
    }
    return chars.join('')
  }
  function bufferClone(buf) {
    if (buf.slice) {
      return buf.slice(0)
    } else {
      var view = new Uint8Array(buf.byteLength);
      view.set(new Uint8Array(buf));
      return view.buffer
    }
  }
  function Body() {
    this.bodyUsed = false;
    this._initBody = function(body) {
      this._bodyInit = body;
      if (!body) {
        this._bodyText = '';
      } else if (typeof body === 'string') {
        this._bodyText = body;
      } else if (support.blob && Blob.prototype.isPrototypeOf(body)) {
        this._bodyBlob = body;
      } else if (support.formData && FormData.prototype.isPrototypeOf(body)) {
        this._bodyFormData = body;
      } else if (support.searchParams && URLSearchParams.prototype.isPrototypeOf(body)) {
        this._bodyText = body.toString();
      } else if (support.arrayBuffer && support.blob && isDataView(body)) {
        this._bodyArrayBuffer = bufferClone(body.buffer);
        this._bodyInit = new Blob([this._bodyArrayBuffer]);
      } else if (support.arrayBuffer && (ArrayBuffer.prototype.isPrototypeOf(body) || isArrayBufferView(body))) {
        this._bodyArrayBuffer = bufferClone(body);
      } else {
        this._bodyText = body = Object.prototype.toString.call(body);
      }
      if (!this.headers.get('content-type')) {
        if (typeof body === 'string') {
          this.headers.set('content-type', 'text/plain;charset=UTF-8');
        } else if (this._bodyBlob && this._bodyBlob.type) {
          this.headers.set('content-type', this._bodyBlob.type);
        } else if (support.searchParams && URLSearchParams.prototype.isPrototypeOf(body)) {
          this.headers.set('content-type', 'application/x-www-form-urlencoded;charset=UTF-8');
        }
      }
    };
    if (support.blob) {
      this.blob = function() {
        var rejected = consumed(this);
        if (rejected) {
          return rejected
        }
        if (this._bodyBlob) {
          return Promise.resolve(this._bodyBlob)
        } else if (this._bodyArrayBuffer) {
          return Promise.resolve(new Blob([this._bodyArrayBuffer]))
        } else if (this._bodyFormData) {
          throw new Error('could not read FormData body as blob')
        } else {
          return Promise.resolve(new Blob([this._bodyText]))
        }
      };
      this.arrayBuffer = function() {
        if (this._bodyArrayBuffer) {
          return consumed(this) || Promise.resolve(this._bodyArrayBuffer)
        } else {
          return this.blob().then(readBlobAsArrayBuffer)
        }
      };
    }
    this.text = function() {
      var rejected = consumed(this);
      if (rejected) {
        return rejected
      }
      if (this._bodyBlob) {
        return readBlobAsText(this._bodyBlob)
      } else if (this._bodyArrayBuffer) {
        return Promise.resolve(readArrayBufferAsText(this._bodyArrayBuffer))
      } else if (this._bodyFormData) {
        throw new Error('could not read FormData body as text')
      } else {
        return Promise.resolve(this._bodyText)
      }
    };
    if (support.formData) {
      this.formData = function() {
        return this.text().then(decode)
      };
    }
    this.json = function() {
      return this.text().then(JSON.parse)
    };
    return this
  }
  var methods = ['DELETE', 'GET', 'HEAD', 'OPTIONS', 'POST', 'PUT'];
  function normalizeMethod(method) {
    var upcased = method.toUpperCase();
    return methods.indexOf(upcased) > -1 ? upcased : method
  }
  function Request(input, options) {
    options = options || {};
    var body = options.body;
    if (input instanceof Request) {
      if (input.bodyUsed) {
        throw new TypeError('Already read')
      }
      this.url = input.url;
      this.credentials = input.credentials;
      if (!options.headers) {
        this.headers = new Headers(input.headers);
      }
      this.method = input.method;
      this.mode = input.mode;
      this.signal = input.signal;
      if (!body && input._bodyInit != null) {
        body = input._bodyInit;
        input.bodyUsed = true;
      }
    } else {
      this.url = String(input);
    }
    this.credentials = options.credentials || this.credentials || 'same-origin';
    if (options.headers || !this.headers) {
      this.headers = new Headers(options.headers);
    }
    this.method = normalizeMethod(options.method || this.method || 'GET');
    this.mode = options.mode || this.mode || null;
    this.signal = options.signal || this.signal;
    this.referrer = null;
    if ((this.method === 'GET' || this.method === 'HEAD') && body) {
      throw new TypeError('Body not allowed for GET or HEAD requests')
    }
    this._initBody(body);
  }
  Request.prototype.clone = function() {
    return new Request(this, {body: this._bodyInit})
  };
  function decode(body) {
    var form = new FormData();
    body
      .trim()
      .split('&')
      .forEach(function(bytes) {
        if (bytes) {
          var split = bytes.split('=');
          var name = split.shift().replace(/\+/g, ' ');
          var value = split.join('=').replace(/\+/g, ' ');
          form.append(decodeURIComponent(name), decodeURIComponent(value));
        }
      });
    return form
  }
  function parseHeaders(rawHeaders) {
    var headers = new Headers();
    var preProcessedHeaders = rawHeaders.replace(/\r?\n[\t ]+/g, ' ');
    preProcessedHeaders.split(/\r?\n/).forEach(function(line) {
      var parts = line.split(':');
      var key = parts.shift().trim();
      if (key) {
        var value = parts.join(':').trim();
        headers.append(key, value);
      }
    });
    return headers
  }
  Body.call(Request.prototype);
  function Response(bodyInit, options) {
    if (!options) {
      options = {};
    }
    this.type = 'default';
    this.status = options.status === undefined ? 200 : options.status;
    this.ok = this.status >= 200 && this.status < 300;
    this.statusText = 'statusText' in options ? options.statusText : 'OK';
    this.headers = new Headers(options.headers);
    this.url = options.url || '';
    this._initBody(bodyInit);
  }
  Body.call(Response.prototype);
  Response.prototype.clone = function() {
    return new Response(this._bodyInit, {
      status: this.status,
      statusText: this.statusText,
      headers: new Headers(this.headers),
      url: this.url
    })
  };
  Response.error = function() {
    var response = new Response(null, {status: 0, statusText: ''});
    response.type = 'error';
    return response
  };
  var redirectStatuses = [301, 302, 303, 307, 308];
  Response.redirect = function(url, status) {
    if (redirectStatuses.indexOf(status) === -1) {
      throw new RangeError('Invalid status code')
    }
    return new Response(null, {status: status, headers: {location: url}})
  };
  var DOMException = self.DOMException;
  try {
    new DOMException();
  } catch (err) {
    DOMException = function(message, name) {
      this.message = message;
      this.name = name;
      var error = Error(message);
      this.stack = error.stack;
    };
    DOMException.prototype = Object.create(Error.prototype);
    DOMException.prototype.constructor = DOMException;
  }
  function fetch(input, init) {
    return new Promise(function(resolve, reject) {
      var request = new Request(input, init);
      if (request.signal && request.signal.aborted) {
        return reject(new DOMException('Aborted', 'AbortError'))
      }
      var xhr = new XMLHttpRequest();
      function abortXhr() {
        xhr.abort();
      }
      xhr.onload = function() {
        var options = {
          status: xhr.status,
          statusText: xhr.statusText,
          headers: parseHeaders(xhr.getAllResponseHeaders() || '')
        };
        options.url = 'responseURL' in xhr ? xhr.responseURL : options.headers.get('X-Request-URL');
        var body = 'response' in xhr ? xhr.response : xhr.responseText;
        resolve(new Response(body, options));
      };
      xhr.onerror = function() {
        reject(new TypeError('Network request failed'));
      };
      xhr.ontimeout = function() {
        reject(new TypeError('Network request failed'));
      };
      xhr.onabort = function() {
        reject(new DOMException('Aborted', 'AbortError'));
      };
      xhr.open(request.method, request.url, true);
      if (request.credentials === 'include') {
        xhr.withCredentials = true;
      } else if (request.credentials === 'omit') {
        xhr.withCredentials = false;
      }
      if ('responseType' in xhr && support.blob) {
        xhr.responseType = 'blob';
      }
      request.headers.forEach(function(value, name) {
        xhr.setRequestHeader(name, value);
      });
      if (request.signal) {
        request.signal.addEventListener('abort', abortXhr);
        xhr.onreadystatechange = function() {
          if (xhr.readyState === 4) {
            request.signal.removeEventListener('abort', abortXhr);
          }
        };
      }
      xhr.send(typeof request._bodyInit === 'undefined' ? null : request._bodyInit);
    })
  }
  fetch.polyfill = true;
  if (!self.fetch) {
    self.fetch = fetch;
    self.Headers = Headers;
    self.Request = Request;
    self.Response = Response;
  }

  var fetch$1 = fetch;

  var core = createCommonjsModule(function (module, exports) {
  (function (root, factory) {
  	{
  		module.exports = exports = factory();
  	}
  }(commonjsGlobal, function () {
  	var CryptoJS = CryptoJS || (function (Math, undefined$1) {
  	    var crypto$1;
  	    if (typeof window !== 'undefined' && window.crypto) {
  	        crypto$1 = window.crypto;
  	    }
  	    if (typeof self !== 'undefined' && self.crypto) {
  	        crypto$1 = self.crypto;
  	    }
  	    if (typeof globalThis !== 'undefined' && globalThis.crypto) {
  	        crypto$1 = globalThis.crypto;
  	    }
  	    if (!crypto$1 && typeof window !== 'undefined' && window.msCrypto) {
  	        crypto$1 = window.msCrypto;
  	    }
  	    if (!crypto$1 && typeof commonjsGlobal !== 'undefined' && commonjsGlobal.crypto) {
  	        crypto$1 = commonjsGlobal.crypto;
  	    }
  	    if (!crypto$1 && typeof commonjsRequire === 'function') {
  	        try {
  	            crypto$1 = crypto;
  	        } catch (err) {}
  	    }
  	    var cryptoSecureRandomInt = function () {
  	        if (crypto$1) {
  	            if (typeof crypto$1.getRandomValues === 'function') {
  	                try {
  	                    return crypto$1.getRandomValues(new Uint32Array(1))[0];
  	                } catch (err) {}
  	            }
  	            if (typeof crypto$1.randomBytes === 'function') {
  	                try {
  	                    return crypto$1.randomBytes(4).readInt32LE();
  	                } catch (err) {}
  	            }
  	        }
  	        throw new Error('Native crypto module could not be used to get secure random number.');
  	    };
  	    var create = Object.create || (function () {
  	        function F() {}
  	        return function (obj) {
  	            var subtype;
  	            F.prototype = obj;
  	            subtype = new F();
  	            F.prototype = null;
  	            return subtype;
  	        };
  	    }());
  	    var C = {};
  	    var C_lib = C.lib = {};
  	    var Base = C_lib.Base = (function () {
  	        return {
  	            extend: function (overrides) {
  	                var subtype = create(this);
  	                if (overrides) {
  	                    subtype.mixIn(overrides);
  	                }
  	                if (!subtype.hasOwnProperty('init') || this.init === subtype.init) {
  	                    subtype.init = function () {
  	                        subtype.$super.init.apply(this, arguments);
  	                    };
  	                }
  	                subtype.init.prototype = subtype;
  	                subtype.$super = this;
  	                return subtype;
  	            },
  	            create: function () {
  	                var instance = this.extend();
  	                instance.init.apply(instance, arguments);
  	                return instance;
  	            },
  	            init: function () {
  	            },
  	            mixIn: function (properties) {
  	                for (var propertyName in properties) {
  	                    if (properties.hasOwnProperty(propertyName)) {
  	                        this[propertyName] = properties[propertyName];
  	                    }
  	                }
  	                if (properties.hasOwnProperty('toString')) {
  	                    this.toString = properties.toString;
  	                }
  	            },
  	            clone: function () {
  	                return this.init.prototype.extend(this);
  	            }
  	        };
  	    }());
  	    var WordArray = C_lib.WordArray = Base.extend({
  	        init: function (words, sigBytes) {
  	            words = this.words = words || [];
  	            if (sigBytes != undefined$1) {
  	                this.sigBytes = sigBytes;
  	            } else {
  	                this.sigBytes = words.length * 4;
  	            }
  	        },
  	        toString: function (encoder) {
  	            return (encoder || Hex).stringify(this);
  	        },
  	        concat: function (wordArray) {
  	            var thisWords = this.words;
  	            var thatWords = wordArray.words;
  	            var thisSigBytes = this.sigBytes;
  	            var thatSigBytes = wordArray.sigBytes;
  	            this.clamp();
  	            if (thisSigBytes % 4) {
  	                for (var i = 0; i < thatSigBytes; i++) {
  	                    var thatByte = (thatWords[i >>> 2] >>> (24 - (i % 4) * 8)) & 0xff;
  	                    thisWords[(thisSigBytes + i) >>> 2] |= thatByte << (24 - ((thisSigBytes + i) % 4) * 8);
  	                }
  	            } else {
  	                for (var j = 0; j < thatSigBytes; j += 4) {
  	                    thisWords[(thisSigBytes + j) >>> 2] = thatWords[j >>> 2];
  	                }
  	            }
  	            this.sigBytes += thatSigBytes;
  	            return this;
  	        },
  	        clamp: function () {
  	            var words = this.words;
  	            var sigBytes = this.sigBytes;
  	            words[sigBytes >>> 2] &= 0xffffffff << (32 - (sigBytes % 4) * 8);
  	            words.length = Math.ceil(sigBytes / 4);
  	        },
  	        clone: function () {
  	            var clone = Base.clone.call(this);
  	            clone.words = this.words.slice(0);
  	            return clone;
  	        },
  	        random: function (nBytes) {
  	            var words = [];
  	            for (var i = 0; i < nBytes; i += 4) {
  	                words.push(cryptoSecureRandomInt());
  	            }
  	            return new WordArray.init(words, nBytes);
  	        }
  	    });
  	    var C_enc = C.enc = {};
  	    var Hex = C_enc.Hex = {
  	        stringify: function (wordArray) {
  	            var words = wordArray.words;
  	            var sigBytes = wordArray.sigBytes;
  	            var hexChars = [];
  	            for (var i = 0; i < sigBytes; i++) {
  	                var bite = (words[i >>> 2] >>> (24 - (i % 4) * 8)) & 0xff;
  	                hexChars.push((bite >>> 4).toString(16));
  	                hexChars.push((bite & 0x0f).toString(16));
  	            }
  	            return hexChars.join('');
  	        },
  	        parse: function (hexStr) {
  	            var hexStrLength = hexStr.length;
  	            var words = [];
  	            for (var i = 0; i < hexStrLength; i += 2) {
  	                words[i >>> 3] |= parseInt(hexStr.substr(i, 2), 16) << (24 - (i % 8) * 4);
  	            }
  	            return new WordArray.init(words, hexStrLength / 2);
  	        }
  	    };
  	    var Latin1 = C_enc.Latin1 = {
  	        stringify: function (wordArray) {
  	            var words = wordArray.words;
  	            var sigBytes = wordArray.sigBytes;
  	            var latin1Chars = [];
  	            for (var i = 0; i < sigBytes; i++) {
  	                var bite = (words[i >>> 2] >>> (24 - (i % 4) * 8)) & 0xff;
  	                latin1Chars.push(String.fromCharCode(bite));
  	            }
  	            return latin1Chars.join('');
  	        },
  	        parse: function (latin1Str) {
  	            var latin1StrLength = latin1Str.length;
  	            var words = [];
  	            for (var i = 0; i < latin1StrLength; i++) {
  	                words[i >>> 2] |= (latin1Str.charCodeAt(i) & 0xff) << (24 - (i % 4) * 8);
  	            }
  	            return new WordArray.init(words, latin1StrLength);
  	        }
  	    };
  	    var Utf8 = C_enc.Utf8 = {
  	        stringify: function (wordArray) {
  	            try {
  	                return decodeURIComponent(escape(Latin1.stringify(wordArray)));
  	            } catch (e) {
  	                throw new Error('Malformed UTF-8 data');
  	            }
  	        },
  	        parse: function (utf8Str) {
  	            return Latin1.parse(unescape(encodeURIComponent(utf8Str)));
  	        }
  	    };
  	    var BufferedBlockAlgorithm = C_lib.BufferedBlockAlgorithm = Base.extend({
  	        reset: function () {
  	            this._data = new WordArray.init();
  	            this._nDataBytes = 0;
  	        },
  	        _append: function (data) {
  	            if (typeof data == 'string') {
  	                data = Utf8.parse(data);
  	            }
  	            this._data.concat(data);
  	            this._nDataBytes += data.sigBytes;
  	        },
  	        _process: function (doFlush) {
  	            var processedWords;
  	            var data = this._data;
  	            var dataWords = data.words;
  	            var dataSigBytes = data.sigBytes;
  	            var blockSize = this.blockSize;
  	            var blockSizeBytes = blockSize * 4;
  	            var nBlocksReady = dataSigBytes / blockSizeBytes;
  	            if (doFlush) {
  	                nBlocksReady = Math.ceil(nBlocksReady);
  	            } else {
  	                nBlocksReady = Math.max((nBlocksReady | 0) - this._minBufferSize, 0);
  	            }
  	            var nWordsReady = nBlocksReady * blockSize;
  	            var nBytesReady = Math.min(nWordsReady * 4, dataSigBytes);
  	            if (nWordsReady) {
  	                for (var offset = 0; offset < nWordsReady; offset += blockSize) {
  	                    this._doProcessBlock(dataWords, offset);
  	                }
  	                processedWords = dataWords.splice(0, nWordsReady);
  	                data.sigBytes -= nBytesReady;
  	            }
  	            return new WordArray.init(processedWords, nBytesReady);
  	        },
  	        clone: function () {
  	            var clone = Base.clone.call(this);
  	            clone._data = this._data.clone();
  	            return clone;
  	        },
  	        _minBufferSize: 0
  	    });
  	    var Hasher = C_lib.Hasher = BufferedBlockAlgorithm.extend({
  	        cfg: Base.extend(),
  	        init: function (cfg) {
  	            this.cfg = this.cfg.extend(cfg);
  	            this.reset();
  	        },
  	        reset: function () {
  	            BufferedBlockAlgorithm.reset.call(this);
  	            this._doReset();
  	        },
  	        update: function (messageUpdate) {
  	            this._append(messageUpdate);
  	            this._process();
  	            return this;
  	        },
  	        finalize: function (messageUpdate) {
  	            if (messageUpdate) {
  	                this._append(messageUpdate);
  	            }
  	            var hash = this._doFinalize();
  	            return hash;
  	        },
  	        blockSize: 512/32,
  	        _createHelper: function (hasher) {
  	            return function (message, cfg) {
  	                return new hasher.init(cfg).finalize(message);
  	            };
  	        },
  	        _createHmacHelper: function (hasher) {
  	            return function (message, key) {
  	                return new C_algo.HMAC.init(hasher, key).finalize(message);
  	            };
  	        }
  	    });
  	    var C_algo = C.algo = {};
  	    return C;
  	}(Math));
  	return CryptoJS;
  }));
  });

  var x64Core = createCommonjsModule(function (module, exports) {
  (function (root, factory) {
  	{
  		module.exports = exports = factory(core);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	(function (undefined$1) {
  	    var C = CryptoJS;
  	    var C_lib = C.lib;
  	    var Base = C_lib.Base;
  	    var X32WordArray = C_lib.WordArray;
  	    var C_x64 = C.x64 = {};
  	    var X64Word = C_x64.Word = Base.extend({
  	        init: function (high, low) {
  	            this.high = high;
  	            this.low = low;
  	        }
  	    });
  	    var X64WordArray = C_x64.WordArray = Base.extend({
  	        init: function (words, sigBytes) {
  	            words = this.words = words || [];
  	            if (sigBytes != undefined$1) {
  	                this.sigBytes = sigBytes;
  	            } else {
  	                this.sigBytes = words.length * 8;
  	            }
  	        },
  	        toX32: function () {
  	            var x64Words = this.words;
  	            var x64WordsLength = x64Words.length;
  	            var x32Words = [];
  	            for (var i = 0; i < x64WordsLength; i++) {
  	                var x64Word = x64Words[i];
  	                x32Words.push(x64Word.high);
  	                x32Words.push(x64Word.low);
  	            }
  	            return X32WordArray.create(x32Words, this.sigBytes);
  	        },
  	        clone: function () {
  	            var clone = Base.clone.call(this);
  	            var words = clone.words = this.words.slice(0);
  	            var wordsLength = words.length;
  	            for (var i = 0; i < wordsLength; i++) {
  	                words[i] = words[i].clone();
  	            }
  	            return clone;
  	        }
  	    });
  	}());
  	return CryptoJS;
  }));
  });

  var libTypedarrays = createCommonjsModule(function (module, exports) {
  (function (root, factory) {
  	{
  		module.exports = exports = factory(core);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	(function () {
  	    if (typeof ArrayBuffer != 'function') {
  	        return;
  	    }
  	    var C = CryptoJS;
  	    var C_lib = C.lib;
  	    var WordArray = C_lib.WordArray;
  	    var superInit = WordArray.init;
  	    var subInit = WordArray.init = function (typedArray) {
  	        if (typedArray instanceof ArrayBuffer) {
  	            typedArray = new Uint8Array(typedArray);
  	        }
  	        if (
  	            typedArray instanceof Int8Array ||
  	            (typeof Uint8ClampedArray !== "undefined" && typedArray instanceof Uint8ClampedArray) ||
  	            typedArray instanceof Int16Array ||
  	            typedArray instanceof Uint16Array ||
  	            typedArray instanceof Int32Array ||
  	            typedArray instanceof Uint32Array ||
  	            typedArray instanceof Float32Array ||
  	            typedArray instanceof Float64Array
  	        ) {
  	            typedArray = new Uint8Array(typedArray.buffer, typedArray.byteOffset, typedArray.byteLength);
  	        }
  	        if (typedArray instanceof Uint8Array) {
  	            var typedArrayByteLength = typedArray.byteLength;
  	            var words = [];
  	            for (var i = 0; i < typedArrayByteLength; i++) {
  	                words[i >>> 2] |= typedArray[i] << (24 - (i % 4) * 8);
  	            }
  	            superInit.call(this, words, typedArrayByteLength);
  	        } else {
  	            superInit.apply(this, arguments);
  	        }
  	    };
  	    subInit.prototype = WordArray;
  	}());
  	return CryptoJS.lib.WordArray;
  }));
  });

  var encUtf16 = createCommonjsModule(function (module, exports) {
  (function (root, factory) {
  	{
  		module.exports = exports = factory(core);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	(function () {
  	    var C = CryptoJS;
  	    var C_lib = C.lib;
  	    var WordArray = C_lib.WordArray;
  	    var C_enc = C.enc;
  	    var Utf16BE = C_enc.Utf16 = C_enc.Utf16BE = {
  	        stringify: function (wordArray) {
  	            var words = wordArray.words;
  	            var sigBytes = wordArray.sigBytes;
  	            var utf16Chars = [];
  	            for (var i = 0; i < sigBytes; i += 2) {
  	                var codePoint = (words[i >>> 2] >>> (16 - (i % 4) * 8)) & 0xffff;
  	                utf16Chars.push(String.fromCharCode(codePoint));
  	            }
  	            return utf16Chars.join('');
  	        },
  	        parse: function (utf16Str) {
  	            var utf16StrLength = utf16Str.length;
  	            var words = [];
  	            for (var i = 0; i < utf16StrLength; i++) {
  	                words[i >>> 1] |= utf16Str.charCodeAt(i) << (16 - (i % 2) * 16);
  	            }
  	            return WordArray.create(words, utf16StrLength * 2);
  	        }
  	    };
  	    C_enc.Utf16LE = {
  	        stringify: function (wordArray) {
  	            var words = wordArray.words;
  	            var sigBytes = wordArray.sigBytes;
  	            var utf16Chars = [];
  	            for (var i = 0; i < sigBytes; i += 2) {
  	                var codePoint = swapEndian((words[i >>> 2] >>> (16 - (i % 4) * 8)) & 0xffff);
  	                utf16Chars.push(String.fromCharCode(codePoint));
  	            }
  	            return utf16Chars.join('');
  	        },
  	        parse: function (utf16Str) {
  	            var utf16StrLength = utf16Str.length;
  	            var words = [];
  	            for (var i = 0; i < utf16StrLength; i++) {
  	                words[i >>> 1] |= swapEndian(utf16Str.charCodeAt(i) << (16 - (i % 2) * 16));
  	            }
  	            return WordArray.create(words, utf16StrLength * 2);
  	        }
  	    };
  	    function swapEndian(word) {
  	        return ((word << 8) & 0xff00ff00) | ((word >>> 8) & 0x00ff00ff);
  	    }
  	}());
  	return CryptoJS.enc.Utf16;
  }));
  });

  var encBase64 = createCommonjsModule(function (module, exports) {
  (function (root, factory) {
  	{
  		module.exports = exports = factory(core);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	(function () {
  	    var C = CryptoJS;
  	    var C_lib = C.lib;
  	    var WordArray = C_lib.WordArray;
  	    var C_enc = C.enc;
  	    var Base64 = C_enc.Base64 = {
  	        stringify: function (wordArray) {
  	            var words = wordArray.words;
  	            var sigBytes = wordArray.sigBytes;
  	            var map = this._map;
  	            wordArray.clamp();
  	            var base64Chars = [];
  	            for (var i = 0; i < sigBytes; i += 3) {
  	                var byte1 = (words[i >>> 2]       >>> (24 - (i % 4) * 8))       & 0xff;
  	                var byte2 = (words[(i + 1) >>> 2] >>> (24 - ((i + 1) % 4) * 8)) & 0xff;
  	                var byte3 = (words[(i + 2) >>> 2] >>> (24 - ((i + 2) % 4) * 8)) & 0xff;
  	                var triplet = (byte1 << 16) | (byte2 << 8) | byte3;
  	                for (var j = 0; (j < 4) && (i + j * 0.75 < sigBytes); j++) {
  	                    base64Chars.push(map.charAt((triplet >>> (6 * (3 - j))) & 0x3f));
  	                }
  	            }
  	            var paddingChar = map.charAt(64);
  	            if (paddingChar) {
  	                while (base64Chars.length % 4) {
  	                    base64Chars.push(paddingChar);
  	                }
  	            }
  	            return base64Chars.join('');
  	        },
  	        parse: function (base64Str) {
  	            var base64StrLength = base64Str.length;
  	            var map = this._map;
  	            var reverseMap = this._reverseMap;
  	            if (!reverseMap) {
  	                    reverseMap = this._reverseMap = [];
  	                    for (var j = 0; j < map.length; j++) {
  	                        reverseMap[map.charCodeAt(j)] = j;
  	                    }
  	            }
  	            var paddingChar = map.charAt(64);
  	            if (paddingChar) {
  	                var paddingIndex = base64Str.indexOf(paddingChar);
  	                if (paddingIndex !== -1) {
  	                    base64StrLength = paddingIndex;
  	                }
  	            }
  	            return parseLoop(base64Str, base64StrLength, reverseMap);
  	        },
  	        _map: 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/='
  	    };
  	    function parseLoop(base64Str, base64StrLength, reverseMap) {
  	      var words = [];
  	      var nBytes = 0;
  	      for (var i = 0; i < base64StrLength; i++) {
  	          if (i % 4) {
  	              var bits1 = reverseMap[base64Str.charCodeAt(i - 1)] << ((i % 4) * 2);
  	              var bits2 = reverseMap[base64Str.charCodeAt(i)] >>> (6 - (i % 4) * 2);
  	              var bitsCombined = bits1 | bits2;
  	              words[nBytes >>> 2] |= bitsCombined << (24 - (nBytes % 4) * 8);
  	              nBytes++;
  	          }
  	      }
  	      return WordArray.create(words, nBytes);
  	    }
  	}());
  	return CryptoJS.enc.Base64;
  }));
  });

  var encBase64url = createCommonjsModule(function (module, exports) {
  (function (root, factory) {
  	{
  		module.exports = exports = factory(core);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	(function () {
  	    var C = CryptoJS;
  	    var C_lib = C.lib;
  	    var WordArray = C_lib.WordArray;
  	    var C_enc = C.enc;
  	    var Base64url = C_enc.Base64url = {
  	        stringify: function (wordArray, urlSafe=true) {
  	            var words = wordArray.words;
  	            var sigBytes = wordArray.sigBytes;
  	            var map = urlSafe ? this._safe_map : this._map;
  	            wordArray.clamp();
  	            var base64Chars = [];
  	            for (var i = 0; i < sigBytes; i += 3) {
  	                var byte1 = (words[i >>> 2]       >>> (24 - (i % 4) * 8))       & 0xff;
  	                var byte2 = (words[(i + 1) >>> 2] >>> (24 - ((i + 1) % 4) * 8)) & 0xff;
  	                var byte3 = (words[(i + 2) >>> 2] >>> (24 - ((i + 2) % 4) * 8)) & 0xff;
  	                var triplet = (byte1 << 16) | (byte2 << 8) | byte3;
  	                for (var j = 0; (j < 4) && (i + j * 0.75 < sigBytes); j++) {
  	                    base64Chars.push(map.charAt((triplet >>> (6 * (3 - j))) & 0x3f));
  	                }
  	            }
  	            var paddingChar = map.charAt(64);
  	            if (paddingChar) {
  	                while (base64Chars.length % 4) {
  	                    base64Chars.push(paddingChar);
  	                }
  	            }
  	            return base64Chars.join('');
  	        },
  	        parse: function (base64Str, urlSafe=true) {
  	            var base64StrLength = base64Str.length;
  	            var map = urlSafe ? this._safe_map : this._map;
  	            var reverseMap = this._reverseMap;
  	            if (!reverseMap) {
  	                reverseMap = this._reverseMap = [];
  	                for (var j = 0; j < map.length; j++) {
  	                    reverseMap[map.charCodeAt(j)] = j;
  	                }
  	            }
  	            var paddingChar = map.charAt(64);
  	            if (paddingChar) {
  	                var paddingIndex = base64Str.indexOf(paddingChar);
  	                if (paddingIndex !== -1) {
  	                    base64StrLength = paddingIndex;
  	                }
  	            }
  	            return parseLoop(base64Str, base64StrLength, reverseMap);
  	        },
  	        _map: 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=',
  	        _safe_map: 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_',
  	    };
  	    function parseLoop(base64Str, base64StrLength, reverseMap) {
  	        var words = [];
  	        var nBytes = 0;
  	        for (var i = 0; i < base64StrLength; i++) {
  	            if (i % 4) {
  	                var bits1 = reverseMap[base64Str.charCodeAt(i - 1)] << ((i % 4) * 2);
  	                var bits2 = reverseMap[base64Str.charCodeAt(i)] >>> (6 - (i % 4) * 2);
  	                var bitsCombined = bits1 | bits2;
  	                words[nBytes >>> 2] |= bitsCombined << (24 - (nBytes % 4) * 8);
  	                nBytes++;
  	            }
  	        }
  	        return WordArray.create(words, nBytes);
  	    }
  	}());
  	return CryptoJS.enc.Base64url;
  }));
  });

  var md5 = createCommonjsModule(function (module, exports) {
  (function (root, factory) {
  	{
  		module.exports = exports = factory(core);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	(function (Math) {
  	    var C = CryptoJS;
  	    var C_lib = C.lib;
  	    var WordArray = C_lib.WordArray;
  	    var Hasher = C_lib.Hasher;
  	    var C_algo = C.algo;
  	    var T = [];
  	    (function () {
  	        for (var i = 0; i < 64; i++) {
  	            T[i] = (Math.abs(Math.sin(i + 1)) * 0x100000000) | 0;
  	        }
  	    }());
  	    var MD5 = C_algo.MD5 = Hasher.extend({
  	        _doReset: function () {
  	            this._hash = new WordArray.init([
  	                0x67452301, 0xefcdab89,
  	                0x98badcfe, 0x10325476
  	            ]);
  	        },
  	        _doProcessBlock: function (M, offset) {
  	            for (var i = 0; i < 16; i++) {
  	                var offset_i = offset + i;
  	                var M_offset_i = M[offset_i];
  	                M[offset_i] = (
  	                    (((M_offset_i << 8)  | (M_offset_i >>> 24)) & 0x00ff00ff) |
  	                    (((M_offset_i << 24) | (M_offset_i >>> 8))  & 0xff00ff00)
  	                );
  	            }
  	            var H = this._hash.words;
  	            var M_offset_0  = M[offset + 0];
  	            var M_offset_1  = M[offset + 1];
  	            var M_offset_2  = M[offset + 2];
  	            var M_offset_3  = M[offset + 3];
  	            var M_offset_4  = M[offset + 4];
  	            var M_offset_5  = M[offset + 5];
  	            var M_offset_6  = M[offset + 6];
  	            var M_offset_7  = M[offset + 7];
  	            var M_offset_8  = M[offset + 8];
  	            var M_offset_9  = M[offset + 9];
  	            var M_offset_10 = M[offset + 10];
  	            var M_offset_11 = M[offset + 11];
  	            var M_offset_12 = M[offset + 12];
  	            var M_offset_13 = M[offset + 13];
  	            var M_offset_14 = M[offset + 14];
  	            var M_offset_15 = M[offset + 15];
  	            var a = H[0];
  	            var b = H[1];
  	            var c = H[2];
  	            var d = H[3];
  	            a = FF(a, b, c, d, M_offset_0,  7,  T[0]);
  	            d = FF(d, a, b, c, M_offset_1,  12, T[1]);
  	            c = FF(c, d, a, b, M_offset_2,  17, T[2]);
  	            b = FF(b, c, d, a, M_offset_3,  22, T[3]);
  	            a = FF(a, b, c, d, M_offset_4,  7,  T[4]);
  	            d = FF(d, a, b, c, M_offset_5,  12, T[5]);
  	            c = FF(c, d, a, b, M_offset_6,  17, T[6]);
  	            b = FF(b, c, d, a, M_offset_7,  22, T[7]);
  	            a = FF(a, b, c, d, M_offset_8,  7,  T[8]);
  	            d = FF(d, a, b, c, M_offset_9,  12, T[9]);
  	            c = FF(c, d, a, b, M_offset_10, 17, T[10]);
  	            b = FF(b, c, d, a, M_offset_11, 22, T[11]);
  	            a = FF(a, b, c, d, M_offset_12, 7,  T[12]);
  	            d = FF(d, a, b, c, M_offset_13, 12, T[13]);
  	            c = FF(c, d, a, b, M_offset_14, 17, T[14]);
  	            b = FF(b, c, d, a, M_offset_15, 22, T[15]);
  	            a = GG(a, b, c, d, M_offset_1,  5,  T[16]);
  	            d = GG(d, a, b, c, M_offset_6,  9,  T[17]);
  	            c = GG(c, d, a, b, M_offset_11, 14, T[18]);
  	            b = GG(b, c, d, a, M_offset_0,  20, T[19]);
  	            a = GG(a, b, c, d, M_offset_5,  5,  T[20]);
  	            d = GG(d, a, b, c, M_offset_10, 9,  T[21]);
  	            c = GG(c, d, a, b, M_offset_15, 14, T[22]);
  	            b = GG(b, c, d, a, M_offset_4,  20, T[23]);
  	            a = GG(a, b, c, d, M_offset_9,  5,  T[24]);
  	            d = GG(d, a, b, c, M_offset_14, 9,  T[25]);
  	            c = GG(c, d, a, b, M_offset_3,  14, T[26]);
  	            b = GG(b, c, d, a, M_offset_8,  20, T[27]);
  	            a = GG(a, b, c, d, M_offset_13, 5,  T[28]);
  	            d = GG(d, a, b, c, M_offset_2,  9,  T[29]);
  	            c = GG(c, d, a, b, M_offset_7,  14, T[30]);
  	            b = GG(b, c, d, a, M_offset_12, 20, T[31]);
  	            a = HH(a, b, c, d, M_offset_5,  4,  T[32]);
  	            d = HH(d, a, b, c, M_offset_8,  11, T[33]);
  	            c = HH(c, d, a, b, M_offset_11, 16, T[34]);
  	            b = HH(b, c, d, a, M_offset_14, 23, T[35]);
  	            a = HH(a, b, c, d, M_offset_1,  4,  T[36]);
  	            d = HH(d, a, b, c, M_offset_4,  11, T[37]);
  	            c = HH(c, d, a, b, M_offset_7,  16, T[38]);
  	            b = HH(b, c, d, a, M_offset_10, 23, T[39]);
  	            a = HH(a, b, c, d, M_offset_13, 4,  T[40]);
  	            d = HH(d, a, b, c, M_offset_0,  11, T[41]);
  	            c = HH(c, d, a, b, M_offset_3,  16, T[42]);
  	            b = HH(b, c, d, a, M_offset_6,  23, T[43]);
  	            a = HH(a, b, c, d, M_offset_9,  4,  T[44]);
  	            d = HH(d, a, b, c, M_offset_12, 11, T[45]);
  	            c = HH(c, d, a, b, M_offset_15, 16, T[46]);
  	            b = HH(b, c, d, a, M_offset_2,  23, T[47]);
  	            a = II(a, b, c, d, M_offset_0,  6,  T[48]);
  	            d = II(d, a, b, c, M_offset_7,  10, T[49]);
  	            c = II(c, d, a, b, M_offset_14, 15, T[50]);
  	            b = II(b, c, d, a, M_offset_5,  21, T[51]);
  	            a = II(a, b, c, d, M_offset_12, 6,  T[52]);
  	            d = II(d, a, b, c, M_offset_3,  10, T[53]);
  	            c = II(c, d, a, b, M_offset_10, 15, T[54]);
  	            b = II(b, c, d, a, M_offset_1,  21, T[55]);
  	            a = II(a, b, c, d, M_offset_8,  6,  T[56]);
  	            d = II(d, a, b, c, M_offset_15, 10, T[57]);
  	            c = II(c, d, a, b, M_offset_6,  15, T[58]);
  	            b = II(b, c, d, a, M_offset_13, 21, T[59]);
  	            a = II(a, b, c, d, M_offset_4,  6,  T[60]);
  	            d = II(d, a, b, c, M_offset_11, 10, T[61]);
  	            c = II(c, d, a, b, M_offset_2,  15, T[62]);
  	            b = II(b, c, d, a, M_offset_9,  21, T[63]);
  	            H[0] = (H[0] + a) | 0;
  	            H[1] = (H[1] + b) | 0;
  	            H[2] = (H[2] + c) | 0;
  	            H[3] = (H[3] + d) | 0;
  	        },
  	        _doFinalize: function () {
  	            var data = this._data;
  	            var dataWords = data.words;
  	            var nBitsTotal = this._nDataBytes * 8;
  	            var nBitsLeft = data.sigBytes * 8;
  	            dataWords[nBitsLeft >>> 5] |= 0x80 << (24 - nBitsLeft % 32);
  	            var nBitsTotalH = Math.floor(nBitsTotal / 0x100000000);
  	            var nBitsTotalL = nBitsTotal;
  	            dataWords[(((nBitsLeft + 64) >>> 9) << 4) + 15] = (
  	                (((nBitsTotalH << 8)  | (nBitsTotalH >>> 24)) & 0x00ff00ff) |
  	                (((nBitsTotalH << 24) | (nBitsTotalH >>> 8))  & 0xff00ff00)
  	            );
  	            dataWords[(((nBitsLeft + 64) >>> 9) << 4) + 14] = (
  	                (((nBitsTotalL << 8)  | (nBitsTotalL >>> 24)) & 0x00ff00ff) |
  	                (((nBitsTotalL << 24) | (nBitsTotalL >>> 8))  & 0xff00ff00)
  	            );
  	            data.sigBytes = (dataWords.length + 1) * 4;
  	            this._process();
  	            var hash = this._hash;
  	            var H = hash.words;
  	            for (var i = 0; i < 4; i++) {
  	                var H_i = H[i];
  	                H[i] = (((H_i << 8)  | (H_i >>> 24)) & 0x00ff00ff) |
  	                       (((H_i << 24) | (H_i >>> 8))  & 0xff00ff00);
  	            }
  	            return hash;
  	        },
  	        clone: function () {
  	            var clone = Hasher.clone.call(this);
  	            clone._hash = this._hash.clone();
  	            return clone;
  	        }
  	    });
  	    function FF(a, b, c, d, x, s, t) {
  	        var n = a + ((b & c) | (~b & d)) + x + t;
  	        return ((n << s) | (n >>> (32 - s))) + b;
  	    }
  	    function GG(a, b, c, d, x, s, t) {
  	        var n = a + ((b & d) | (c & ~d)) + x + t;
  	        return ((n << s) | (n >>> (32 - s))) + b;
  	    }
  	    function HH(a, b, c, d, x, s, t) {
  	        var n = a + (b ^ c ^ d) + x + t;
  	        return ((n << s) | (n >>> (32 - s))) + b;
  	    }
  	    function II(a, b, c, d, x, s, t) {
  	        var n = a + (c ^ (b | ~d)) + x + t;
  	        return ((n << s) | (n >>> (32 - s))) + b;
  	    }
  	    C.MD5 = Hasher._createHelper(MD5);
  	    C.HmacMD5 = Hasher._createHmacHelper(MD5);
  	}(Math));
  	return CryptoJS.MD5;
  }));
  });

  var sha1 = createCommonjsModule(function (module, exports) {
  (function (root, factory) {
  	{
  		module.exports = exports = factory(core);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	(function () {
  	    var C = CryptoJS;
  	    var C_lib = C.lib;
  	    var WordArray = C_lib.WordArray;
  	    var Hasher = C_lib.Hasher;
  	    var C_algo = C.algo;
  	    var W = [];
  	    var SHA1 = C_algo.SHA1 = Hasher.extend({
  	        _doReset: function () {
  	            this._hash = new WordArray.init([
  	                0x67452301, 0xefcdab89,
  	                0x98badcfe, 0x10325476,
  	                0xc3d2e1f0
  	            ]);
  	        },
  	        _doProcessBlock: function (M, offset) {
  	            var H = this._hash.words;
  	            var a = H[0];
  	            var b = H[1];
  	            var c = H[2];
  	            var d = H[3];
  	            var e = H[4];
  	            for (var i = 0; i < 80; i++) {
  	                if (i < 16) {
  	                    W[i] = M[offset + i] | 0;
  	                } else {
  	                    var n = W[i - 3] ^ W[i - 8] ^ W[i - 14] ^ W[i - 16];
  	                    W[i] = (n << 1) | (n >>> 31);
  	                }
  	                var t = ((a << 5) | (a >>> 27)) + e + W[i];
  	                if (i < 20) {
  	                    t += ((b & c) | (~b & d)) + 0x5a827999;
  	                } else if (i < 40) {
  	                    t += (b ^ c ^ d) + 0x6ed9eba1;
  	                } else if (i < 60) {
  	                    t += ((b & c) | (b & d) | (c & d)) - 0x70e44324;
  	                } else  {
  	                    t += (b ^ c ^ d) - 0x359d3e2a;
  	                }
  	                e = d;
  	                d = c;
  	                c = (b << 30) | (b >>> 2);
  	                b = a;
  	                a = t;
  	            }
  	            H[0] = (H[0] + a) | 0;
  	            H[1] = (H[1] + b) | 0;
  	            H[2] = (H[2] + c) | 0;
  	            H[3] = (H[3] + d) | 0;
  	            H[4] = (H[4] + e) | 0;
  	        },
  	        _doFinalize: function () {
  	            var data = this._data;
  	            var dataWords = data.words;
  	            var nBitsTotal = this._nDataBytes * 8;
  	            var nBitsLeft = data.sigBytes * 8;
  	            dataWords[nBitsLeft >>> 5] |= 0x80 << (24 - nBitsLeft % 32);
  	            dataWords[(((nBitsLeft + 64) >>> 9) << 4) + 14] = Math.floor(nBitsTotal / 0x100000000);
  	            dataWords[(((nBitsLeft + 64) >>> 9) << 4) + 15] = nBitsTotal;
  	            data.sigBytes = dataWords.length * 4;
  	            this._process();
  	            return this._hash;
  	        },
  	        clone: function () {
  	            var clone = Hasher.clone.call(this);
  	            clone._hash = this._hash.clone();
  	            return clone;
  	        }
  	    });
  	    C.SHA1 = Hasher._createHelper(SHA1);
  	    C.HmacSHA1 = Hasher._createHmacHelper(SHA1);
  	}());
  	return CryptoJS.SHA1;
  }));
  });

  var sha256 = createCommonjsModule(function (module, exports) {
  (function (root, factory) {
  	{
  		module.exports = exports = factory(core);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	(function (Math) {
  	    var C = CryptoJS;
  	    var C_lib = C.lib;
  	    var WordArray = C_lib.WordArray;
  	    var Hasher = C_lib.Hasher;
  	    var C_algo = C.algo;
  	    var H = [];
  	    var K = [];
  	    (function () {
  	        function isPrime(n) {
  	            var sqrtN = Math.sqrt(n);
  	            for (var factor = 2; factor <= sqrtN; factor++) {
  	                if (!(n % factor)) {
  	                    return false;
  	                }
  	            }
  	            return true;
  	        }
  	        function getFractionalBits(n) {
  	            return ((n - (n | 0)) * 0x100000000) | 0;
  	        }
  	        var n = 2;
  	        var nPrime = 0;
  	        while (nPrime < 64) {
  	            if (isPrime(n)) {
  	                if (nPrime < 8) {
  	                    H[nPrime] = getFractionalBits(Math.pow(n, 1 / 2));
  	                }
  	                K[nPrime] = getFractionalBits(Math.pow(n, 1 / 3));
  	                nPrime++;
  	            }
  	            n++;
  	        }
  	    }());
  	    var W = [];
  	    var SHA256 = C_algo.SHA256 = Hasher.extend({
  	        _doReset: function () {
  	            this._hash = new WordArray.init(H.slice(0));
  	        },
  	        _doProcessBlock: function (M, offset) {
  	            var H = this._hash.words;
  	            var a = H[0];
  	            var b = H[1];
  	            var c = H[2];
  	            var d = H[3];
  	            var e = H[4];
  	            var f = H[5];
  	            var g = H[6];
  	            var h = H[7];
  	            for (var i = 0; i < 64; i++) {
  	                if (i < 16) {
  	                    W[i] = M[offset + i] | 0;
  	                } else {
  	                    var gamma0x = W[i - 15];
  	                    var gamma0  = ((gamma0x << 25) | (gamma0x >>> 7))  ^
  	                                  ((gamma0x << 14) | (gamma0x >>> 18)) ^
  	                                   (gamma0x >>> 3);
  	                    var gamma1x = W[i - 2];
  	                    var gamma1  = ((gamma1x << 15) | (gamma1x >>> 17)) ^
  	                                  ((gamma1x << 13) | (gamma1x >>> 19)) ^
  	                                   (gamma1x >>> 10);
  	                    W[i] = gamma0 + W[i - 7] + gamma1 + W[i - 16];
  	                }
  	                var ch  = (e & f) ^ (~e & g);
  	                var maj = (a & b) ^ (a & c) ^ (b & c);
  	                var sigma0 = ((a << 30) | (a >>> 2)) ^ ((a << 19) | (a >>> 13)) ^ ((a << 10) | (a >>> 22));
  	                var sigma1 = ((e << 26) | (e >>> 6)) ^ ((e << 21) | (e >>> 11)) ^ ((e << 7)  | (e >>> 25));
  	                var t1 = h + sigma1 + ch + K[i] + W[i];
  	                var t2 = sigma0 + maj;
  	                h = g;
  	                g = f;
  	                f = e;
  	                e = (d + t1) | 0;
  	                d = c;
  	                c = b;
  	                b = a;
  	                a = (t1 + t2) | 0;
  	            }
  	            H[0] = (H[0] + a) | 0;
  	            H[1] = (H[1] + b) | 0;
  	            H[2] = (H[2] + c) | 0;
  	            H[3] = (H[3] + d) | 0;
  	            H[4] = (H[4] + e) | 0;
  	            H[5] = (H[5] + f) | 0;
  	            H[6] = (H[6] + g) | 0;
  	            H[7] = (H[7] + h) | 0;
  	        },
  	        _doFinalize: function () {
  	            var data = this._data;
  	            var dataWords = data.words;
  	            var nBitsTotal = this._nDataBytes * 8;
  	            var nBitsLeft = data.sigBytes * 8;
  	            dataWords[nBitsLeft >>> 5] |= 0x80 << (24 - nBitsLeft % 32);
  	            dataWords[(((nBitsLeft + 64) >>> 9) << 4) + 14] = Math.floor(nBitsTotal / 0x100000000);
  	            dataWords[(((nBitsLeft + 64) >>> 9) << 4) + 15] = nBitsTotal;
  	            data.sigBytes = dataWords.length * 4;
  	            this._process();
  	            return this._hash;
  	        },
  	        clone: function () {
  	            var clone = Hasher.clone.call(this);
  	            clone._hash = this._hash.clone();
  	            return clone;
  	        }
  	    });
  	    C.SHA256 = Hasher._createHelper(SHA256);
  	    C.HmacSHA256 = Hasher._createHmacHelper(SHA256);
  	}(Math));
  	return CryptoJS.SHA256;
  }));
  });

  var sha224 = createCommonjsModule(function (module, exports) {
  (function (root, factory, undef) {
  	{
  		module.exports = exports = factory(core, sha256);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	(function () {
  	    var C = CryptoJS;
  	    var C_lib = C.lib;
  	    var WordArray = C_lib.WordArray;
  	    var C_algo = C.algo;
  	    var SHA256 = C_algo.SHA256;
  	    var SHA224 = C_algo.SHA224 = SHA256.extend({
  	        _doReset: function () {
  	            this._hash = new WordArray.init([
  	                0xc1059ed8, 0x367cd507, 0x3070dd17, 0xf70e5939,
  	                0xffc00b31, 0x68581511, 0x64f98fa7, 0xbefa4fa4
  	            ]);
  	        },
  	        _doFinalize: function () {
  	            var hash = SHA256._doFinalize.call(this);
  	            hash.sigBytes -= 4;
  	            return hash;
  	        }
  	    });
  	    C.SHA224 = SHA256._createHelper(SHA224);
  	    C.HmacSHA224 = SHA256._createHmacHelper(SHA224);
  	}());
  	return CryptoJS.SHA224;
  }));
  });

  var sha512 = createCommonjsModule(function (module, exports) {
  (function (root, factory, undef) {
  	{
  		module.exports = exports = factory(core, x64Core);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	(function () {
  	    var C = CryptoJS;
  	    var C_lib = C.lib;
  	    var Hasher = C_lib.Hasher;
  	    var C_x64 = C.x64;
  	    var X64Word = C_x64.Word;
  	    var X64WordArray = C_x64.WordArray;
  	    var C_algo = C.algo;
  	    function X64Word_create() {
  	        return X64Word.create.apply(X64Word, arguments);
  	    }
  	    var K = [
  	        X64Word_create(0x428a2f98, 0xd728ae22), X64Word_create(0x71374491, 0x23ef65cd),
  	        X64Word_create(0xb5c0fbcf, 0xec4d3b2f), X64Word_create(0xe9b5dba5, 0x8189dbbc),
  	        X64Word_create(0x3956c25b, 0xf348b538), X64Word_create(0x59f111f1, 0xb605d019),
  	        X64Word_create(0x923f82a4, 0xaf194f9b), X64Word_create(0xab1c5ed5, 0xda6d8118),
  	        X64Word_create(0xd807aa98, 0xa3030242), X64Word_create(0x12835b01, 0x45706fbe),
  	        X64Word_create(0x243185be, 0x4ee4b28c), X64Word_create(0x550c7dc3, 0xd5ffb4e2),
  	        X64Word_create(0x72be5d74, 0xf27b896f), X64Word_create(0x80deb1fe, 0x3b1696b1),
  	        X64Word_create(0x9bdc06a7, 0x25c71235), X64Word_create(0xc19bf174, 0xcf692694),
  	        X64Word_create(0xe49b69c1, 0x9ef14ad2), X64Word_create(0xefbe4786, 0x384f25e3),
  	        X64Word_create(0x0fc19dc6, 0x8b8cd5b5), X64Word_create(0x240ca1cc, 0x77ac9c65),
  	        X64Word_create(0x2de92c6f, 0x592b0275), X64Word_create(0x4a7484aa, 0x6ea6e483),
  	        X64Word_create(0x5cb0a9dc, 0xbd41fbd4), X64Word_create(0x76f988da, 0x831153b5),
  	        X64Word_create(0x983e5152, 0xee66dfab), X64Word_create(0xa831c66d, 0x2db43210),
  	        X64Word_create(0xb00327c8, 0x98fb213f), X64Word_create(0xbf597fc7, 0xbeef0ee4),
  	        X64Word_create(0xc6e00bf3, 0x3da88fc2), X64Word_create(0xd5a79147, 0x930aa725),
  	        X64Word_create(0x06ca6351, 0xe003826f), X64Word_create(0x14292967, 0x0a0e6e70),
  	        X64Word_create(0x27b70a85, 0x46d22ffc), X64Word_create(0x2e1b2138, 0x5c26c926),
  	        X64Word_create(0x4d2c6dfc, 0x5ac42aed), X64Word_create(0x53380d13, 0x9d95b3df),
  	        X64Word_create(0x650a7354, 0x8baf63de), X64Word_create(0x766a0abb, 0x3c77b2a8),
  	        X64Word_create(0x81c2c92e, 0x47edaee6), X64Word_create(0x92722c85, 0x1482353b),
  	        X64Word_create(0xa2bfe8a1, 0x4cf10364), X64Word_create(0xa81a664b, 0xbc423001),
  	        X64Word_create(0xc24b8b70, 0xd0f89791), X64Word_create(0xc76c51a3, 0x0654be30),
  	        X64Word_create(0xd192e819, 0xd6ef5218), X64Word_create(0xd6990624, 0x5565a910),
  	        X64Word_create(0xf40e3585, 0x5771202a), X64Word_create(0x106aa070, 0x32bbd1b8),
  	        X64Word_create(0x19a4c116, 0xb8d2d0c8), X64Word_create(0x1e376c08, 0x5141ab53),
  	        X64Word_create(0x2748774c, 0xdf8eeb99), X64Word_create(0x34b0bcb5, 0xe19b48a8),
  	        X64Word_create(0x391c0cb3, 0xc5c95a63), X64Word_create(0x4ed8aa4a, 0xe3418acb),
  	        X64Word_create(0x5b9cca4f, 0x7763e373), X64Word_create(0x682e6ff3, 0xd6b2b8a3),
  	        X64Word_create(0x748f82ee, 0x5defb2fc), X64Word_create(0x78a5636f, 0x43172f60),
  	        X64Word_create(0x84c87814, 0xa1f0ab72), X64Word_create(0x8cc70208, 0x1a6439ec),
  	        X64Word_create(0x90befffa, 0x23631e28), X64Word_create(0xa4506ceb, 0xde82bde9),
  	        X64Word_create(0xbef9a3f7, 0xb2c67915), X64Word_create(0xc67178f2, 0xe372532b),
  	        X64Word_create(0xca273ece, 0xea26619c), X64Word_create(0xd186b8c7, 0x21c0c207),
  	        X64Word_create(0xeada7dd6, 0xcde0eb1e), X64Word_create(0xf57d4f7f, 0xee6ed178),
  	        X64Word_create(0x06f067aa, 0x72176fba), X64Word_create(0x0a637dc5, 0xa2c898a6),
  	        X64Word_create(0x113f9804, 0xbef90dae), X64Word_create(0x1b710b35, 0x131c471b),
  	        X64Word_create(0x28db77f5, 0x23047d84), X64Word_create(0x32caab7b, 0x40c72493),
  	        X64Word_create(0x3c9ebe0a, 0x15c9bebc), X64Word_create(0x431d67c4, 0x9c100d4c),
  	        X64Word_create(0x4cc5d4be, 0xcb3e42b6), X64Word_create(0x597f299c, 0xfc657e2a),
  	        X64Word_create(0x5fcb6fab, 0x3ad6faec), X64Word_create(0x6c44198c, 0x4a475817)
  	    ];
  	    var W = [];
  	    (function () {
  	        for (var i = 0; i < 80; i++) {
  	            W[i] = X64Word_create();
  	        }
  	    }());
  	    var SHA512 = C_algo.SHA512 = Hasher.extend({
  	        _doReset: function () {
  	            this._hash = new X64WordArray.init([
  	                new X64Word.init(0x6a09e667, 0xf3bcc908), new X64Word.init(0xbb67ae85, 0x84caa73b),
  	                new X64Word.init(0x3c6ef372, 0xfe94f82b), new X64Word.init(0xa54ff53a, 0x5f1d36f1),
  	                new X64Word.init(0x510e527f, 0xade682d1), new X64Word.init(0x9b05688c, 0x2b3e6c1f),
  	                new X64Word.init(0x1f83d9ab, 0xfb41bd6b), new X64Word.init(0x5be0cd19, 0x137e2179)
  	            ]);
  	        },
  	        _doProcessBlock: function (M, offset) {
  	            var H = this._hash.words;
  	            var H0 = H[0];
  	            var H1 = H[1];
  	            var H2 = H[2];
  	            var H3 = H[3];
  	            var H4 = H[4];
  	            var H5 = H[5];
  	            var H6 = H[6];
  	            var H7 = H[7];
  	            var H0h = H0.high;
  	            var H0l = H0.low;
  	            var H1h = H1.high;
  	            var H1l = H1.low;
  	            var H2h = H2.high;
  	            var H2l = H2.low;
  	            var H3h = H3.high;
  	            var H3l = H3.low;
  	            var H4h = H4.high;
  	            var H4l = H4.low;
  	            var H5h = H5.high;
  	            var H5l = H5.low;
  	            var H6h = H6.high;
  	            var H6l = H6.low;
  	            var H7h = H7.high;
  	            var H7l = H7.low;
  	            var ah = H0h;
  	            var al = H0l;
  	            var bh = H1h;
  	            var bl = H1l;
  	            var ch = H2h;
  	            var cl = H2l;
  	            var dh = H3h;
  	            var dl = H3l;
  	            var eh = H4h;
  	            var el = H4l;
  	            var fh = H5h;
  	            var fl = H5l;
  	            var gh = H6h;
  	            var gl = H6l;
  	            var hh = H7h;
  	            var hl = H7l;
  	            for (var i = 0; i < 80; i++) {
  	                var Wil;
  	                var Wih;
  	                var Wi = W[i];
  	                if (i < 16) {
  	                    Wih = Wi.high = M[offset + i * 2]     | 0;
  	                    Wil = Wi.low  = M[offset + i * 2 + 1] | 0;
  	                } else {
  	                    var gamma0x  = W[i - 15];
  	                    var gamma0xh = gamma0x.high;
  	                    var gamma0xl = gamma0x.low;
  	                    var gamma0h  = ((gamma0xh >>> 1) | (gamma0xl << 31)) ^ ((gamma0xh >>> 8) | (gamma0xl << 24)) ^ (gamma0xh >>> 7);
  	                    var gamma0l  = ((gamma0xl >>> 1) | (gamma0xh << 31)) ^ ((gamma0xl >>> 8) | (gamma0xh << 24)) ^ ((gamma0xl >>> 7) | (gamma0xh << 25));
  	                    var gamma1x  = W[i - 2];
  	                    var gamma1xh = gamma1x.high;
  	                    var gamma1xl = gamma1x.low;
  	                    var gamma1h  = ((gamma1xh >>> 19) | (gamma1xl << 13)) ^ ((gamma1xh << 3) | (gamma1xl >>> 29)) ^ (gamma1xh >>> 6);
  	                    var gamma1l  = ((gamma1xl >>> 19) | (gamma1xh << 13)) ^ ((gamma1xl << 3) | (gamma1xh >>> 29)) ^ ((gamma1xl >>> 6) | (gamma1xh << 26));
  	                    var Wi7  = W[i - 7];
  	                    var Wi7h = Wi7.high;
  	                    var Wi7l = Wi7.low;
  	                    var Wi16  = W[i - 16];
  	                    var Wi16h = Wi16.high;
  	                    var Wi16l = Wi16.low;
  	                    Wil = gamma0l + Wi7l;
  	                    Wih = gamma0h + Wi7h + ((Wil >>> 0) < (gamma0l >>> 0) ? 1 : 0);
  	                    Wil = Wil + gamma1l;
  	                    Wih = Wih + gamma1h + ((Wil >>> 0) < (gamma1l >>> 0) ? 1 : 0);
  	                    Wil = Wil + Wi16l;
  	                    Wih = Wih + Wi16h + ((Wil >>> 0) < (Wi16l >>> 0) ? 1 : 0);
  	                    Wi.high = Wih;
  	                    Wi.low  = Wil;
  	                }
  	                var chh  = (eh & fh) ^ (~eh & gh);
  	                var chl  = (el & fl) ^ (~el & gl);
  	                var majh = (ah & bh) ^ (ah & ch) ^ (bh & ch);
  	                var majl = (al & bl) ^ (al & cl) ^ (bl & cl);
  	                var sigma0h = ((ah >>> 28) | (al << 4))  ^ ((ah << 30)  | (al >>> 2)) ^ ((ah << 25) | (al >>> 7));
  	                var sigma0l = ((al >>> 28) | (ah << 4))  ^ ((al << 30)  | (ah >>> 2)) ^ ((al << 25) | (ah >>> 7));
  	                var sigma1h = ((eh >>> 14) | (el << 18)) ^ ((eh >>> 18) | (el << 14)) ^ ((eh << 23) | (el >>> 9));
  	                var sigma1l = ((el >>> 14) | (eh << 18)) ^ ((el >>> 18) | (eh << 14)) ^ ((el << 23) | (eh >>> 9));
  	                var Ki  = K[i];
  	                var Kih = Ki.high;
  	                var Kil = Ki.low;
  	                var t1l = hl + sigma1l;
  	                var t1h = hh + sigma1h + ((t1l >>> 0) < (hl >>> 0) ? 1 : 0);
  	                var t1l = t1l + chl;
  	                var t1h = t1h + chh + ((t1l >>> 0) < (chl >>> 0) ? 1 : 0);
  	                var t1l = t1l + Kil;
  	                var t1h = t1h + Kih + ((t1l >>> 0) < (Kil >>> 0) ? 1 : 0);
  	                var t1l = t1l + Wil;
  	                var t1h = t1h + Wih + ((t1l >>> 0) < (Wil >>> 0) ? 1 : 0);
  	                var t2l = sigma0l + majl;
  	                var t2h = sigma0h + majh + ((t2l >>> 0) < (sigma0l >>> 0) ? 1 : 0);
  	                hh = gh;
  	                hl = gl;
  	                gh = fh;
  	                gl = fl;
  	                fh = eh;
  	                fl = el;
  	                el = (dl + t1l) | 0;
  	                eh = (dh + t1h + ((el >>> 0) < (dl >>> 0) ? 1 : 0)) | 0;
  	                dh = ch;
  	                dl = cl;
  	                ch = bh;
  	                cl = bl;
  	                bh = ah;
  	                bl = al;
  	                al = (t1l + t2l) | 0;
  	                ah = (t1h + t2h + ((al >>> 0) < (t1l >>> 0) ? 1 : 0)) | 0;
  	            }
  	            H0l = H0.low  = (H0l + al);
  	            H0.high = (H0h + ah + ((H0l >>> 0) < (al >>> 0) ? 1 : 0));
  	            H1l = H1.low  = (H1l + bl);
  	            H1.high = (H1h + bh + ((H1l >>> 0) < (bl >>> 0) ? 1 : 0));
  	            H2l = H2.low  = (H2l + cl);
  	            H2.high = (H2h + ch + ((H2l >>> 0) < (cl >>> 0) ? 1 : 0));
  	            H3l = H3.low  = (H3l + dl);
  	            H3.high = (H3h + dh + ((H3l >>> 0) < (dl >>> 0) ? 1 : 0));
  	            H4l = H4.low  = (H4l + el);
  	            H4.high = (H4h + eh + ((H4l >>> 0) < (el >>> 0) ? 1 : 0));
  	            H5l = H5.low  = (H5l + fl);
  	            H5.high = (H5h + fh + ((H5l >>> 0) < (fl >>> 0) ? 1 : 0));
  	            H6l = H6.low  = (H6l + gl);
  	            H6.high = (H6h + gh + ((H6l >>> 0) < (gl >>> 0) ? 1 : 0));
  	            H7l = H7.low  = (H7l + hl);
  	            H7.high = (H7h + hh + ((H7l >>> 0) < (hl >>> 0) ? 1 : 0));
  	        },
  	        _doFinalize: function () {
  	            var data = this._data;
  	            var dataWords = data.words;
  	            var nBitsTotal = this._nDataBytes * 8;
  	            var nBitsLeft = data.sigBytes * 8;
  	            dataWords[nBitsLeft >>> 5] |= 0x80 << (24 - nBitsLeft % 32);
  	            dataWords[(((nBitsLeft + 128) >>> 10) << 5) + 30] = Math.floor(nBitsTotal / 0x100000000);
  	            dataWords[(((nBitsLeft + 128) >>> 10) << 5) + 31] = nBitsTotal;
  	            data.sigBytes = dataWords.length * 4;
  	            this._process();
  	            var hash = this._hash.toX32();
  	            return hash;
  	        },
  	        clone: function () {
  	            var clone = Hasher.clone.call(this);
  	            clone._hash = this._hash.clone();
  	            return clone;
  	        },
  	        blockSize: 1024/32
  	    });
  	    C.SHA512 = Hasher._createHelper(SHA512);
  	    C.HmacSHA512 = Hasher._createHmacHelper(SHA512);
  	}());
  	return CryptoJS.SHA512;
  }));
  });

  var sha384 = createCommonjsModule(function (module, exports) {
  (function (root, factory, undef) {
  	{
  		module.exports = exports = factory(core, x64Core, sha512);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	(function () {
  	    var C = CryptoJS;
  	    var C_x64 = C.x64;
  	    var X64Word = C_x64.Word;
  	    var X64WordArray = C_x64.WordArray;
  	    var C_algo = C.algo;
  	    var SHA512 = C_algo.SHA512;
  	    var SHA384 = C_algo.SHA384 = SHA512.extend({
  	        _doReset: function () {
  	            this._hash = new X64WordArray.init([
  	                new X64Word.init(0xcbbb9d5d, 0xc1059ed8), new X64Word.init(0x629a292a, 0x367cd507),
  	                new X64Word.init(0x9159015a, 0x3070dd17), new X64Word.init(0x152fecd8, 0xf70e5939),
  	                new X64Word.init(0x67332667, 0xffc00b31), new X64Word.init(0x8eb44a87, 0x68581511),
  	                new X64Word.init(0xdb0c2e0d, 0x64f98fa7), new X64Word.init(0x47b5481d, 0xbefa4fa4)
  	            ]);
  	        },
  	        _doFinalize: function () {
  	            var hash = SHA512._doFinalize.call(this);
  	            hash.sigBytes -= 16;
  	            return hash;
  	        }
  	    });
  	    C.SHA384 = SHA512._createHelper(SHA384);
  	    C.HmacSHA384 = SHA512._createHmacHelper(SHA384);
  	}());
  	return CryptoJS.SHA384;
  }));
  });

  var sha3 = createCommonjsModule(function (module, exports) {
  (function (root, factory, undef) {
  	{
  		module.exports = exports = factory(core, x64Core);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	(function (Math) {
  	    var C = CryptoJS;
  	    var C_lib = C.lib;
  	    var WordArray = C_lib.WordArray;
  	    var Hasher = C_lib.Hasher;
  	    var C_x64 = C.x64;
  	    var X64Word = C_x64.Word;
  	    var C_algo = C.algo;
  	    var RHO_OFFSETS = [];
  	    var PI_INDEXES  = [];
  	    var ROUND_CONSTANTS = [];
  	    (function () {
  	        var x = 1, y = 0;
  	        for (var t = 0; t < 24; t++) {
  	            RHO_OFFSETS[x + 5 * y] = ((t + 1) * (t + 2) / 2) % 64;
  	            var newX = y % 5;
  	            var newY = (2 * x + 3 * y) % 5;
  	            x = newX;
  	            y = newY;
  	        }
  	        for (var x = 0; x < 5; x++) {
  	            for (var y = 0; y < 5; y++) {
  	                PI_INDEXES[x + 5 * y] = y + ((2 * x + 3 * y) % 5) * 5;
  	            }
  	        }
  	        var LFSR = 0x01;
  	        for (var i = 0; i < 24; i++) {
  	            var roundConstantMsw = 0;
  	            var roundConstantLsw = 0;
  	            for (var j = 0; j < 7; j++) {
  	                if (LFSR & 0x01) {
  	                    var bitPosition = (1 << j) - 1;
  	                    if (bitPosition < 32) {
  	                        roundConstantLsw ^= 1 << bitPosition;
  	                    } else  {
  	                        roundConstantMsw ^= 1 << (bitPosition - 32);
  	                    }
  	                }
  	                if (LFSR & 0x80) {
  	                    LFSR = (LFSR << 1) ^ 0x71;
  	                } else {
  	                    LFSR <<= 1;
  	                }
  	            }
  	            ROUND_CONSTANTS[i] = X64Word.create(roundConstantMsw, roundConstantLsw);
  	        }
  	    }());
  	    var T = [];
  	    (function () {
  	        for (var i = 0; i < 25; i++) {
  	            T[i] = X64Word.create();
  	        }
  	    }());
  	    var SHA3 = C_algo.SHA3 = Hasher.extend({
  	        cfg: Hasher.cfg.extend({
  	            outputLength: 512
  	        }),
  	        _doReset: function () {
  	            var state = this._state = [];
  	            for (var i = 0; i < 25; i++) {
  	                state[i] = new X64Word.init();
  	            }
  	            this.blockSize = (1600 - 2 * this.cfg.outputLength) / 32;
  	        },
  	        _doProcessBlock: function (M, offset) {
  	            var state = this._state;
  	            var nBlockSizeLanes = this.blockSize / 2;
  	            for (var i = 0; i < nBlockSizeLanes; i++) {
  	                var M2i  = M[offset + 2 * i];
  	                var M2i1 = M[offset + 2 * i + 1];
  	                M2i = (
  	                    (((M2i << 8)  | (M2i >>> 24)) & 0x00ff00ff) |
  	                    (((M2i << 24) | (M2i >>> 8))  & 0xff00ff00)
  	                );
  	                M2i1 = (
  	                    (((M2i1 << 8)  | (M2i1 >>> 24)) & 0x00ff00ff) |
  	                    (((M2i1 << 24) | (M2i1 >>> 8))  & 0xff00ff00)
  	                );
  	                var lane = state[i];
  	                lane.high ^= M2i1;
  	                lane.low  ^= M2i;
  	            }
  	            for (var round = 0; round < 24; round++) {
  	                for (var x = 0; x < 5; x++) {
  	                    var tMsw = 0, tLsw = 0;
  	                    for (var y = 0; y < 5; y++) {
  	                        var lane = state[x + 5 * y];
  	                        tMsw ^= lane.high;
  	                        tLsw ^= lane.low;
  	                    }
  	                    var Tx = T[x];
  	                    Tx.high = tMsw;
  	                    Tx.low  = tLsw;
  	                }
  	                for (var x = 0; x < 5; x++) {
  	                    var Tx4 = T[(x + 4) % 5];
  	                    var Tx1 = T[(x + 1) % 5];
  	                    var Tx1Msw = Tx1.high;
  	                    var Tx1Lsw = Tx1.low;
  	                    var tMsw = Tx4.high ^ ((Tx1Msw << 1) | (Tx1Lsw >>> 31));
  	                    var tLsw = Tx4.low  ^ ((Tx1Lsw << 1) | (Tx1Msw >>> 31));
  	                    for (var y = 0; y < 5; y++) {
  	                        var lane = state[x + 5 * y];
  	                        lane.high ^= tMsw;
  	                        lane.low  ^= tLsw;
  	                    }
  	                }
  	                for (var laneIndex = 1; laneIndex < 25; laneIndex++) {
  	                    var tMsw;
  	                    var tLsw;
  	                    var lane = state[laneIndex];
  	                    var laneMsw = lane.high;
  	                    var laneLsw = lane.low;
  	                    var rhoOffset = RHO_OFFSETS[laneIndex];
  	                    if (rhoOffset < 32) {
  	                        tMsw = (laneMsw << rhoOffset) | (laneLsw >>> (32 - rhoOffset));
  	                        tLsw = (laneLsw << rhoOffset) | (laneMsw >>> (32 - rhoOffset));
  	                    } else  {
  	                        tMsw = (laneLsw << (rhoOffset - 32)) | (laneMsw >>> (64 - rhoOffset));
  	                        tLsw = (laneMsw << (rhoOffset - 32)) | (laneLsw >>> (64 - rhoOffset));
  	                    }
  	                    var TPiLane = T[PI_INDEXES[laneIndex]];
  	                    TPiLane.high = tMsw;
  	                    TPiLane.low  = tLsw;
  	                }
  	                var T0 = T[0];
  	                var state0 = state[0];
  	                T0.high = state0.high;
  	                T0.low  = state0.low;
  	                for (var x = 0; x < 5; x++) {
  	                    for (var y = 0; y < 5; y++) {
  	                        var laneIndex = x + 5 * y;
  	                        var lane = state[laneIndex];
  	                        var TLane = T[laneIndex];
  	                        var Tx1Lane = T[((x + 1) % 5) + 5 * y];
  	                        var Tx2Lane = T[((x + 2) % 5) + 5 * y];
  	                        lane.high = TLane.high ^ (~Tx1Lane.high & Tx2Lane.high);
  	                        lane.low  = TLane.low  ^ (~Tx1Lane.low  & Tx2Lane.low);
  	                    }
  	                }
  	                var lane = state[0];
  	                var roundConstant = ROUND_CONSTANTS[round];
  	                lane.high ^= roundConstant.high;
  	                lane.low  ^= roundConstant.low;
  	            }
  	        },
  	        _doFinalize: function () {
  	            var data = this._data;
  	            var dataWords = data.words;
  	            var nBitsTotal = this._nDataBytes * 8;
  	            var nBitsLeft = data.sigBytes * 8;
  	            var blockSizeBits = this.blockSize * 32;
  	            dataWords[nBitsLeft >>> 5] |= 0x1 << (24 - nBitsLeft % 32);
  	            dataWords[((Math.ceil((nBitsLeft + 1) / blockSizeBits) * blockSizeBits) >>> 5) - 1] |= 0x80;
  	            data.sigBytes = dataWords.length * 4;
  	            this._process();
  	            var state = this._state;
  	            var outputLengthBytes = this.cfg.outputLength / 8;
  	            var outputLengthLanes = outputLengthBytes / 8;
  	            var hashWords = [];
  	            for (var i = 0; i < outputLengthLanes; i++) {
  	                var lane = state[i];
  	                var laneMsw = lane.high;
  	                var laneLsw = lane.low;
  	                laneMsw = (
  	                    (((laneMsw << 8)  | (laneMsw >>> 24)) & 0x00ff00ff) |
  	                    (((laneMsw << 24) | (laneMsw >>> 8))  & 0xff00ff00)
  	                );
  	                laneLsw = (
  	                    (((laneLsw << 8)  | (laneLsw >>> 24)) & 0x00ff00ff) |
  	                    (((laneLsw << 24) | (laneLsw >>> 8))  & 0xff00ff00)
  	                );
  	                hashWords.push(laneLsw);
  	                hashWords.push(laneMsw);
  	            }
  	            return new WordArray.init(hashWords, outputLengthBytes);
  	        },
  	        clone: function () {
  	            var clone = Hasher.clone.call(this);
  	            var state = clone._state = this._state.slice(0);
  	            for (var i = 0; i < 25; i++) {
  	                state[i] = state[i].clone();
  	            }
  	            return clone;
  	        }
  	    });
  	    C.SHA3 = Hasher._createHelper(SHA3);
  	    C.HmacSHA3 = Hasher._createHmacHelper(SHA3);
  	}(Math));
  	return CryptoJS.SHA3;
  }));
  });

  var ripemd160 = createCommonjsModule(function (module, exports) {
  (function (root, factory) {
  	{
  		module.exports = exports = factory(core);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	/** @preserve
  	(c) 2012 by Cédric Mesnil. All rights reserved.
  	Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
  	    - Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
  	    - Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
  	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  	*/
  	(function (Math) {
  	    var C = CryptoJS;
  	    var C_lib = C.lib;
  	    var WordArray = C_lib.WordArray;
  	    var Hasher = C_lib.Hasher;
  	    var C_algo = C.algo;
  	    var _zl = WordArray.create([
  	        0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
  	        7,  4, 13,  1, 10,  6, 15,  3, 12,  0,  9,  5,  2, 14, 11,  8,
  	        3, 10, 14,  4,  9, 15,  8,  1,  2,  7,  0,  6, 13, 11,  5, 12,
  	        1,  9, 11, 10,  0,  8, 12,  4, 13,  3,  7, 15, 14,  5,  6,  2,
  	        4,  0,  5,  9,  7, 12,  2, 10, 14,  1,  3,  8, 11,  6, 15, 13]);
  	    var _zr = WordArray.create([
  	        5, 14,  7,  0,  9,  2, 11,  4, 13,  6, 15,  8,  1, 10,  3, 12,
  	        6, 11,  3,  7,  0, 13,  5, 10, 14, 15,  8, 12,  4,  9,  1,  2,
  	        15,  5,  1,  3,  7, 14,  6,  9, 11,  8, 12,  2, 10,  0,  4, 13,
  	        8,  6,  4,  1,  3, 11, 15,  0,  5, 12,  2, 13,  9,  7, 10, 14,
  	        12, 15, 10,  4,  1,  5,  8,  7,  6,  2, 13, 14,  0,  3,  9, 11]);
  	    var _sl = WordArray.create([
  	         11, 14, 15, 12,  5,  8,  7,  9, 11, 13, 14, 15,  6,  7,  9,  8,
  	        7, 6,   8, 13, 11,  9,  7, 15,  7, 12, 15,  9, 11,  7, 13, 12,
  	        11, 13,  6,  7, 14,  9, 13, 15, 14,  8, 13,  6,  5, 12,  7,  5,
  	          11, 12, 14, 15, 14, 15,  9,  8,  9, 14,  5,  6,  8,  6,  5, 12,
  	        9, 15,  5, 11,  6,  8, 13, 12,  5, 12, 13, 14, 11,  8,  5,  6 ]);
  	    var _sr = WordArray.create([
  	        8,  9,  9, 11, 13, 15, 15,  5,  7,  7,  8, 11, 14, 14, 12,  6,
  	        9, 13, 15,  7, 12,  8,  9, 11,  7,  7, 12,  7,  6, 15, 13, 11,
  	        9,  7, 15, 11,  8,  6,  6, 14, 12, 13,  5, 14, 13, 13,  7,  5,
  	        15,  5,  8, 11, 14, 14,  6, 14,  6,  9, 12,  9, 12,  5, 15,  8,
  	        8,  5, 12,  9, 12,  5, 14,  6,  8, 13,  6,  5, 15, 13, 11, 11 ]);
  	    var _hl =  WordArray.create([ 0x00000000, 0x5A827999, 0x6ED9EBA1, 0x8F1BBCDC, 0xA953FD4E]);
  	    var _hr =  WordArray.create([ 0x50A28BE6, 0x5C4DD124, 0x6D703EF3, 0x7A6D76E9, 0x00000000]);
  	    var RIPEMD160 = C_algo.RIPEMD160 = Hasher.extend({
  	        _doReset: function () {
  	            this._hash  = WordArray.create([0x67452301, 0xEFCDAB89, 0x98BADCFE, 0x10325476, 0xC3D2E1F0]);
  	        },
  	        _doProcessBlock: function (M, offset) {
  	            for (var i = 0; i < 16; i++) {
  	                var offset_i = offset + i;
  	                var M_offset_i = M[offset_i];
  	                M[offset_i] = (
  	                    (((M_offset_i << 8)  | (M_offset_i >>> 24)) & 0x00ff00ff) |
  	                    (((M_offset_i << 24) | (M_offset_i >>> 8))  & 0xff00ff00)
  	                );
  	            }
  	            var H  = this._hash.words;
  	            var hl = _hl.words;
  	            var hr = _hr.words;
  	            var zl = _zl.words;
  	            var zr = _zr.words;
  	            var sl = _sl.words;
  	            var sr = _sr.words;
  	            var al, bl, cl, dl, el;
  	            var ar, br, cr, dr, er;
  	            ar = al = H[0];
  	            br = bl = H[1];
  	            cr = cl = H[2];
  	            dr = dl = H[3];
  	            er = el = H[4];
  	            var t;
  	            for (var i = 0; i < 80; i += 1) {
  	                t = (al +  M[offset+zl[i]])|0;
  	                if (i<16){
  		            t +=  f1(bl,cl,dl) + hl[0];
  	                } else if (i<32) {
  		            t +=  f2(bl,cl,dl) + hl[1];
  	                } else if (i<48) {
  		            t +=  f3(bl,cl,dl) + hl[2];
  	                } else if (i<64) {
  		            t +=  f4(bl,cl,dl) + hl[3];
  	                } else {
  		            t +=  f5(bl,cl,dl) + hl[4];
  	                }
  	                t = t|0;
  	                t =  rotl(t,sl[i]);
  	                t = (t+el)|0;
  	                al = el;
  	                el = dl;
  	                dl = rotl(cl, 10);
  	                cl = bl;
  	                bl = t;
  	                t = (ar + M[offset+zr[i]])|0;
  	                if (i<16){
  		            t +=  f5(br,cr,dr) + hr[0];
  	                } else if (i<32) {
  		            t +=  f4(br,cr,dr) + hr[1];
  	                } else if (i<48) {
  		            t +=  f3(br,cr,dr) + hr[2];
  	                } else if (i<64) {
  		            t +=  f2(br,cr,dr) + hr[3];
  	                } else {
  		            t +=  f1(br,cr,dr) + hr[4];
  	                }
  	                t = t|0;
  	                t =  rotl(t,sr[i]) ;
  	                t = (t+er)|0;
  	                ar = er;
  	                er = dr;
  	                dr = rotl(cr, 10);
  	                cr = br;
  	                br = t;
  	            }
  	            t    = (H[1] + cl + dr)|0;
  	            H[1] = (H[2] + dl + er)|0;
  	            H[2] = (H[3] + el + ar)|0;
  	            H[3] = (H[4] + al + br)|0;
  	            H[4] = (H[0] + bl + cr)|0;
  	            H[0] =  t;
  	        },
  	        _doFinalize: function () {
  	            var data = this._data;
  	            var dataWords = data.words;
  	            var nBitsTotal = this._nDataBytes * 8;
  	            var nBitsLeft = data.sigBytes * 8;
  	            dataWords[nBitsLeft >>> 5] |= 0x80 << (24 - nBitsLeft % 32);
  	            dataWords[(((nBitsLeft + 64) >>> 9) << 4) + 14] = (
  	                (((nBitsTotal << 8)  | (nBitsTotal >>> 24)) & 0x00ff00ff) |
  	                (((nBitsTotal << 24) | (nBitsTotal >>> 8))  & 0xff00ff00)
  	            );
  	            data.sigBytes = (dataWords.length + 1) * 4;
  	            this._process();
  	            var hash = this._hash;
  	            var H = hash.words;
  	            for (var i = 0; i < 5; i++) {
  	                var H_i = H[i];
  	                H[i] = (((H_i << 8)  | (H_i >>> 24)) & 0x00ff00ff) |
  	                       (((H_i << 24) | (H_i >>> 8))  & 0xff00ff00);
  	            }
  	            return hash;
  	        },
  	        clone: function () {
  	            var clone = Hasher.clone.call(this);
  	            clone._hash = this._hash.clone();
  	            return clone;
  	        }
  	    });
  	    function f1(x, y, z) {
  	        return ((x) ^ (y) ^ (z));
  	    }
  	    function f2(x, y, z) {
  	        return (((x)&(y)) | ((~x)&(z)));
  	    }
  	    function f3(x, y, z) {
  	        return (((x) | (~(y))) ^ (z));
  	    }
  	    function f4(x, y, z) {
  	        return (((x) & (z)) | ((y)&(~(z))));
  	    }
  	    function f5(x, y, z) {
  	        return ((x) ^ ((y) |(~(z))));
  	    }
  	    function rotl(x,n) {
  	        return (x<<n) | (x>>>(32-n));
  	    }
  	    C.RIPEMD160 = Hasher._createHelper(RIPEMD160);
  	    C.HmacRIPEMD160 = Hasher._createHmacHelper(RIPEMD160);
  	}());
  	return CryptoJS.RIPEMD160;
  }));
  });

  var hmac = createCommonjsModule(function (module, exports) {
  (function (root, factory) {
  	{
  		module.exports = exports = factory(core);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	(function () {
  	    var C = CryptoJS;
  	    var C_lib = C.lib;
  	    var Base = C_lib.Base;
  	    var C_enc = C.enc;
  	    var Utf8 = C_enc.Utf8;
  	    var C_algo = C.algo;
  	    var HMAC = C_algo.HMAC = Base.extend({
  	        init: function (hasher, key) {
  	            hasher = this._hasher = new hasher.init();
  	            if (typeof key == 'string') {
  	                key = Utf8.parse(key);
  	            }
  	            var hasherBlockSize = hasher.blockSize;
  	            var hasherBlockSizeBytes = hasherBlockSize * 4;
  	            if (key.sigBytes > hasherBlockSizeBytes) {
  	                key = hasher.finalize(key);
  	            }
  	            key.clamp();
  	            var oKey = this._oKey = key.clone();
  	            var iKey = this._iKey = key.clone();
  	            var oKeyWords = oKey.words;
  	            var iKeyWords = iKey.words;
  	            for (var i = 0; i < hasherBlockSize; i++) {
  	                oKeyWords[i] ^= 0x5c5c5c5c;
  	                iKeyWords[i] ^= 0x36363636;
  	            }
  	            oKey.sigBytes = iKey.sigBytes = hasherBlockSizeBytes;
  	            this.reset();
  	        },
  	        reset: function () {
  	            var hasher = this._hasher;
  	            hasher.reset();
  	            hasher.update(this._iKey);
  	        },
  	        update: function (messageUpdate) {
  	            this._hasher.update(messageUpdate);
  	            return this;
  	        },
  	        finalize: function (messageUpdate) {
  	            var hasher = this._hasher;
  	            var innerHash = hasher.finalize(messageUpdate);
  	            hasher.reset();
  	            var hmac = hasher.finalize(this._oKey.clone().concat(innerHash));
  	            return hmac;
  	        }
  	    });
  	}());
  }));
  });

  var pbkdf2 = createCommonjsModule(function (module, exports) {
  (function (root, factory, undef) {
  	{
  		module.exports = exports = factory(core, sha1, hmac);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	(function () {
  	    var C = CryptoJS;
  	    var C_lib = C.lib;
  	    var Base = C_lib.Base;
  	    var WordArray = C_lib.WordArray;
  	    var C_algo = C.algo;
  	    var SHA1 = C_algo.SHA1;
  	    var HMAC = C_algo.HMAC;
  	    var PBKDF2 = C_algo.PBKDF2 = Base.extend({
  	        cfg: Base.extend({
  	            keySize: 128/32,
  	            hasher: SHA1,
  	            iterations: 1
  	        }),
  	        init: function (cfg) {
  	            this.cfg = this.cfg.extend(cfg);
  	        },
  	        compute: function (password, salt) {
  	            var cfg = this.cfg;
  	            var hmac = HMAC.create(cfg.hasher, password);
  	            var derivedKey = WordArray.create();
  	            var blockIndex = WordArray.create([0x00000001]);
  	            var derivedKeyWords = derivedKey.words;
  	            var blockIndexWords = blockIndex.words;
  	            var keySize = cfg.keySize;
  	            var iterations = cfg.iterations;
  	            while (derivedKeyWords.length < keySize) {
  	                var block = hmac.update(salt).finalize(blockIndex);
  	                hmac.reset();
  	                var blockWords = block.words;
  	                var blockWordsLength = blockWords.length;
  	                var intermediate = block;
  	                for (var i = 1; i < iterations; i++) {
  	                    intermediate = hmac.finalize(intermediate);
  	                    hmac.reset();
  	                    var intermediateWords = intermediate.words;
  	                    for (var j = 0; j < blockWordsLength; j++) {
  	                        blockWords[j] ^= intermediateWords[j];
  	                    }
  	                }
  	                derivedKey.concat(block);
  	                blockIndexWords[0]++;
  	            }
  	            derivedKey.sigBytes = keySize * 4;
  	            return derivedKey;
  	        }
  	    });
  	    C.PBKDF2 = function (password, salt, cfg) {
  	        return PBKDF2.create(cfg).compute(password, salt);
  	    };
  	}());
  	return CryptoJS.PBKDF2;
  }));
  });

  var evpkdf = createCommonjsModule(function (module, exports) {
  (function (root, factory, undef) {
  	{
  		module.exports = exports = factory(core, sha1, hmac);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	(function () {
  	    var C = CryptoJS;
  	    var C_lib = C.lib;
  	    var Base = C_lib.Base;
  	    var WordArray = C_lib.WordArray;
  	    var C_algo = C.algo;
  	    var MD5 = C_algo.MD5;
  	    var EvpKDF = C_algo.EvpKDF = Base.extend({
  	        cfg: Base.extend({
  	            keySize: 128/32,
  	            hasher: MD5,
  	            iterations: 1
  	        }),
  	        init: function (cfg) {
  	            this.cfg = this.cfg.extend(cfg);
  	        },
  	        compute: function (password, salt) {
  	            var block;
  	            var cfg = this.cfg;
  	            var hasher = cfg.hasher.create();
  	            var derivedKey = WordArray.create();
  	            var derivedKeyWords = derivedKey.words;
  	            var keySize = cfg.keySize;
  	            var iterations = cfg.iterations;
  	            while (derivedKeyWords.length < keySize) {
  	                if (block) {
  	                    hasher.update(block);
  	                }
  	                block = hasher.update(password).finalize(salt);
  	                hasher.reset();
  	                for (var i = 1; i < iterations; i++) {
  	                    block = hasher.finalize(block);
  	                    hasher.reset();
  	                }
  	                derivedKey.concat(block);
  	            }
  	            derivedKey.sigBytes = keySize * 4;
  	            return derivedKey;
  	        }
  	    });
  	    C.EvpKDF = function (password, salt, cfg) {
  	        return EvpKDF.create(cfg).compute(password, salt);
  	    };
  	}());
  	return CryptoJS.EvpKDF;
  }));
  });

  var cipherCore = createCommonjsModule(function (module, exports) {
  (function (root, factory, undef) {
  	{
  		module.exports = exports = factory(core, evpkdf);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	CryptoJS.lib.Cipher || (function (undefined$1) {
  	    var C = CryptoJS;
  	    var C_lib = C.lib;
  	    var Base = C_lib.Base;
  	    var WordArray = C_lib.WordArray;
  	    var BufferedBlockAlgorithm = C_lib.BufferedBlockAlgorithm;
  	    var C_enc = C.enc;
  	    var Utf8 = C_enc.Utf8;
  	    var Base64 = C_enc.Base64;
  	    var C_algo = C.algo;
  	    var EvpKDF = C_algo.EvpKDF;
  	    var Cipher = C_lib.Cipher = BufferedBlockAlgorithm.extend({
  	        cfg: Base.extend(),
  	        createEncryptor: function (key, cfg) {
  	            return this.create(this._ENC_XFORM_MODE, key, cfg);
  	        },
  	        createDecryptor: function (key, cfg) {
  	            return this.create(this._DEC_XFORM_MODE, key, cfg);
  	        },
  	        init: function (xformMode, key, cfg) {
  	            this.cfg = this.cfg.extend(cfg);
  	            this._xformMode = xformMode;
  	            this._key = key;
  	            this.reset();
  	        },
  	        reset: function () {
  	            BufferedBlockAlgorithm.reset.call(this);
  	            this._doReset();
  	        },
  	        process: function (dataUpdate) {
  	            this._append(dataUpdate);
  	            return this._process();
  	        },
  	        finalize: function (dataUpdate) {
  	            if (dataUpdate) {
  	                this._append(dataUpdate);
  	            }
  	            var finalProcessedData = this._doFinalize();
  	            return finalProcessedData;
  	        },
  	        keySize: 128/32,
  	        ivSize: 128/32,
  	        _ENC_XFORM_MODE: 1,
  	        _DEC_XFORM_MODE: 2,
  	        _createHelper: (function () {
  	            function selectCipherStrategy(key) {
  	                if (typeof key == 'string') {
  	                    return PasswordBasedCipher;
  	                } else {
  	                    return SerializableCipher;
  	                }
  	            }
  	            return function (cipher) {
  	                return {
  	                    encrypt: function (message, key, cfg) {
  	                        return selectCipherStrategy(key).encrypt(cipher, message, key, cfg);
  	                    },
  	                    decrypt: function (ciphertext, key, cfg) {
  	                        return selectCipherStrategy(key).decrypt(cipher, ciphertext, key, cfg);
  	                    }
  	                };
  	            };
  	        }())
  	    });
  	    var StreamCipher = C_lib.StreamCipher = Cipher.extend({
  	        _doFinalize: function () {
  	            var finalProcessedBlocks = this._process(!!'flush');
  	            return finalProcessedBlocks;
  	        },
  	        blockSize: 1
  	    });
  	    var C_mode = C.mode = {};
  	    var BlockCipherMode = C_lib.BlockCipherMode = Base.extend({
  	        createEncryptor: function (cipher, iv) {
  	            return this.Encryptor.create(cipher, iv);
  	        },
  	        createDecryptor: function (cipher, iv) {
  	            return this.Decryptor.create(cipher, iv);
  	        },
  	        init: function (cipher, iv) {
  	            this._cipher = cipher;
  	            this._iv = iv;
  	        }
  	    });
  	    var CBC = C_mode.CBC = (function () {
  	        var CBC = BlockCipherMode.extend();
  	        CBC.Encryptor = CBC.extend({
  	            processBlock: function (words, offset) {
  	                var cipher = this._cipher;
  	                var blockSize = cipher.blockSize;
  	                xorBlock.call(this, words, offset, blockSize);
  	                cipher.encryptBlock(words, offset);
  	                this._prevBlock = words.slice(offset, offset + blockSize);
  	            }
  	        });
  	        CBC.Decryptor = CBC.extend({
  	            processBlock: function (words, offset) {
  	                var cipher = this._cipher;
  	                var blockSize = cipher.blockSize;
  	                var thisBlock = words.slice(offset, offset + blockSize);
  	                cipher.decryptBlock(words, offset);
  	                xorBlock.call(this, words, offset, blockSize);
  	                this._prevBlock = thisBlock;
  	            }
  	        });
  	        function xorBlock(words, offset, blockSize) {
  	            var block;
  	            var iv = this._iv;
  	            if (iv) {
  	                block = iv;
  	                this._iv = undefined$1;
  	            } else {
  	                block = this._prevBlock;
  	            }
  	            for (var i = 0; i < blockSize; i++) {
  	                words[offset + i] ^= block[i];
  	            }
  	        }
  	        return CBC;
  	    }());
  	    var C_pad = C.pad = {};
  	    var Pkcs7 = C_pad.Pkcs7 = {
  	        pad: function (data, blockSize) {
  	            var blockSizeBytes = blockSize * 4;
  	            var nPaddingBytes = blockSizeBytes - data.sigBytes % blockSizeBytes;
  	            var paddingWord = (nPaddingBytes << 24) | (nPaddingBytes << 16) | (nPaddingBytes << 8) | nPaddingBytes;
  	            var paddingWords = [];
  	            for (var i = 0; i < nPaddingBytes; i += 4) {
  	                paddingWords.push(paddingWord);
  	            }
  	            var padding = WordArray.create(paddingWords, nPaddingBytes);
  	            data.concat(padding);
  	        },
  	        unpad: function (data) {
  	            var nPaddingBytes = data.words[(data.sigBytes - 1) >>> 2] & 0xff;
  	            data.sigBytes -= nPaddingBytes;
  	        }
  	    };
  	    var BlockCipher = C_lib.BlockCipher = Cipher.extend({
  	        cfg: Cipher.cfg.extend({
  	            mode: CBC,
  	            padding: Pkcs7
  	        }),
  	        reset: function () {
  	            var modeCreator;
  	            Cipher.reset.call(this);
  	            var cfg = this.cfg;
  	            var iv = cfg.iv;
  	            var mode = cfg.mode;
  	            if (this._xformMode == this._ENC_XFORM_MODE) {
  	                modeCreator = mode.createEncryptor;
  	            } else  {
  	                modeCreator = mode.createDecryptor;
  	                this._minBufferSize = 1;
  	            }
  	            if (this._mode && this._mode.__creator == modeCreator) {
  	                this._mode.init(this, iv && iv.words);
  	            } else {
  	                this._mode = modeCreator.call(mode, this, iv && iv.words);
  	                this._mode.__creator = modeCreator;
  	            }
  	        },
  	        _doProcessBlock: function (words, offset) {
  	            this._mode.processBlock(words, offset);
  	        },
  	        _doFinalize: function () {
  	            var finalProcessedBlocks;
  	            var padding = this.cfg.padding;
  	            if (this._xformMode == this._ENC_XFORM_MODE) {
  	                padding.pad(this._data, this.blockSize);
  	                finalProcessedBlocks = this._process(!!'flush');
  	            } else  {
  	                finalProcessedBlocks = this._process(!!'flush');
  	                padding.unpad(finalProcessedBlocks);
  	            }
  	            return finalProcessedBlocks;
  	        },
  	        blockSize: 128/32
  	    });
  	    var CipherParams = C_lib.CipherParams = Base.extend({
  	        init: function (cipherParams) {
  	            this.mixIn(cipherParams);
  	        },
  	        toString: function (formatter) {
  	            return (formatter || this.formatter).stringify(this);
  	        }
  	    });
  	    var C_format = C.format = {};
  	    var OpenSSLFormatter = C_format.OpenSSL = {
  	        stringify: function (cipherParams) {
  	            var wordArray;
  	            var ciphertext = cipherParams.ciphertext;
  	            var salt = cipherParams.salt;
  	            if (salt) {
  	                wordArray = WordArray.create([0x53616c74, 0x65645f5f]).concat(salt).concat(ciphertext);
  	            } else {
  	                wordArray = ciphertext;
  	            }
  	            return wordArray.toString(Base64);
  	        },
  	        parse: function (openSSLStr) {
  	            var salt;
  	            var ciphertext = Base64.parse(openSSLStr);
  	            var ciphertextWords = ciphertext.words;
  	            if (ciphertextWords[0] == 0x53616c74 && ciphertextWords[1] == 0x65645f5f) {
  	                salt = WordArray.create(ciphertextWords.slice(2, 4));
  	                ciphertextWords.splice(0, 4);
  	                ciphertext.sigBytes -= 16;
  	            }
  	            return CipherParams.create({ ciphertext: ciphertext, salt: salt });
  	        }
  	    };
  	    var SerializableCipher = C_lib.SerializableCipher = Base.extend({
  	        cfg: Base.extend({
  	            format: OpenSSLFormatter
  	        }),
  	        encrypt: function (cipher, message, key, cfg) {
  	            cfg = this.cfg.extend(cfg);
  	            var encryptor = cipher.createEncryptor(key, cfg);
  	            var ciphertext = encryptor.finalize(message);
  	            var cipherCfg = encryptor.cfg;
  	            return CipherParams.create({
  	                ciphertext: ciphertext,
  	                key: key,
  	                iv: cipherCfg.iv,
  	                algorithm: cipher,
  	                mode: cipherCfg.mode,
  	                padding: cipherCfg.padding,
  	                blockSize: cipher.blockSize,
  	                formatter: cfg.format
  	            });
  	        },
  	        decrypt: function (cipher, ciphertext, key, cfg) {
  	            cfg = this.cfg.extend(cfg);
  	            ciphertext = this._parse(ciphertext, cfg.format);
  	            var plaintext = cipher.createDecryptor(key, cfg).finalize(ciphertext.ciphertext);
  	            return plaintext;
  	        },
  	        _parse: function (ciphertext, format) {
  	            if (typeof ciphertext == 'string') {
  	                return format.parse(ciphertext, this);
  	            } else {
  	                return ciphertext;
  	            }
  	        }
  	    });
  	    var C_kdf = C.kdf = {};
  	    var OpenSSLKdf = C_kdf.OpenSSL = {
  	        execute: function (password, keySize, ivSize, salt) {
  	            if (!salt) {
  	                salt = WordArray.random(64/8);
  	            }
  	            var key = EvpKDF.create({ keySize: keySize + ivSize }).compute(password, salt);
  	            var iv = WordArray.create(key.words.slice(keySize), ivSize * 4);
  	            key.sigBytes = keySize * 4;
  	            return CipherParams.create({ key: key, iv: iv, salt: salt });
  	        }
  	    };
  	    var PasswordBasedCipher = C_lib.PasswordBasedCipher = SerializableCipher.extend({
  	        cfg: SerializableCipher.cfg.extend({
  	            kdf: OpenSSLKdf
  	        }),
  	        encrypt: function (cipher, message, password, cfg) {
  	            cfg = this.cfg.extend(cfg);
  	            var derivedParams = cfg.kdf.execute(password, cipher.keySize, cipher.ivSize);
  	            cfg.iv = derivedParams.iv;
  	            var ciphertext = SerializableCipher.encrypt.call(this, cipher, message, derivedParams.key, cfg);
  	            ciphertext.mixIn(derivedParams);
  	            return ciphertext;
  	        },
  	        decrypt: function (cipher, ciphertext, password, cfg) {
  	            cfg = this.cfg.extend(cfg);
  	            ciphertext = this._parse(ciphertext, cfg.format);
  	            var derivedParams = cfg.kdf.execute(password, cipher.keySize, cipher.ivSize, ciphertext.salt);
  	            cfg.iv = derivedParams.iv;
  	            var plaintext = SerializableCipher.decrypt.call(this, cipher, ciphertext, derivedParams.key, cfg);
  	            return plaintext;
  	        }
  	    });
  	}());
  }));
  });

  var modeCfb = createCommonjsModule(function (module, exports) {
  (function (root, factory, undef) {
  	{
  		module.exports = exports = factory(core, cipherCore);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	CryptoJS.mode.CFB = (function () {
  	    var CFB = CryptoJS.lib.BlockCipherMode.extend();
  	    CFB.Encryptor = CFB.extend({
  	        processBlock: function (words, offset) {
  	            var cipher = this._cipher;
  	            var blockSize = cipher.blockSize;
  	            generateKeystreamAndEncrypt.call(this, words, offset, blockSize, cipher);
  	            this._prevBlock = words.slice(offset, offset + blockSize);
  	        }
  	    });
  	    CFB.Decryptor = CFB.extend({
  	        processBlock: function (words, offset) {
  	            var cipher = this._cipher;
  	            var blockSize = cipher.blockSize;
  	            var thisBlock = words.slice(offset, offset + blockSize);
  	            generateKeystreamAndEncrypt.call(this, words, offset, blockSize, cipher);
  	            this._prevBlock = thisBlock;
  	        }
  	    });
  	    function generateKeystreamAndEncrypt(words, offset, blockSize, cipher) {
  	        var keystream;
  	        var iv = this._iv;
  	        if (iv) {
  	            keystream = iv.slice(0);
  	            this._iv = undefined;
  	        } else {
  	            keystream = this._prevBlock;
  	        }
  	        cipher.encryptBlock(keystream, 0);
  	        for (var i = 0; i < blockSize; i++) {
  	            words[offset + i] ^= keystream[i];
  	        }
  	    }
  	    return CFB;
  	}());
  	return CryptoJS.mode.CFB;
  }));
  });

  var modeCtr = createCommonjsModule(function (module, exports) {
  (function (root, factory, undef) {
  	{
  		module.exports = exports = factory(core, cipherCore);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	CryptoJS.mode.CTR = (function () {
  	    var CTR = CryptoJS.lib.BlockCipherMode.extend();
  	    var Encryptor = CTR.Encryptor = CTR.extend({
  	        processBlock: function (words, offset) {
  	            var cipher = this._cipher;
  	            var blockSize = cipher.blockSize;
  	            var iv = this._iv;
  	            var counter = this._counter;
  	            if (iv) {
  	                counter = this._counter = iv.slice(0);
  	                this._iv = undefined;
  	            }
  	            var keystream = counter.slice(0);
  	            cipher.encryptBlock(keystream, 0);
  	            counter[blockSize - 1] = (counter[blockSize - 1] + 1) | 0;
  	            for (var i = 0; i < blockSize; i++) {
  	                words[offset + i] ^= keystream[i];
  	            }
  	        }
  	    });
  	    CTR.Decryptor = Encryptor;
  	    return CTR;
  	}());
  	return CryptoJS.mode.CTR;
  }));
  });

  var modeCtrGladman = createCommonjsModule(function (module, exports) {
  (function (root, factory, undef) {
  	{
  		module.exports = exports = factory(core, cipherCore);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	/** @preserve
  	 * Counter block mode compatible with  Dr Brian Gladman fileenc.c
  	 * derived from CryptoJS.mode.CTR
  	 * Jan Hruby jhruby.web@gmail.com
  	 */
  	CryptoJS.mode.CTRGladman = (function () {
  	    var CTRGladman = CryptoJS.lib.BlockCipherMode.extend();
  		function incWord(word)
  		{
  			if (((word >> 24) & 0xff) === 0xff) {
  			var b1 = (word >> 16)&0xff;
  			var b2 = (word >> 8)&0xff;
  			var b3 = word & 0xff;
  			if (b1 === 0xff)
  			{
  			b1 = 0;
  			if (b2 === 0xff)
  			{
  				b2 = 0;
  				if (b3 === 0xff)
  				{
  					b3 = 0;
  				}
  				else
  				{
  					++b3;
  				}
  			}
  			else
  			{
  				++b2;
  			}
  			}
  			else
  			{
  			++b1;
  			}
  			word = 0;
  			word += (b1 << 16);
  			word += (b2 << 8);
  			word += b3;
  			}
  			else
  			{
  			word += (0x01 << 24);
  			}
  			return word;
  		}
  		function incCounter(counter)
  		{
  			if ((counter[0] = incWord(counter[0])) === 0)
  			{
  				counter[1] = incWord(counter[1]);
  			}
  			return counter;
  		}
  	    var Encryptor = CTRGladman.Encryptor = CTRGladman.extend({
  	        processBlock: function (words, offset) {
  	            var cipher = this._cipher;
  	            var blockSize = cipher.blockSize;
  	            var iv = this._iv;
  	            var counter = this._counter;
  	            if (iv) {
  	                counter = this._counter = iv.slice(0);
  	                this._iv = undefined;
  	            }
  				incCounter(counter);
  				var keystream = counter.slice(0);
  	            cipher.encryptBlock(keystream, 0);
  	            for (var i = 0; i < blockSize; i++) {
  	                words[offset + i] ^= keystream[i];
  	            }
  	        }
  	    });
  	    CTRGladman.Decryptor = Encryptor;
  	    return CTRGladman;
  	}());
  	return CryptoJS.mode.CTRGladman;
  }));
  });

  var modeOfb = createCommonjsModule(function (module, exports) {
  (function (root, factory, undef) {
  	{
  		module.exports = exports = factory(core, cipherCore);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	CryptoJS.mode.OFB = (function () {
  	    var OFB = CryptoJS.lib.BlockCipherMode.extend();
  	    var Encryptor = OFB.Encryptor = OFB.extend({
  	        processBlock: function (words, offset) {
  	            var cipher = this._cipher;
  	            var blockSize = cipher.blockSize;
  	            var iv = this._iv;
  	            var keystream = this._keystream;
  	            if (iv) {
  	                keystream = this._keystream = iv.slice(0);
  	                this._iv = undefined;
  	            }
  	            cipher.encryptBlock(keystream, 0);
  	            for (var i = 0; i < blockSize; i++) {
  	                words[offset + i] ^= keystream[i];
  	            }
  	        }
  	    });
  	    OFB.Decryptor = Encryptor;
  	    return OFB;
  	}());
  	return CryptoJS.mode.OFB;
  }));
  });

  var modeEcb = createCommonjsModule(function (module, exports) {
  (function (root, factory, undef) {
  	{
  		module.exports = exports = factory(core, cipherCore);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	CryptoJS.mode.ECB = (function () {
  	    var ECB = CryptoJS.lib.BlockCipherMode.extend();
  	    ECB.Encryptor = ECB.extend({
  	        processBlock: function (words, offset) {
  	            this._cipher.encryptBlock(words, offset);
  	        }
  	    });
  	    ECB.Decryptor = ECB.extend({
  	        processBlock: function (words, offset) {
  	            this._cipher.decryptBlock(words, offset);
  	        }
  	    });
  	    return ECB;
  	}());
  	return CryptoJS.mode.ECB;
  }));
  });

  var padAnsix923 = createCommonjsModule(function (module, exports) {
  (function (root, factory, undef) {
  	{
  		module.exports = exports = factory(core, cipherCore);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	CryptoJS.pad.AnsiX923 = {
  	    pad: function (data, blockSize) {
  	        var dataSigBytes = data.sigBytes;
  	        var blockSizeBytes = blockSize * 4;
  	        var nPaddingBytes = blockSizeBytes - dataSigBytes % blockSizeBytes;
  	        var lastBytePos = dataSigBytes + nPaddingBytes - 1;
  	        data.clamp();
  	        data.words[lastBytePos >>> 2] |= nPaddingBytes << (24 - (lastBytePos % 4) * 8);
  	        data.sigBytes += nPaddingBytes;
  	    },
  	    unpad: function (data) {
  	        var nPaddingBytes = data.words[(data.sigBytes - 1) >>> 2] & 0xff;
  	        data.sigBytes -= nPaddingBytes;
  	    }
  	};
  	return CryptoJS.pad.Ansix923;
  }));
  });

  var padIso10126 = createCommonjsModule(function (module, exports) {
  (function (root, factory, undef) {
  	{
  		module.exports = exports = factory(core, cipherCore);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	CryptoJS.pad.Iso10126 = {
  	    pad: function (data, blockSize) {
  	        var blockSizeBytes = blockSize * 4;
  	        var nPaddingBytes = blockSizeBytes - data.sigBytes % blockSizeBytes;
  	        data.concat(CryptoJS.lib.WordArray.random(nPaddingBytes - 1)).
  	             concat(CryptoJS.lib.WordArray.create([nPaddingBytes << 24], 1));
  	    },
  	    unpad: function (data) {
  	        var nPaddingBytes = data.words[(data.sigBytes - 1) >>> 2] & 0xff;
  	        data.sigBytes -= nPaddingBytes;
  	    }
  	};
  	return CryptoJS.pad.Iso10126;
  }));
  });

  var padIso97971 = createCommonjsModule(function (module, exports) {
  (function (root, factory, undef) {
  	{
  		module.exports = exports = factory(core, cipherCore);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	CryptoJS.pad.Iso97971 = {
  	    pad: function (data, blockSize) {
  	        data.concat(CryptoJS.lib.WordArray.create([0x80000000], 1));
  	        CryptoJS.pad.ZeroPadding.pad(data, blockSize);
  	    },
  	    unpad: function (data) {
  	        CryptoJS.pad.ZeroPadding.unpad(data);
  	        data.sigBytes--;
  	    }
  	};
  	return CryptoJS.pad.Iso97971;
  }));
  });

  var padZeropadding = createCommonjsModule(function (module, exports) {
  (function (root, factory, undef) {
  	{
  		module.exports = exports = factory(core, cipherCore);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	CryptoJS.pad.ZeroPadding = {
  	    pad: function (data, blockSize) {
  	        var blockSizeBytes = blockSize * 4;
  	        data.clamp();
  	        data.sigBytes += blockSizeBytes - ((data.sigBytes % blockSizeBytes) || blockSizeBytes);
  	    },
  	    unpad: function (data) {
  	        var dataWords = data.words;
  	        var i = data.sigBytes - 1;
  	        for (var i = data.sigBytes - 1; i >= 0; i--) {
  	            if (((dataWords[i >>> 2] >>> (24 - (i % 4) * 8)) & 0xff)) {
  	                data.sigBytes = i + 1;
  	                break;
  	            }
  	        }
  	    }
  	};
  	return CryptoJS.pad.ZeroPadding;
  }));
  });

  var padNopadding = createCommonjsModule(function (module, exports) {
  (function (root, factory, undef) {
  	{
  		module.exports = exports = factory(core, cipherCore);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	CryptoJS.pad.NoPadding = {
  	    pad: function () {
  	    },
  	    unpad: function () {
  	    }
  	};
  	return CryptoJS.pad.NoPadding;
  }));
  });

  var formatHex = createCommonjsModule(function (module, exports) {
  (function (root, factory, undef) {
  	{
  		module.exports = exports = factory(core, cipherCore);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	(function (undefined$1) {
  	    var C = CryptoJS;
  	    var C_lib = C.lib;
  	    var CipherParams = C_lib.CipherParams;
  	    var C_enc = C.enc;
  	    var Hex = C_enc.Hex;
  	    var C_format = C.format;
  	    var HexFormatter = C_format.Hex = {
  	        stringify: function (cipherParams) {
  	            return cipherParams.ciphertext.toString(Hex);
  	        },
  	        parse: function (input) {
  	            var ciphertext = Hex.parse(input);
  	            return CipherParams.create({ ciphertext: ciphertext });
  	        }
  	    };
  	}());
  	return CryptoJS.format.Hex;
  }));
  });

  var aes = createCommonjsModule(function (module, exports) {
  (function (root, factory, undef) {
  	{
  		module.exports = exports = factory(core, encBase64, md5, evpkdf, cipherCore);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	(function () {
  	    var C = CryptoJS;
  	    var C_lib = C.lib;
  	    var BlockCipher = C_lib.BlockCipher;
  	    var C_algo = C.algo;
  	    var SBOX = [];
  	    var INV_SBOX = [];
  	    var SUB_MIX_0 = [];
  	    var SUB_MIX_1 = [];
  	    var SUB_MIX_2 = [];
  	    var SUB_MIX_3 = [];
  	    var INV_SUB_MIX_0 = [];
  	    var INV_SUB_MIX_1 = [];
  	    var INV_SUB_MIX_2 = [];
  	    var INV_SUB_MIX_3 = [];
  	    (function () {
  	        var d = [];
  	        for (var i = 0; i < 256; i++) {
  	            if (i < 128) {
  	                d[i] = i << 1;
  	            } else {
  	                d[i] = (i << 1) ^ 0x11b;
  	            }
  	        }
  	        var x = 0;
  	        var xi = 0;
  	        for (var i = 0; i < 256; i++) {
  	            var sx = xi ^ (xi << 1) ^ (xi << 2) ^ (xi << 3) ^ (xi << 4);
  	            sx = (sx >>> 8) ^ (sx & 0xff) ^ 0x63;
  	            SBOX[x] = sx;
  	            INV_SBOX[sx] = x;
  	            var x2 = d[x];
  	            var x4 = d[x2];
  	            var x8 = d[x4];
  	            var t = (d[sx] * 0x101) ^ (sx * 0x1010100);
  	            SUB_MIX_0[x] = (t << 24) | (t >>> 8);
  	            SUB_MIX_1[x] = (t << 16) | (t >>> 16);
  	            SUB_MIX_2[x] = (t << 8)  | (t >>> 24);
  	            SUB_MIX_3[x] = t;
  	            var t = (x8 * 0x1010101) ^ (x4 * 0x10001) ^ (x2 * 0x101) ^ (x * 0x1010100);
  	            INV_SUB_MIX_0[sx] = (t << 24) | (t >>> 8);
  	            INV_SUB_MIX_1[sx] = (t << 16) | (t >>> 16);
  	            INV_SUB_MIX_2[sx] = (t << 8)  | (t >>> 24);
  	            INV_SUB_MIX_3[sx] = t;
  	            if (!x) {
  	                x = xi = 1;
  	            } else {
  	                x = x2 ^ d[d[d[x8 ^ x2]]];
  	                xi ^= d[d[xi]];
  	            }
  	        }
  	    }());
  	    var RCON = [0x00, 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x1b, 0x36];
  	    var AES = C_algo.AES = BlockCipher.extend({
  	        _doReset: function () {
  	            var t;
  	            if (this._nRounds && this._keyPriorReset === this._key) {
  	                return;
  	            }
  	            var key = this._keyPriorReset = this._key;
  	            var keyWords = key.words;
  	            var keySize = key.sigBytes / 4;
  	            var nRounds = this._nRounds = keySize + 6;
  	            var ksRows = (nRounds + 1) * 4;
  	            var keySchedule = this._keySchedule = [];
  	            for (var ksRow = 0; ksRow < ksRows; ksRow++) {
  	                if (ksRow < keySize) {
  	                    keySchedule[ksRow] = keyWords[ksRow];
  	                } else {
  	                    t = keySchedule[ksRow - 1];
  	                    if (!(ksRow % keySize)) {
  	                        t = (t << 8) | (t >>> 24);
  	                        t = (SBOX[t >>> 24] << 24) | (SBOX[(t >>> 16) & 0xff] << 16) | (SBOX[(t >>> 8) & 0xff] << 8) | SBOX[t & 0xff];
  	                        t ^= RCON[(ksRow / keySize) | 0] << 24;
  	                    } else if (keySize > 6 && ksRow % keySize == 4) {
  	                        t = (SBOX[t >>> 24] << 24) | (SBOX[(t >>> 16) & 0xff] << 16) | (SBOX[(t >>> 8) & 0xff] << 8) | SBOX[t & 0xff];
  	                    }
  	                    keySchedule[ksRow] = keySchedule[ksRow - keySize] ^ t;
  	                }
  	            }
  	            var invKeySchedule = this._invKeySchedule = [];
  	            for (var invKsRow = 0; invKsRow < ksRows; invKsRow++) {
  	                var ksRow = ksRows - invKsRow;
  	                if (invKsRow % 4) {
  	                    var t = keySchedule[ksRow];
  	                } else {
  	                    var t = keySchedule[ksRow - 4];
  	                }
  	                if (invKsRow < 4 || ksRow <= 4) {
  	                    invKeySchedule[invKsRow] = t;
  	                } else {
  	                    invKeySchedule[invKsRow] = INV_SUB_MIX_0[SBOX[t >>> 24]] ^ INV_SUB_MIX_1[SBOX[(t >>> 16) & 0xff]] ^
  	                                               INV_SUB_MIX_2[SBOX[(t >>> 8) & 0xff]] ^ INV_SUB_MIX_3[SBOX[t & 0xff]];
  	                }
  	            }
  	        },
  	        encryptBlock: function (M, offset) {
  	            this._doCryptBlock(M, offset, this._keySchedule, SUB_MIX_0, SUB_MIX_1, SUB_MIX_2, SUB_MIX_3, SBOX);
  	        },
  	        decryptBlock: function (M, offset) {
  	            var t = M[offset + 1];
  	            M[offset + 1] = M[offset + 3];
  	            M[offset + 3] = t;
  	            this._doCryptBlock(M, offset, this._invKeySchedule, INV_SUB_MIX_0, INV_SUB_MIX_1, INV_SUB_MIX_2, INV_SUB_MIX_3, INV_SBOX);
  	            var t = M[offset + 1];
  	            M[offset + 1] = M[offset + 3];
  	            M[offset + 3] = t;
  	        },
  	        _doCryptBlock: function (M, offset, keySchedule, SUB_MIX_0, SUB_MIX_1, SUB_MIX_2, SUB_MIX_3, SBOX) {
  	            var nRounds = this._nRounds;
  	            var s0 = M[offset]     ^ keySchedule[0];
  	            var s1 = M[offset + 1] ^ keySchedule[1];
  	            var s2 = M[offset + 2] ^ keySchedule[2];
  	            var s3 = M[offset + 3] ^ keySchedule[3];
  	            var ksRow = 4;
  	            for (var round = 1; round < nRounds; round++) {
  	                var t0 = SUB_MIX_0[s0 >>> 24] ^ SUB_MIX_1[(s1 >>> 16) & 0xff] ^ SUB_MIX_2[(s2 >>> 8) & 0xff] ^ SUB_MIX_3[s3 & 0xff] ^ keySchedule[ksRow++];
  	                var t1 = SUB_MIX_0[s1 >>> 24] ^ SUB_MIX_1[(s2 >>> 16) & 0xff] ^ SUB_MIX_2[(s3 >>> 8) & 0xff] ^ SUB_MIX_3[s0 & 0xff] ^ keySchedule[ksRow++];
  	                var t2 = SUB_MIX_0[s2 >>> 24] ^ SUB_MIX_1[(s3 >>> 16) & 0xff] ^ SUB_MIX_2[(s0 >>> 8) & 0xff] ^ SUB_MIX_3[s1 & 0xff] ^ keySchedule[ksRow++];
  	                var t3 = SUB_MIX_0[s3 >>> 24] ^ SUB_MIX_1[(s0 >>> 16) & 0xff] ^ SUB_MIX_2[(s1 >>> 8) & 0xff] ^ SUB_MIX_3[s2 & 0xff] ^ keySchedule[ksRow++];
  	                s0 = t0;
  	                s1 = t1;
  	                s2 = t2;
  	                s3 = t3;
  	            }
  	            var t0 = ((SBOX[s0 >>> 24] << 24) | (SBOX[(s1 >>> 16) & 0xff] << 16) | (SBOX[(s2 >>> 8) & 0xff] << 8) | SBOX[s3 & 0xff]) ^ keySchedule[ksRow++];
  	            var t1 = ((SBOX[s1 >>> 24] << 24) | (SBOX[(s2 >>> 16) & 0xff] << 16) | (SBOX[(s3 >>> 8) & 0xff] << 8) | SBOX[s0 & 0xff]) ^ keySchedule[ksRow++];
  	            var t2 = ((SBOX[s2 >>> 24] << 24) | (SBOX[(s3 >>> 16) & 0xff] << 16) | (SBOX[(s0 >>> 8) & 0xff] << 8) | SBOX[s1 & 0xff]) ^ keySchedule[ksRow++];
  	            var t3 = ((SBOX[s3 >>> 24] << 24) | (SBOX[(s0 >>> 16) & 0xff] << 16) | (SBOX[(s1 >>> 8) & 0xff] << 8) | SBOX[s2 & 0xff]) ^ keySchedule[ksRow++];
  	            M[offset]     = t0;
  	            M[offset + 1] = t1;
  	            M[offset + 2] = t2;
  	            M[offset + 3] = t3;
  	        },
  	        keySize: 256/32
  	    });
  	    C.AES = BlockCipher._createHelper(AES);
  	}());
  	return CryptoJS.AES;
  }));
  });

  var tripledes = createCommonjsModule(function (module, exports) {
  (function (root, factory, undef) {
  	{
  		module.exports = exports = factory(core, encBase64, md5, evpkdf, cipherCore);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	(function () {
  	    var C = CryptoJS;
  	    var C_lib = C.lib;
  	    var WordArray = C_lib.WordArray;
  	    var BlockCipher = C_lib.BlockCipher;
  	    var C_algo = C.algo;
  	    var PC1 = [
  	        57, 49, 41, 33, 25, 17, 9,  1,
  	        58, 50, 42, 34, 26, 18, 10, 2,
  	        59, 51, 43, 35, 27, 19, 11, 3,
  	        60, 52, 44, 36, 63, 55, 47, 39,
  	        31, 23, 15, 7,  62, 54, 46, 38,
  	        30, 22, 14, 6,  61, 53, 45, 37,
  	        29, 21, 13, 5,  28, 20, 12, 4
  	    ];
  	    var PC2 = [
  	        14, 17, 11, 24, 1,  5,
  	        3,  28, 15, 6,  21, 10,
  	        23, 19, 12, 4,  26, 8,
  	        16, 7,  27, 20, 13, 2,
  	        41, 52, 31, 37, 47, 55,
  	        30, 40, 51, 45, 33, 48,
  	        44, 49, 39, 56, 34, 53,
  	        46, 42, 50, 36, 29, 32
  	    ];
  	    var BIT_SHIFTS = [1,  2,  4,  6,  8,  10, 12, 14, 15, 17, 19, 21, 23, 25, 27, 28];
  	    var SBOX_P = [
  	        {
  	            0x0: 0x808200,
  	            0x10000000: 0x8000,
  	            0x20000000: 0x808002,
  	            0x30000000: 0x2,
  	            0x40000000: 0x200,
  	            0x50000000: 0x808202,
  	            0x60000000: 0x800202,
  	            0x70000000: 0x800000,
  	            0x80000000: 0x202,
  	            0x90000000: 0x800200,
  	            0xa0000000: 0x8200,
  	            0xb0000000: 0x808000,
  	            0xc0000000: 0x8002,
  	            0xd0000000: 0x800002,
  	            0xe0000000: 0x0,
  	            0xf0000000: 0x8202,
  	            0x8000000: 0x0,
  	            0x18000000: 0x808202,
  	            0x28000000: 0x8202,
  	            0x38000000: 0x8000,
  	            0x48000000: 0x808200,
  	            0x58000000: 0x200,
  	            0x68000000: 0x808002,
  	            0x78000000: 0x2,
  	            0x88000000: 0x800200,
  	            0x98000000: 0x8200,
  	            0xa8000000: 0x808000,
  	            0xb8000000: 0x800202,
  	            0xc8000000: 0x800002,
  	            0xd8000000: 0x8002,
  	            0xe8000000: 0x202,
  	            0xf8000000: 0x800000,
  	            0x1: 0x8000,
  	            0x10000001: 0x2,
  	            0x20000001: 0x808200,
  	            0x30000001: 0x800000,
  	            0x40000001: 0x808002,
  	            0x50000001: 0x8200,
  	            0x60000001: 0x200,
  	            0x70000001: 0x800202,
  	            0x80000001: 0x808202,
  	            0x90000001: 0x808000,
  	            0xa0000001: 0x800002,
  	            0xb0000001: 0x8202,
  	            0xc0000001: 0x202,
  	            0xd0000001: 0x800200,
  	            0xe0000001: 0x8002,
  	            0xf0000001: 0x0,
  	            0x8000001: 0x808202,
  	            0x18000001: 0x808000,
  	            0x28000001: 0x800000,
  	            0x38000001: 0x200,
  	            0x48000001: 0x8000,
  	            0x58000001: 0x800002,
  	            0x68000001: 0x2,
  	            0x78000001: 0x8202,
  	            0x88000001: 0x8002,
  	            0x98000001: 0x800202,
  	            0xa8000001: 0x202,
  	            0xb8000001: 0x808200,
  	            0xc8000001: 0x800200,
  	            0xd8000001: 0x0,
  	            0xe8000001: 0x8200,
  	            0xf8000001: 0x808002
  	        },
  	        {
  	            0x0: 0x40084010,
  	            0x1000000: 0x4000,
  	            0x2000000: 0x80000,
  	            0x3000000: 0x40080010,
  	            0x4000000: 0x40000010,
  	            0x5000000: 0x40084000,
  	            0x6000000: 0x40004000,
  	            0x7000000: 0x10,
  	            0x8000000: 0x84000,
  	            0x9000000: 0x40004010,
  	            0xa000000: 0x40000000,
  	            0xb000000: 0x84010,
  	            0xc000000: 0x80010,
  	            0xd000000: 0x0,
  	            0xe000000: 0x4010,
  	            0xf000000: 0x40080000,
  	            0x800000: 0x40004000,
  	            0x1800000: 0x84010,
  	            0x2800000: 0x10,
  	            0x3800000: 0x40004010,
  	            0x4800000: 0x40084010,
  	            0x5800000: 0x40000000,
  	            0x6800000: 0x80000,
  	            0x7800000: 0x40080010,
  	            0x8800000: 0x80010,
  	            0x9800000: 0x0,
  	            0xa800000: 0x4000,
  	            0xb800000: 0x40080000,
  	            0xc800000: 0x40000010,
  	            0xd800000: 0x84000,
  	            0xe800000: 0x40084000,
  	            0xf800000: 0x4010,
  	            0x10000000: 0x0,
  	            0x11000000: 0x40080010,
  	            0x12000000: 0x40004010,
  	            0x13000000: 0x40084000,
  	            0x14000000: 0x40080000,
  	            0x15000000: 0x10,
  	            0x16000000: 0x84010,
  	            0x17000000: 0x4000,
  	            0x18000000: 0x4010,
  	            0x19000000: 0x80000,
  	            0x1a000000: 0x80010,
  	            0x1b000000: 0x40000010,
  	            0x1c000000: 0x84000,
  	            0x1d000000: 0x40004000,
  	            0x1e000000: 0x40000000,
  	            0x1f000000: 0x40084010,
  	            0x10800000: 0x84010,
  	            0x11800000: 0x80000,
  	            0x12800000: 0x40080000,
  	            0x13800000: 0x4000,
  	            0x14800000: 0x40004000,
  	            0x15800000: 0x40084010,
  	            0x16800000: 0x10,
  	            0x17800000: 0x40000000,
  	            0x18800000: 0x40084000,
  	            0x19800000: 0x40000010,
  	            0x1a800000: 0x40004010,
  	            0x1b800000: 0x80010,
  	            0x1c800000: 0x0,
  	            0x1d800000: 0x4010,
  	            0x1e800000: 0x40080010,
  	            0x1f800000: 0x84000
  	        },
  	        {
  	            0x0: 0x104,
  	            0x100000: 0x0,
  	            0x200000: 0x4000100,
  	            0x300000: 0x10104,
  	            0x400000: 0x10004,
  	            0x500000: 0x4000004,
  	            0x600000: 0x4010104,
  	            0x700000: 0x4010000,
  	            0x800000: 0x4000000,
  	            0x900000: 0x4010100,
  	            0xa00000: 0x10100,
  	            0xb00000: 0x4010004,
  	            0xc00000: 0x4000104,
  	            0xd00000: 0x10000,
  	            0xe00000: 0x4,
  	            0xf00000: 0x100,
  	            0x80000: 0x4010100,
  	            0x180000: 0x4010004,
  	            0x280000: 0x0,
  	            0x380000: 0x4000100,
  	            0x480000: 0x4000004,
  	            0x580000: 0x10000,
  	            0x680000: 0x10004,
  	            0x780000: 0x104,
  	            0x880000: 0x4,
  	            0x980000: 0x100,
  	            0xa80000: 0x4010000,
  	            0xb80000: 0x10104,
  	            0xc80000: 0x10100,
  	            0xd80000: 0x4000104,
  	            0xe80000: 0x4010104,
  	            0xf80000: 0x4000000,
  	            0x1000000: 0x4010100,
  	            0x1100000: 0x10004,
  	            0x1200000: 0x10000,
  	            0x1300000: 0x4000100,
  	            0x1400000: 0x100,
  	            0x1500000: 0x4010104,
  	            0x1600000: 0x4000004,
  	            0x1700000: 0x0,
  	            0x1800000: 0x4000104,
  	            0x1900000: 0x4000000,
  	            0x1a00000: 0x4,
  	            0x1b00000: 0x10100,
  	            0x1c00000: 0x4010000,
  	            0x1d00000: 0x104,
  	            0x1e00000: 0x10104,
  	            0x1f00000: 0x4010004,
  	            0x1080000: 0x4000000,
  	            0x1180000: 0x104,
  	            0x1280000: 0x4010100,
  	            0x1380000: 0x0,
  	            0x1480000: 0x10004,
  	            0x1580000: 0x4000100,
  	            0x1680000: 0x100,
  	            0x1780000: 0x4010004,
  	            0x1880000: 0x10000,
  	            0x1980000: 0x4010104,
  	            0x1a80000: 0x10104,
  	            0x1b80000: 0x4000004,
  	            0x1c80000: 0x4000104,
  	            0x1d80000: 0x4010000,
  	            0x1e80000: 0x4,
  	            0x1f80000: 0x10100
  	        },
  	        {
  	            0x0: 0x80401000,
  	            0x10000: 0x80001040,
  	            0x20000: 0x401040,
  	            0x30000: 0x80400000,
  	            0x40000: 0x0,
  	            0x50000: 0x401000,
  	            0x60000: 0x80000040,
  	            0x70000: 0x400040,
  	            0x80000: 0x80000000,
  	            0x90000: 0x400000,
  	            0xa0000: 0x40,
  	            0xb0000: 0x80001000,
  	            0xc0000: 0x80400040,
  	            0xd0000: 0x1040,
  	            0xe0000: 0x1000,
  	            0xf0000: 0x80401040,
  	            0x8000: 0x80001040,
  	            0x18000: 0x40,
  	            0x28000: 0x80400040,
  	            0x38000: 0x80001000,
  	            0x48000: 0x401000,
  	            0x58000: 0x80401040,
  	            0x68000: 0x0,
  	            0x78000: 0x80400000,
  	            0x88000: 0x1000,
  	            0x98000: 0x80401000,
  	            0xa8000: 0x400000,
  	            0xb8000: 0x1040,
  	            0xc8000: 0x80000000,
  	            0xd8000: 0x400040,
  	            0xe8000: 0x401040,
  	            0xf8000: 0x80000040,
  	            0x100000: 0x400040,
  	            0x110000: 0x401000,
  	            0x120000: 0x80000040,
  	            0x130000: 0x0,
  	            0x140000: 0x1040,
  	            0x150000: 0x80400040,
  	            0x160000: 0x80401000,
  	            0x170000: 0x80001040,
  	            0x180000: 0x80401040,
  	            0x190000: 0x80000000,
  	            0x1a0000: 0x80400000,
  	            0x1b0000: 0x401040,
  	            0x1c0000: 0x80001000,
  	            0x1d0000: 0x400000,
  	            0x1e0000: 0x40,
  	            0x1f0000: 0x1000,
  	            0x108000: 0x80400000,
  	            0x118000: 0x80401040,
  	            0x128000: 0x0,
  	            0x138000: 0x401000,
  	            0x148000: 0x400040,
  	            0x158000: 0x80000000,
  	            0x168000: 0x80001040,
  	            0x178000: 0x40,
  	            0x188000: 0x80000040,
  	            0x198000: 0x1000,
  	            0x1a8000: 0x80001000,
  	            0x1b8000: 0x80400040,
  	            0x1c8000: 0x1040,
  	            0x1d8000: 0x80401000,
  	            0x1e8000: 0x400000,
  	            0x1f8000: 0x401040
  	        },
  	        {
  	            0x0: 0x80,
  	            0x1000: 0x1040000,
  	            0x2000: 0x40000,
  	            0x3000: 0x20000000,
  	            0x4000: 0x20040080,
  	            0x5000: 0x1000080,
  	            0x6000: 0x21000080,
  	            0x7000: 0x40080,
  	            0x8000: 0x1000000,
  	            0x9000: 0x20040000,
  	            0xa000: 0x20000080,
  	            0xb000: 0x21040080,
  	            0xc000: 0x21040000,
  	            0xd000: 0x0,
  	            0xe000: 0x1040080,
  	            0xf000: 0x21000000,
  	            0x800: 0x1040080,
  	            0x1800: 0x21000080,
  	            0x2800: 0x80,
  	            0x3800: 0x1040000,
  	            0x4800: 0x40000,
  	            0x5800: 0x20040080,
  	            0x6800: 0x21040000,
  	            0x7800: 0x20000000,
  	            0x8800: 0x20040000,
  	            0x9800: 0x0,
  	            0xa800: 0x21040080,
  	            0xb800: 0x1000080,
  	            0xc800: 0x20000080,
  	            0xd800: 0x21000000,
  	            0xe800: 0x1000000,
  	            0xf800: 0x40080,
  	            0x10000: 0x40000,
  	            0x11000: 0x80,
  	            0x12000: 0x20000000,
  	            0x13000: 0x21000080,
  	            0x14000: 0x1000080,
  	            0x15000: 0x21040000,
  	            0x16000: 0x20040080,
  	            0x17000: 0x1000000,
  	            0x18000: 0x21040080,
  	            0x19000: 0x21000000,
  	            0x1a000: 0x1040000,
  	            0x1b000: 0x20040000,
  	            0x1c000: 0x40080,
  	            0x1d000: 0x20000080,
  	            0x1e000: 0x0,
  	            0x1f000: 0x1040080,
  	            0x10800: 0x21000080,
  	            0x11800: 0x1000000,
  	            0x12800: 0x1040000,
  	            0x13800: 0x20040080,
  	            0x14800: 0x20000000,
  	            0x15800: 0x1040080,
  	            0x16800: 0x80,
  	            0x17800: 0x21040000,
  	            0x18800: 0x40080,
  	            0x19800: 0x21040080,
  	            0x1a800: 0x0,
  	            0x1b800: 0x21000000,
  	            0x1c800: 0x1000080,
  	            0x1d800: 0x40000,
  	            0x1e800: 0x20040000,
  	            0x1f800: 0x20000080
  	        },
  	        {
  	            0x0: 0x10000008,
  	            0x100: 0x2000,
  	            0x200: 0x10200000,
  	            0x300: 0x10202008,
  	            0x400: 0x10002000,
  	            0x500: 0x200000,
  	            0x600: 0x200008,
  	            0x700: 0x10000000,
  	            0x800: 0x0,
  	            0x900: 0x10002008,
  	            0xa00: 0x202000,
  	            0xb00: 0x8,
  	            0xc00: 0x10200008,
  	            0xd00: 0x202008,
  	            0xe00: 0x2008,
  	            0xf00: 0x10202000,
  	            0x80: 0x10200000,
  	            0x180: 0x10202008,
  	            0x280: 0x8,
  	            0x380: 0x200000,
  	            0x480: 0x202008,
  	            0x580: 0x10000008,
  	            0x680: 0x10002000,
  	            0x780: 0x2008,
  	            0x880: 0x200008,
  	            0x980: 0x2000,
  	            0xa80: 0x10002008,
  	            0xb80: 0x10200008,
  	            0xc80: 0x0,
  	            0xd80: 0x10202000,
  	            0xe80: 0x202000,
  	            0xf80: 0x10000000,
  	            0x1000: 0x10002000,
  	            0x1100: 0x10200008,
  	            0x1200: 0x10202008,
  	            0x1300: 0x2008,
  	            0x1400: 0x200000,
  	            0x1500: 0x10000000,
  	            0x1600: 0x10000008,
  	            0x1700: 0x202000,
  	            0x1800: 0x202008,
  	            0x1900: 0x0,
  	            0x1a00: 0x8,
  	            0x1b00: 0x10200000,
  	            0x1c00: 0x2000,
  	            0x1d00: 0x10002008,
  	            0x1e00: 0x10202000,
  	            0x1f00: 0x200008,
  	            0x1080: 0x8,
  	            0x1180: 0x202000,
  	            0x1280: 0x200000,
  	            0x1380: 0x10000008,
  	            0x1480: 0x10002000,
  	            0x1580: 0x2008,
  	            0x1680: 0x10202008,
  	            0x1780: 0x10200000,
  	            0x1880: 0x10202000,
  	            0x1980: 0x10200008,
  	            0x1a80: 0x2000,
  	            0x1b80: 0x202008,
  	            0x1c80: 0x200008,
  	            0x1d80: 0x0,
  	            0x1e80: 0x10000000,
  	            0x1f80: 0x10002008
  	        },
  	        {
  	            0x0: 0x100000,
  	            0x10: 0x2000401,
  	            0x20: 0x400,
  	            0x30: 0x100401,
  	            0x40: 0x2100401,
  	            0x50: 0x0,
  	            0x60: 0x1,
  	            0x70: 0x2100001,
  	            0x80: 0x2000400,
  	            0x90: 0x100001,
  	            0xa0: 0x2000001,
  	            0xb0: 0x2100400,
  	            0xc0: 0x2100000,
  	            0xd0: 0x401,
  	            0xe0: 0x100400,
  	            0xf0: 0x2000000,
  	            0x8: 0x2100001,
  	            0x18: 0x0,
  	            0x28: 0x2000401,
  	            0x38: 0x2100400,
  	            0x48: 0x100000,
  	            0x58: 0x2000001,
  	            0x68: 0x2000000,
  	            0x78: 0x401,
  	            0x88: 0x100401,
  	            0x98: 0x2000400,
  	            0xa8: 0x2100000,
  	            0xb8: 0x100001,
  	            0xc8: 0x400,
  	            0xd8: 0x2100401,
  	            0xe8: 0x1,
  	            0xf8: 0x100400,
  	            0x100: 0x2000000,
  	            0x110: 0x100000,
  	            0x120: 0x2000401,
  	            0x130: 0x2100001,
  	            0x140: 0x100001,
  	            0x150: 0x2000400,
  	            0x160: 0x2100400,
  	            0x170: 0x100401,
  	            0x180: 0x401,
  	            0x190: 0x2100401,
  	            0x1a0: 0x100400,
  	            0x1b0: 0x1,
  	            0x1c0: 0x0,
  	            0x1d0: 0x2100000,
  	            0x1e0: 0x2000001,
  	            0x1f0: 0x400,
  	            0x108: 0x100400,
  	            0x118: 0x2000401,
  	            0x128: 0x2100001,
  	            0x138: 0x1,
  	            0x148: 0x2000000,
  	            0x158: 0x100000,
  	            0x168: 0x401,
  	            0x178: 0x2100400,
  	            0x188: 0x2000001,
  	            0x198: 0x2100000,
  	            0x1a8: 0x0,
  	            0x1b8: 0x2100401,
  	            0x1c8: 0x100401,
  	            0x1d8: 0x400,
  	            0x1e8: 0x2000400,
  	            0x1f8: 0x100001
  	        },
  	        {
  	            0x0: 0x8000820,
  	            0x1: 0x20000,
  	            0x2: 0x8000000,
  	            0x3: 0x20,
  	            0x4: 0x20020,
  	            0x5: 0x8020820,
  	            0x6: 0x8020800,
  	            0x7: 0x800,
  	            0x8: 0x8020000,
  	            0x9: 0x8000800,
  	            0xa: 0x20800,
  	            0xb: 0x8020020,
  	            0xc: 0x820,
  	            0xd: 0x0,
  	            0xe: 0x8000020,
  	            0xf: 0x20820,
  	            0x80000000: 0x800,
  	            0x80000001: 0x8020820,
  	            0x80000002: 0x8000820,
  	            0x80000003: 0x8000000,
  	            0x80000004: 0x8020000,
  	            0x80000005: 0x20800,
  	            0x80000006: 0x20820,
  	            0x80000007: 0x20,
  	            0x80000008: 0x8000020,
  	            0x80000009: 0x820,
  	            0x8000000a: 0x20020,
  	            0x8000000b: 0x8020800,
  	            0x8000000c: 0x0,
  	            0x8000000d: 0x8020020,
  	            0x8000000e: 0x8000800,
  	            0x8000000f: 0x20000,
  	            0x10: 0x20820,
  	            0x11: 0x8020800,
  	            0x12: 0x20,
  	            0x13: 0x800,
  	            0x14: 0x8000800,
  	            0x15: 0x8000020,
  	            0x16: 0x8020020,
  	            0x17: 0x20000,
  	            0x18: 0x0,
  	            0x19: 0x20020,
  	            0x1a: 0x8020000,
  	            0x1b: 0x8000820,
  	            0x1c: 0x8020820,
  	            0x1d: 0x20800,
  	            0x1e: 0x820,
  	            0x1f: 0x8000000,
  	            0x80000010: 0x20000,
  	            0x80000011: 0x800,
  	            0x80000012: 0x8020020,
  	            0x80000013: 0x20820,
  	            0x80000014: 0x20,
  	            0x80000015: 0x8020000,
  	            0x80000016: 0x8000000,
  	            0x80000017: 0x8000820,
  	            0x80000018: 0x8020820,
  	            0x80000019: 0x8000020,
  	            0x8000001a: 0x8000800,
  	            0x8000001b: 0x0,
  	            0x8000001c: 0x20800,
  	            0x8000001d: 0x820,
  	            0x8000001e: 0x20020,
  	            0x8000001f: 0x8020800
  	        }
  	    ];
  	    var SBOX_MASK = [
  	        0xf8000001, 0x1f800000, 0x01f80000, 0x001f8000,
  	        0x0001f800, 0x00001f80, 0x000001f8, 0x8000001f
  	    ];
  	    var DES = C_algo.DES = BlockCipher.extend({
  	        _doReset: function () {
  	            var key = this._key;
  	            var keyWords = key.words;
  	            var keyBits = [];
  	            for (var i = 0; i < 56; i++) {
  	                var keyBitPos = PC1[i] - 1;
  	                keyBits[i] = (keyWords[keyBitPos >>> 5] >>> (31 - keyBitPos % 32)) & 1;
  	            }
  	            var subKeys = this._subKeys = [];
  	            for (var nSubKey = 0; nSubKey < 16; nSubKey++) {
  	                var subKey = subKeys[nSubKey] = [];
  	                var bitShift = BIT_SHIFTS[nSubKey];
  	                for (var i = 0; i < 24; i++) {
  	                    subKey[(i / 6) | 0] |= keyBits[((PC2[i] - 1) + bitShift) % 28] << (31 - i % 6);
  	                    subKey[4 + ((i / 6) | 0)] |= keyBits[28 + (((PC2[i + 24] - 1) + bitShift) % 28)] << (31 - i % 6);
  	                }
  	                subKey[0] = (subKey[0] << 1) | (subKey[0] >>> 31);
  	                for (var i = 1; i < 7; i++) {
  	                    subKey[i] = subKey[i] >>> ((i - 1) * 4 + 3);
  	                }
  	                subKey[7] = (subKey[7] << 5) | (subKey[7] >>> 27);
  	            }
  	            var invSubKeys = this._invSubKeys = [];
  	            for (var i = 0; i < 16; i++) {
  	                invSubKeys[i] = subKeys[15 - i];
  	            }
  	        },
  	        encryptBlock: function (M, offset) {
  	            this._doCryptBlock(M, offset, this._subKeys);
  	        },
  	        decryptBlock: function (M, offset) {
  	            this._doCryptBlock(M, offset, this._invSubKeys);
  	        },
  	        _doCryptBlock: function (M, offset, subKeys) {
  	            this._lBlock = M[offset];
  	            this._rBlock = M[offset + 1];
  	            exchangeLR.call(this, 4,  0x0f0f0f0f);
  	            exchangeLR.call(this, 16, 0x0000ffff);
  	            exchangeRL.call(this, 2,  0x33333333);
  	            exchangeRL.call(this, 8,  0x00ff00ff);
  	            exchangeLR.call(this, 1,  0x55555555);
  	            for (var round = 0; round < 16; round++) {
  	                var subKey = subKeys[round];
  	                var lBlock = this._lBlock;
  	                var rBlock = this._rBlock;
  	                var f = 0;
  	                for (var i = 0; i < 8; i++) {
  	                    f |= SBOX_P[i][((rBlock ^ subKey[i]) & SBOX_MASK[i]) >>> 0];
  	                }
  	                this._lBlock = rBlock;
  	                this._rBlock = lBlock ^ f;
  	            }
  	            var t = this._lBlock;
  	            this._lBlock = this._rBlock;
  	            this._rBlock = t;
  	            exchangeLR.call(this, 1,  0x55555555);
  	            exchangeRL.call(this, 8,  0x00ff00ff);
  	            exchangeRL.call(this, 2,  0x33333333);
  	            exchangeLR.call(this, 16, 0x0000ffff);
  	            exchangeLR.call(this, 4,  0x0f0f0f0f);
  	            M[offset] = this._lBlock;
  	            M[offset + 1] = this._rBlock;
  	        },
  	        keySize: 64/32,
  	        ivSize: 64/32,
  	        blockSize: 64/32
  	    });
  	    function exchangeLR(offset, mask) {
  	        var t = ((this._lBlock >>> offset) ^ this._rBlock) & mask;
  	        this._rBlock ^= t;
  	        this._lBlock ^= t << offset;
  	    }
  	    function exchangeRL(offset, mask) {
  	        var t = ((this._rBlock >>> offset) ^ this._lBlock) & mask;
  	        this._lBlock ^= t;
  	        this._rBlock ^= t << offset;
  	    }
  	    C.DES = BlockCipher._createHelper(DES);
  	    var TripleDES = C_algo.TripleDES = BlockCipher.extend({
  	        _doReset: function () {
  	            var key = this._key;
  	            var keyWords = key.words;
  	            if (keyWords.length !== 2 && keyWords.length !== 4 && keyWords.length < 6) {
  	                throw new Error('Invalid key length - 3DES requires the key length to be 64, 128, 192 or >192.');
  	            }
  	            var key1 = keyWords.slice(0, 2);
  	            var key2 = keyWords.length < 4 ? keyWords.slice(0, 2) : keyWords.slice(2, 4);
  	            var key3 = keyWords.length < 6 ? keyWords.slice(0, 2) : keyWords.slice(4, 6);
  	            this._des1 = DES.createEncryptor(WordArray.create(key1));
  	            this._des2 = DES.createEncryptor(WordArray.create(key2));
  	            this._des3 = DES.createEncryptor(WordArray.create(key3));
  	        },
  	        encryptBlock: function (M, offset) {
  	            this._des1.encryptBlock(M, offset);
  	            this._des2.decryptBlock(M, offset);
  	            this._des3.encryptBlock(M, offset);
  	        },
  	        decryptBlock: function (M, offset) {
  	            this._des3.decryptBlock(M, offset);
  	            this._des2.encryptBlock(M, offset);
  	            this._des1.decryptBlock(M, offset);
  	        },
  	        keySize: 192/32,
  	        ivSize: 64/32,
  	        blockSize: 64/32
  	    });
  	    C.TripleDES = BlockCipher._createHelper(TripleDES);
  	}());
  	return CryptoJS.TripleDES;
  }));
  });

  var rc4 = createCommonjsModule(function (module, exports) {
  (function (root, factory, undef) {
  	{
  		module.exports = exports = factory(core, encBase64, md5, evpkdf, cipherCore);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	(function () {
  	    var C = CryptoJS;
  	    var C_lib = C.lib;
  	    var StreamCipher = C_lib.StreamCipher;
  	    var C_algo = C.algo;
  	    var RC4 = C_algo.RC4 = StreamCipher.extend({
  	        _doReset: function () {
  	            var key = this._key;
  	            var keyWords = key.words;
  	            var keySigBytes = key.sigBytes;
  	            var S = this._S = [];
  	            for (var i = 0; i < 256; i++) {
  	                S[i] = i;
  	            }
  	            for (var i = 0, j = 0; i < 256; i++) {
  	                var keyByteIndex = i % keySigBytes;
  	                var keyByte = (keyWords[keyByteIndex >>> 2] >>> (24 - (keyByteIndex % 4) * 8)) & 0xff;
  	                j = (j + S[i] + keyByte) % 256;
  	                var t = S[i];
  	                S[i] = S[j];
  	                S[j] = t;
  	            }
  	            this._i = this._j = 0;
  	        },
  	        _doProcessBlock: function (M, offset) {
  	            M[offset] ^= generateKeystreamWord.call(this);
  	        },
  	        keySize: 256/32,
  	        ivSize: 0
  	    });
  	    function generateKeystreamWord() {
  	        var S = this._S;
  	        var i = this._i;
  	        var j = this._j;
  	        var keystreamWord = 0;
  	        for (var n = 0; n < 4; n++) {
  	            i = (i + 1) % 256;
  	            j = (j + S[i]) % 256;
  	            var t = S[i];
  	            S[i] = S[j];
  	            S[j] = t;
  	            keystreamWord |= S[(S[i] + S[j]) % 256] << (24 - n * 8);
  	        }
  	        this._i = i;
  	        this._j = j;
  	        return keystreamWord;
  	    }
  	    C.RC4 = StreamCipher._createHelper(RC4);
  	    var RC4Drop = C_algo.RC4Drop = RC4.extend({
  	        cfg: RC4.cfg.extend({
  	            drop: 192
  	        }),
  	        _doReset: function () {
  	            RC4._doReset.call(this);
  	            for (var i = this.cfg.drop; i > 0; i--) {
  	                generateKeystreamWord.call(this);
  	            }
  	        }
  	    });
  	    C.RC4Drop = StreamCipher._createHelper(RC4Drop);
  	}());
  	return CryptoJS.RC4;
  }));
  });

  var rabbit = createCommonjsModule(function (module, exports) {
  (function (root, factory, undef) {
  	{
  		module.exports = exports = factory(core, encBase64, md5, evpkdf, cipherCore);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	(function () {
  	    var C = CryptoJS;
  	    var C_lib = C.lib;
  	    var StreamCipher = C_lib.StreamCipher;
  	    var C_algo = C.algo;
  	    var S  = [];
  	    var C_ = [];
  	    var G  = [];
  	    var Rabbit = C_algo.Rabbit = StreamCipher.extend({
  	        _doReset: function () {
  	            var K = this._key.words;
  	            var iv = this.cfg.iv;
  	            for (var i = 0; i < 4; i++) {
  	                K[i] = (((K[i] << 8)  | (K[i] >>> 24)) & 0x00ff00ff) |
  	                       (((K[i] << 24) | (K[i] >>> 8))  & 0xff00ff00);
  	            }
  	            var X = this._X = [
  	                K[0], (K[3] << 16) | (K[2] >>> 16),
  	                K[1], (K[0] << 16) | (K[3] >>> 16),
  	                K[2], (K[1] << 16) | (K[0] >>> 16),
  	                K[3], (K[2] << 16) | (K[1] >>> 16)
  	            ];
  	            var C = this._C = [
  	                (K[2] << 16) | (K[2] >>> 16), (K[0] & 0xffff0000) | (K[1] & 0x0000ffff),
  	                (K[3] << 16) | (K[3] >>> 16), (K[1] & 0xffff0000) | (K[2] & 0x0000ffff),
  	                (K[0] << 16) | (K[0] >>> 16), (K[2] & 0xffff0000) | (K[3] & 0x0000ffff),
  	                (K[1] << 16) | (K[1] >>> 16), (K[3] & 0xffff0000) | (K[0] & 0x0000ffff)
  	            ];
  	            this._b = 0;
  	            for (var i = 0; i < 4; i++) {
  	                nextState.call(this);
  	            }
  	            for (var i = 0; i < 8; i++) {
  	                C[i] ^= X[(i + 4) & 7];
  	            }
  	            if (iv) {
  	                var IV = iv.words;
  	                var IV_0 = IV[0];
  	                var IV_1 = IV[1];
  	                var i0 = (((IV_0 << 8) | (IV_0 >>> 24)) & 0x00ff00ff) | (((IV_0 << 24) | (IV_0 >>> 8)) & 0xff00ff00);
  	                var i2 = (((IV_1 << 8) | (IV_1 >>> 24)) & 0x00ff00ff) | (((IV_1 << 24) | (IV_1 >>> 8)) & 0xff00ff00);
  	                var i1 = (i0 >>> 16) | (i2 & 0xffff0000);
  	                var i3 = (i2 << 16)  | (i0 & 0x0000ffff);
  	                C[0] ^= i0;
  	                C[1] ^= i1;
  	                C[2] ^= i2;
  	                C[3] ^= i3;
  	                C[4] ^= i0;
  	                C[5] ^= i1;
  	                C[6] ^= i2;
  	                C[7] ^= i3;
  	                for (var i = 0; i < 4; i++) {
  	                    nextState.call(this);
  	                }
  	            }
  	        },
  	        _doProcessBlock: function (M, offset) {
  	            var X = this._X;
  	            nextState.call(this);
  	            S[0] = X[0] ^ (X[5] >>> 16) ^ (X[3] << 16);
  	            S[1] = X[2] ^ (X[7] >>> 16) ^ (X[5] << 16);
  	            S[2] = X[4] ^ (X[1] >>> 16) ^ (X[7] << 16);
  	            S[3] = X[6] ^ (X[3] >>> 16) ^ (X[1] << 16);
  	            for (var i = 0; i < 4; i++) {
  	                S[i] = (((S[i] << 8)  | (S[i] >>> 24)) & 0x00ff00ff) |
  	                       (((S[i] << 24) | (S[i] >>> 8))  & 0xff00ff00);
  	                M[offset + i] ^= S[i];
  	            }
  	        },
  	        blockSize: 128/32,
  	        ivSize: 64/32
  	    });
  	    function nextState() {
  	        var X = this._X;
  	        var C = this._C;
  	        for (var i = 0; i < 8; i++) {
  	            C_[i] = C[i];
  	        }
  	        C[0] = (C[0] + 0x4d34d34d + this._b) | 0;
  	        C[1] = (C[1] + 0xd34d34d3 + ((C[0] >>> 0) < (C_[0] >>> 0) ? 1 : 0)) | 0;
  	        C[2] = (C[2] + 0x34d34d34 + ((C[1] >>> 0) < (C_[1] >>> 0) ? 1 : 0)) | 0;
  	        C[3] = (C[3] + 0x4d34d34d + ((C[2] >>> 0) < (C_[2] >>> 0) ? 1 : 0)) | 0;
  	        C[4] = (C[4] + 0xd34d34d3 + ((C[3] >>> 0) < (C_[3] >>> 0) ? 1 : 0)) | 0;
  	        C[5] = (C[5] + 0x34d34d34 + ((C[4] >>> 0) < (C_[4] >>> 0) ? 1 : 0)) | 0;
  	        C[6] = (C[6] + 0x4d34d34d + ((C[5] >>> 0) < (C_[5] >>> 0) ? 1 : 0)) | 0;
  	        C[7] = (C[7] + 0xd34d34d3 + ((C[6] >>> 0) < (C_[6] >>> 0) ? 1 : 0)) | 0;
  	        this._b = (C[7] >>> 0) < (C_[7] >>> 0) ? 1 : 0;
  	        for (var i = 0; i < 8; i++) {
  	            var gx = X[i] + C[i];
  	            var ga = gx & 0xffff;
  	            var gb = gx >>> 16;
  	            var gh = ((((ga * ga) >>> 17) + ga * gb) >>> 15) + gb * gb;
  	            var gl = (((gx & 0xffff0000) * gx) | 0) + (((gx & 0x0000ffff) * gx) | 0);
  	            G[i] = gh ^ gl;
  	        }
  	        X[0] = (G[0] + ((G[7] << 16) | (G[7] >>> 16)) + ((G[6] << 16) | (G[6] >>> 16))) | 0;
  	        X[1] = (G[1] + ((G[0] << 8)  | (G[0] >>> 24)) + G[7]) | 0;
  	        X[2] = (G[2] + ((G[1] << 16) | (G[1] >>> 16)) + ((G[0] << 16) | (G[0] >>> 16))) | 0;
  	        X[3] = (G[3] + ((G[2] << 8)  | (G[2] >>> 24)) + G[1]) | 0;
  	        X[4] = (G[4] + ((G[3] << 16) | (G[3] >>> 16)) + ((G[2] << 16) | (G[2] >>> 16))) | 0;
  	        X[5] = (G[5] + ((G[4] << 8)  | (G[4] >>> 24)) + G[3]) | 0;
  	        X[6] = (G[6] + ((G[5] << 16) | (G[5] >>> 16)) + ((G[4] << 16) | (G[4] >>> 16))) | 0;
  	        X[7] = (G[7] + ((G[6] << 8)  | (G[6] >>> 24)) + G[5]) | 0;
  	    }
  	    C.Rabbit = StreamCipher._createHelper(Rabbit);
  	}());
  	return CryptoJS.Rabbit;
  }));
  });

  var rabbitLegacy = createCommonjsModule(function (module, exports) {
  (function (root, factory, undef) {
  	{
  		module.exports = exports = factory(core, encBase64, md5, evpkdf, cipherCore);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	(function () {
  	    var C = CryptoJS;
  	    var C_lib = C.lib;
  	    var StreamCipher = C_lib.StreamCipher;
  	    var C_algo = C.algo;
  	    var S  = [];
  	    var C_ = [];
  	    var G  = [];
  	    var RabbitLegacy = C_algo.RabbitLegacy = StreamCipher.extend({
  	        _doReset: function () {
  	            var K = this._key.words;
  	            var iv = this.cfg.iv;
  	            var X = this._X = [
  	                K[0], (K[3] << 16) | (K[2] >>> 16),
  	                K[1], (K[0] << 16) | (K[3] >>> 16),
  	                K[2], (K[1] << 16) | (K[0] >>> 16),
  	                K[3], (K[2] << 16) | (K[1] >>> 16)
  	            ];
  	            var C = this._C = [
  	                (K[2] << 16) | (K[2] >>> 16), (K[0] & 0xffff0000) | (K[1] & 0x0000ffff),
  	                (K[3] << 16) | (K[3] >>> 16), (K[1] & 0xffff0000) | (K[2] & 0x0000ffff),
  	                (K[0] << 16) | (K[0] >>> 16), (K[2] & 0xffff0000) | (K[3] & 0x0000ffff),
  	                (K[1] << 16) | (K[1] >>> 16), (K[3] & 0xffff0000) | (K[0] & 0x0000ffff)
  	            ];
  	            this._b = 0;
  	            for (var i = 0; i < 4; i++) {
  	                nextState.call(this);
  	            }
  	            for (var i = 0; i < 8; i++) {
  	                C[i] ^= X[(i + 4) & 7];
  	            }
  	            if (iv) {
  	                var IV = iv.words;
  	                var IV_0 = IV[0];
  	                var IV_1 = IV[1];
  	                var i0 = (((IV_0 << 8) | (IV_0 >>> 24)) & 0x00ff00ff) | (((IV_0 << 24) | (IV_0 >>> 8)) & 0xff00ff00);
  	                var i2 = (((IV_1 << 8) | (IV_1 >>> 24)) & 0x00ff00ff) | (((IV_1 << 24) | (IV_1 >>> 8)) & 0xff00ff00);
  	                var i1 = (i0 >>> 16) | (i2 & 0xffff0000);
  	                var i3 = (i2 << 16)  | (i0 & 0x0000ffff);
  	                C[0] ^= i0;
  	                C[1] ^= i1;
  	                C[2] ^= i2;
  	                C[3] ^= i3;
  	                C[4] ^= i0;
  	                C[5] ^= i1;
  	                C[6] ^= i2;
  	                C[7] ^= i3;
  	                for (var i = 0; i < 4; i++) {
  	                    nextState.call(this);
  	                }
  	            }
  	        },
  	        _doProcessBlock: function (M, offset) {
  	            var X = this._X;
  	            nextState.call(this);
  	            S[0] = X[0] ^ (X[5] >>> 16) ^ (X[3] << 16);
  	            S[1] = X[2] ^ (X[7] >>> 16) ^ (X[5] << 16);
  	            S[2] = X[4] ^ (X[1] >>> 16) ^ (X[7] << 16);
  	            S[3] = X[6] ^ (X[3] >>> 16) ^ (X[1] << 16);
  	            for (var i = 0; i < 4; i++) {
  	                S[i] = (((S[i] << 8)  | (S[i] >>> 24)) & 0x00ff00ff) |
  	                       (((S[i] << 24) | (S[i] >>> 8))  & 0xff00ff00);
  	                M[offset + i] ^= S[i];
  	            }
  	        },
  	        blockSize: 128/32,
  	        ivSize: 64/32
  	    });
  	    function nextState() {
  	        var X = this._X;
  	        var C = this._C;
  	        for (var i = 0; i < 8; i++) {
  	            C_[i] = C[i];
  	        }
  	        C[0] = (C[0] + 0x4d34d34d + this._b) | 0;
  	        C[1] = (C[1] + 0xd34d34d3 + ((C[0] >>> 0) < (C_[0] >>> 0) ? 1 : 0)) | 0;
  	        C[2] = (C[2] + 0x34d34d34 + ((C[1] >>> 0) < (C_[1] >>> 0) ? 1 : 0)) | 0;
  	        C[3] = (C[3] + 0x4d34d34d + ((C[2] >>> 0) < (C_[2] >>> 0) ? 1 : 0)) | 0;
  	        C[4] = (C[4] + 0xd34d34d3 + ((C[3] >>> 0) < (C_[3] >>> 0) ? 1 : 0)) | 0;
  	        C[5] = (C[5] + 0x34d34d34 + ((C[4] >>> 0) < (C_[4] >>> 0) ? 1 : 0)) | 0;
  	        C[6] = (C[6] + 0x4d34d34d + ((C[5] >>> 0) < (C_[5] >>> 0) ? 1 : 0)) | 0;
  	        C[7] = (C[7] + 0xd34d34d3 + ((C[6] >>> 0) < (C_[6] >>> 0) ? 1 : 0)) | 0;
  	        this._b = (C[7] >>> 0) < (C_[7] >>> 0) ? 1 : 0;
  	        for (var i = 0; i < 8; i++) {
  	            var gx = X[i] + C[i];
  	            var ga = gx & 0xffff;
  	            var gb = gx >>> 16;
  	            var gh = ((((ga * ga) >>> 17) + ga * gb) >>> 15) + gb * gb;
  	            var gl = (((gx & 0xffff0000) * gx) | 0) + (((gx & 0x0000ffff) * gx) | 0);
  	            G[i] = gh ^ gl;
  	        }
  	        X[0] = (G[0] + ((G[7] << 16) | (G[7] >>> 16)) + ((G[6] << 16) | (G[6] >>> 16))) | 0;
  	        X[1] = (G[1] + ((G[0] << 8)  | (G[0] >>> 24)) + G[7]) | 0;
  	        X[2] = (G[2] + ((G[1] << 16) | (G[1] >>> 16)) + ((G[0] << 16) | (G[0] >>> 16))) | 0;
  	        X[3] = (G[3] + ((G[2] << 8)  | (G[2] >>> 24)) + G[1]) | 0;
  	        X[4] = (G[4] + ((G[3] << 16) | (G[3] >>> 16)) + ((G[2] << 16) | (G[2] >>> 16))) | 0;
  	        X[5] = (G[5] + ((G[4] << 8)  | (G[4] >>> 24)) + G[3]) | 0;
  	        X[6] = (G[6] + ((G[5] << 16) | (G[5] >>> 16)) + ((G[4] << 16) | (G[4] >>> 16))) | 0;
  	        X[7] = (G[7] + ((G[6] << 8)  | (G[6] >>> 24)) + G[5]) | 0;
  	    }
  	    C.RabbitLegacy = StreamCipher._createHelper(RabbitLegacy);
  	}());
  	return CryptoJS.RabbitLegacy;
  }));
  });

  var cryptoJs = createCommonjsModule(function (module, exports) {
  (function (root, factory, undef) {
  	{
  		module.exports = exports = factory(core, x64Core, libTypedarrays, encUtf16, encBase64, encBase64url, md5, sha1, sha256, sha224, sha512, sha384, sha3, ripemd160, hmac, pbkdf2, evpkdf, cipherCore, modeCfb, modeCtr, modeCtrGladman, modeOfb, modeEcb, padAnsix923, padIso10126, padIso97971, padZeropadding, padNopadding, formatHex, aes, tripledes, rc4, rabbit, rabbitLegacy);
  	}
  }(commonjsGlobal, function (CryptoJS) {
  	return CryptoJS;
  }));
  });

  var REQUEST_METHOD_GET = 'GET';
  var REQUEST_METHOD_POST = 'POST';
  var REQUEST_METHOD_OPTIONS = 'OPTIONS';
  var REQUEST_METHOD_DELETE = 'DELETE';
  var ALL_METHODS = ['get', 'post', 'delete', 'options', 'head', 'put', 'connect', 'trace', 'patch', 'move', 'copy', 'link', 'unlink', 'wrapped'];
  var CONTENT_TYPES = {
    JSON: 'application/json; charset=UTF-8',
    FORM_URL: 'application/x-www-form-urlencoded',
    XML: 'text/xml',
    FORM_DATA: 'multipart/form-data',
    TEXT: 'text/plain',
    HTML: 'text/html',
    STREAM: 'application/octet-stream'
  };
  var EVENT_ERROR = 'error';
  var EVENT_WILL_REQUEST = 'willRequest';
  var EVENT_PARSE_OPTION = 'parseOption';
  var EVENT_REQUESTED = 'requested';

  var _excluded = ["headers"];
  function mergeOption(options) {
    if (_typeof(options) !== 'object') {
      options = {};
    }
    var _options = options,
        headers = _options.headers,
        otherOptions = _objectWithoutProperties(_options, _excluded);
    var defaultOption = _objectSpread2({
      headers: _objectSpread2({}, headers),
      method: REQUEST_METHOD_GET
    }, otherOptions);
    var body = defaultOption.body,
        _defaultOption$method = defaultOption.method,
        method = _defaultOption$method === void 0 ? REQUEST_METHOD_GET : _defaultOption$method;
    if (typeof defaultOption.method !== 'string' || !ALL_METHODS.includes(defaultOption.method.toLowerCase())) {
      defaultOption.method = REQUEST_METHOD_GET;
    }
    if (window && window.FormData && body instanceof window.FormData) {
      delete defaultOption.headers['Content-Type'];
    } else if (typeof body === 'number') {
      defaultOption.body = "".concat(body);
    } else if (_typeof(body) === 'object') {
      if (method === REQUEST_METHOD_GET || method === REQUEST_METHOD_DELETE || defaultOption.headers['Content-Type'] === CONTENT_TYPES.FORM_URL) {
        defaultOption.body = json2param(body);
      } else if (defaultOption.headers['Content-Type'] === CONTENT_TYPES.JSON) {
        defaultOption.body = JSON.stringify(body);
      }
    }
    return defaultOption;
  }
  function dealUrl(url, options) {
    var _options$method = options.method,
        method = _options$method === void 0 ? REQUEST_METHOD_GET : _options$method,
        body = options.body;
    if ((method === REQUEST_METHOD_GET || method === REQUEST_METHOD_DELETE) && typeof body === 'string') {
      if (url.indexOf('?') < 0) {
        url += '?';
      } else if (url[url.length - 1] !== '&') {
        url += '&';
      }
      url += body;
      delete options.body;
    }
    return url;
  }
  function dealStatus(useOriginResponse) {
    return function (response) {
      if (useOriginResponse) {
        return Promise.resolve(response);
      }
      if (response.status === 200) {
        return response.text().then(function (txt) {
          return parseJson(txt);
        });
      } else {
        return Promise.reject(response);
      }
    };
  }
  function cacheResponse(md5, useCache, useOriginResponse) {
    return function (json) {
      if (useCache && !useOriginResponse) {
        _requestCache[md5] = json;
      }
      return json;
    };
  }
  var _fetchQueue = [];
  var _fetchQueueStarting = false;
  function _addFetchQueue(url, option, useCache) {
    return new Promise(function (resolve, reject) {
      _fetchQueue.push({
        url: url,
        option: option,
        successFun: resolve,
        failFun: reject,
        useCache: useCache
      });
      _startQueue();
    });
  }
  function _startQueue() {
    if (_fetchQueueStarting) {
      return;
    }
    _fetchQueueStarting = true;
    promiseAll(_fetchQueue, function (_ref) {
      var url = _ref.url,
          option = _ref.option,
          successFun = _ref.successFun,
          failFun = _ref.failFun,
          useCache = _ref.useCache;
      if (useCache && _requestCache[url]) {
        return Promise.resolve(_requestCache[url]);
      }
      return fetch$1(url, option).then(successFun)["catch"](failFun);
    })["finally"](function () {
      _fetchQueueStarting = false;
    });
  }
  var _requestCache = {};
  function request(url, options) {
    var useQueue = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    var useCache = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
    var useOriginResponse = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
    var lastOption = mergeOption(options);
    var lastUrl = dealUrl(url, lastOption);
    var sha256Str = "".concat(lastUrl, "_").concat(lastOption && lastOption.body && JSON.stringify(lastOption.body) || '');
    var cacheSha256 = cryptoJs.SHA256(sha256Str).toString(cryptoJs.enc.Base64);
    if (useQueue) {
      return _addFetchQueue(lastUrl, lastOption, useCache).then(dealStatus(useOriginResponse)).then(cacheResponse(cacheSha256, useCache, useOriginResponse));
    } else {
      if (useCache && _requestCache[cacheSha256]) {
        return Promise.resolve(_requestCache[cacheSha256]);
      }
      return fetch$1(lastUrl, lastOption).then(dealStatus(useOriginResponse)).then(cacheResponse(cacheSha256, useCache, useOriginResponse));
    }
  }
  function clearRequestCache() {
    _requestCache = {};
  }

  var Promise$1 = require('es6-promise').Promise;
  var FetchService = function () {
    function FetchService() {
      var op = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      _classCallCheck(this, FetchService);
      _defineProperty(this, "_eventer", new eventemitter3());
      _defineProperty(this, "_globalParseResponse", null);
      _defineProperty(this, "_tokenFun", null);
      _defineProperty(this, "_requestNeedToken", false);
      _defineProperty(this, "_requestHeaderTokenName", 'fetch-service-auth-token');
      _defineProperty(this, "_customParseResponse", void 0);
      this._globalParseResponse = op.parseResponse;
      this._tokenFun = op.tokenFun;
      if (op.customParseResponse) {
        this._customParseResponse = op.customParseResponse;
      }
      if (op.requestNeedToken) {
        this._requestNeedToken = true;
      }
      if (op.headers) {
        this._globalHeader = op.headers;
      }
      if (op.mode) {
        this._mode = op.mode;
      }
      if (op.credentials) {
        this._credentials = op.credentials;
      }
      if (op.tokenHeaderName) {
        this._requestHeaderTokenName = op.tokenHeaderName;
      }
    }
    _createClass(FetchService, [{
      key: "__parseResponse",
      value: function __parseResponse(apiOption, data) {
        var resolveData = data;
        if (isFunction(this._globalParseResponse)) {
          resolveData = this._globalParseResponse(resolveData, apiOption);
        }
        if (isFunction(apiOption.parseResponse)) {
          resolveData = apiOption.parseResponse(resolveData);
        }
        return resolveData;
      }
    }, {
      key: "__parseParam",
      value: function __parseParam(p, apiOption) {
        if (isFunction(apiOption.parseParam)) {
          return apiOption.parseParam(p);
        }
        return p;
      }
    }, {
      key: "__parseOption",
      value: function __parseOption(apiOption, param) {
        var _this = this;
        var _apiOption$headers = apiOption.headers,
            headers = _apiOption$headers === void 0 ? {} : _apiOption$headers,
            _apiOption$method = apiOption.method,
            method = _apiOption$method === void 0 ? REQUEST_METHOD_GET : _apiOption$method,
            _apiOption$mode = apiOption.mode,
            mode = _apiOption$mode === void 0 ? this._mode : _apiOption$mode,
            _apiOption$credential = apiOption.credentials,
            credentials = _apiOption$credential === void 0 ? this._credentials : _apiOption$credential;
        var _globalHeaders = this._globalHeader;
        var _localHeaders = headers;
        if (isFunction(this._globalHeader)) {
          _globalHeaders = this._globalHeader(param, apiOption);
        }
        if (isFunction(headers)) {
          _localHeaders = headers(param, apiOption);
        }
        var newHeaders = deepClone(Object.assign({}, _globalHeaders, _localHeaders));
        return function (p) {
          _this._eventer.emit(EVENT_PARSE_OPTION, apiOption, p, newHeaders);
          var ret = {
            body: p,
            headers: newHeaders,
            method: method
          };
          if (mode) {
            ret.mode = mode;
          }
          if (credentials) {
            ret.credentials = credentials;
          }
          return ret;
        };
      }
    }, {
      key: "__request",
      value: function __request(apiOption, p) {
        var _this2 = this;
        return function (op) {
          _this2._eventer.emit(EVENT_WILL_REQUEST, apiOption, op, p);
          var url = renderTemplate(apiOption.url, p);
          if (apiOption.debug && apiOption.mock) {
            var resolveData = apiOption.mock;
            if (isFunction(resolveData)) {
              resolveData = resolveData(p);
            }
            return timeoutPromise(function () {
              return resolveData;
            }, 1000);
          }
          var useOriginResponse = apiOption.useOriginResponse || !!_this2._customParseResponse;
          return request(url, op, apiOption.useQueue, apiOption.cache, useOriginResponse).then(function (res) {
            if (_this2._customParseResponse) {
              return _this2._customParseResponse(res, url, op, apiOption);
            }
            return res;
          });
        };
      }
    }, {
      key: "__response",
      value: function __response(apiOption) {
        var _this3 = this;
        return function (res) {
          return _this3.__parseResponse(apiOption, res);
        };
      }
    }, {
      key: "__handleError",
      value: function __handleError(apiOption) {
        var _this4 = this;
        return function (err) {
          return !apiOption.noErrorTip && _this4._eventer.emit(EVENT_ERROR, err, apiOption);
        };
      }
    }, {
      key: "__ensureToken",
      value: function __ensureToken(apiOption, p) {
        var _this5 = this;
        return function (op) {
          if (_this5._requestNeedToken && apiOption.requestNeedToken !== false && isFunction(_this5._tokenFun)) {
            return _this5._tokenFun(apiOption, p).then(function (token) {
              if (!op.headers) {
                op.headers = {};
              }
              op.headers[_this5._requestHeaderTokenName] = token;
              return op;
            });
          }
          return op;
        };
      }
    }, {
      key: "parseOption",
      value: function parseOption(apiOption) {
        var _this6 = this;
        return function (p) {
          var promise = Promise$1.resolve(_this6.__parseParam(p, apiOption))
          .then(_this6.__parseOption(apiOption, p))
          .then(_this6.__ensureToken(apiOption, p))
          .then(_this6.__request(apiOption, p))
          .then(_this6.__response(apiOption));
          promise["catch"](_this6.__handleError(apiOption))
          ["finally"](function () {
            return _this6._eventer.emit(EVENT_REQUESTED, apiOption);
          });
          return promise;
        };
      }
    }, {
      key: "on",
      value: function on(eventName, fun) {
        if (isFunction(fun)) {
          this._eventer.on(eventName, fun);
        }
      }
    }, {
      key: "off",
      value: function off(eventName, fun) {
        this._eventer.off(eventName, fun);
      }
    }]);
    return FetchService;
  }();

  var _service = new FetchService();
  var parseRequest = _service.parseOption;
  var on = _service.on;
  var off = _service.off;

  var services = /*#__PURE__*/Object.freeze({
    __proto__: null,
    parseRequest: parseRequest,
    on: on,
    off: off
  });

  var StorageRequestEnsureToken = function () {
    function StorageRequestEnsureToken() {
      var op = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      _classCallCheck(this, StorageRequestEnsureToken);
      _defineProperty(this, "TOKEN_KEY", 'fetch-service-storage-token');
      _defineProperty(this, "TOKEN_KEY_TIMESTAMP", 'fetch-service-storage-token-timestamp');
      _defineProperty(this, "TIME_OVER_TIME", 1 * 60 * 60 * 1000);
      _defineProperty(this, "_initToking", false);
      _defineProperty(this, "_userSessionStorage", false);
      _defineProperty(this, "_initTokenPromise", []);
      _defineProperty(this, "_customGetToken", function () {
        return Promise.resolve();
      });
      if (!op.customGetToken) {
        throw 'need customGetToken function return Promise';
      }
      if (op.tokenKey) {
        this.TOKEN_KEY = op.tokenKey;
      }
      if (op.tokenTimestampKey) {
        this.TOKEN_KEY_TIMESTAMP = op.tokenTimestampKey;
      }
      if (op.timeout) {
        this.TIME_OVER_TIME = op.timeout;
      }
      if (op.session) {
        this._userSessionStorage = true;
      }
      this._customGetToken = op.customGetToken;
    }
    _createClass(StorageRequestEnsureToken, [{
      key: "setStorage",
      value: function setStorage(key, value) {
        if (this._userSessionStorage) {
          sessionStorage.setItem(key, value);
        } else {
          localStorage.setItem(key, value);
        }
      }
    }, {
      key: "getStorage",
      value: function getStorage(key) {
        if (this._userSessionStorage) {
          return sessionStorage.getItem(key);
        } else {
          return localStorage.getItem(key);
        }
      }
    }, {
      key: "removeStorage",
      value: function removeStorage(key) {
        if (this._userSessionStorage) {
          sessionStorage.removeItem(key);
        } else {
          localStorage.removeItem(key);
        }
      }
    }, {
      key: "__setToken",
      value: function __setToken(token) {
        if (token) {
          this.setStorage(this.TOKEN_KEY, token);
          this.setStorage(this.TOKEN_KEY_TIMESTAMP, "".concat(Date.now()));
        }
        return token;
      }
    }, {
      key: "clearToken",
      value: function clearToken() {
        this.removeStorage(this.TOKEN_KEY);
        this.removeStorage(this.TOKEN_KEY_TIMESTAMP);
      }
    }, {
      key: "__invokeTokingPromise",
      value: function __invokeTokingPromise(err, info) {
        var _iterator = _createForOfIteratorHelper(this._initTokenPromise),
            _step;
        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var p = _step.value;
            if (err) {
              p.reject(err);
            } else {
              p.resolve(info);
            }
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
        this._initTokenPromise = [];
        this._initToking = false;
      }
    }, {
      key: "getStorageToken",
      value: function getStorageToken() {
        var token = this.getStorage(this.TOKEN_KEY);
        var timestamp = this.getStorage(this.TOKEN_KEY_TIMESTAMP);
        if (!token) return null;
        if (!timestamp) return null;
        var time = Date.now() - timestamp;
        if (time >= 0 && time <= this.TIME_OVER_TIME) {
          return token;
        }
        return null;
      }
    }, {
      key: "getToken",
      value: function getToken() {
        var _this = this;
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }
        var token = this.getStorageToken();
        return new Promise(function (resolve, reject) {
          if (token) {
            resolve(token);
          } else {
            if (_this._initToking) {
              _this._initTokenPromise.push({
                resolve: resolve,
                reject: reject
              });
              return;
            }
            _this._initToking = true;
            _this._customGetToken.apply(_this, args).then(function (newToken) {
              _this.__setToken(newToken);
              resolve(newToken);
              _this.__invokeTokingPromise(null, newToken);
            })["catch"](function (err) {
              reject(err);
              _this.__invokeTokingPromise(err);
            });
          }
        });
      }
    }]);
    return StorageRequestEnsureToken;
  }();

  var RequestNeedTokenQueue = function () {
    function RequestNeedTokenQueue(ensureAuthFn, errorCatchFn) {
      _classCallCheck(this, RequestNeedTokenQueue);
      _defineProperty(this, "loginTestFetchingQueue", []);
      _defineProperty(this, "fetchingLoginTest", false);
      _defineProperty(this, "_ensureAuthFn", function () {
        return Promise.reject();
      });
      _defineProperty(this, "_errorCatchFn", function () {});
      this._ensureAuthFn = ensureAuthFn;
      this._errorCatchFn = errorCatchFn;
    }
    _createClass(RequestNeedTokenQueue, [{
      key: "goonNext",
      value: function goonNext() {
        var onePromise = this.loginTestFetchingQueue.shift();
        if (onePromise) {
          onePromise.resolve();
          this.goonNext();
        } else {
          this.fetchingLoginTest = false;
        }
      }
    }, {
      key: "startLoginTest",
      value: function startLoginTest() {
        var _this = this;
        if (this.fetchingLoginTest) {
          return;
        }
        this.fetchingLoginTest = true;
        this._ensureAuthFn().then(function (res) {
          _this.goonNext();
        })["catch"](function (err) {
          _this._errorCatchFn(err);
        });
      }
    }, {
      key: "ensure",
      value: function ensure() {
        var _this2 = this;
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }
        return new Promise(function (resolve, reject) {
          var onePromise = {
            resolve: resolve,
            reject: reject,
            args: args
          };
          _this2.loginTestFetchingQueue.push(onePromise);
          _this2.startLoginTest();
        });
      }
    }]);
    return RequestNeedTokenQueue;
  }();

  exports.CONTENT_TYPES = CONTENT_TYPES;
  exports.EVENT_ERROR = EVENT_ERROR;
  exports.EVENT_PARSE_OPTION = EVENT_PARSE_OPTION;
  exports.EVENT_REQUESTED = EVENT_REQUESTED;
  exports.EVENT_WILL_REQUEST = EVENT_WILL_REQUEST;
  exports.FetchService = FetchService;
  exports.REQUEST_METHOD_DELETE = REQUEST_METHOD_DELETE;
  exports.REQUEST_METHOD_GET = REQUEST_METHOD_GET;
  exports.REQUEST_METHOD_OPTIONS = REQUEST_METHOD_OPTIONS;
  exports.REQUEST_METHOD_POST = REQUEST_METHOD_POST;
  exports.RequestNeedTokenQueue = RequestNeedTokenQueue;
  exports.StorageRequestEnsureToken = StorageRequestEnsureToken;
  exports.clearRequestCache = clearRequestCache;
  exports.request = request;
  exports.services = services;
  exports.util = util;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
